<?PHP
/*******************************************************************
 *  cmsWorks - api lib                                             *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.6.3                                                *
 *	Modified: 2005-10-18 18:50                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/
 
function API_LoadFile($file)
{
	if(is_file($file))
	{
		$fp = fopen($file, "r");
		while (!feof ($fp)) 
		{
	   		$buffer .= fgets($fp, 4096);
		}
		fclose ($fp);
	}
	
	return $buffer;	
}

function API_GetTemplate($file, $custom = "no")
{
	global $ADMIN_TEMPLATE;

	if($custom != "no" AND is_file("template/custom/".$file))
		$template = API_LoadFile("template/custom/".$file);
	if($custom == "no" AND is_file("template/".$ADMIN_TEMPLATE."/".$file))
		$template = API_LoadFile("template/".$ADMIN_TEMPLATE."/".$file);
	else if($custom == "no" AND is_file("../template/".$ADMIN_TEMPLATE."/".$file))
		$template = API_LoadFile("../template/".$ADMIN_TEMPLATE."/".$file);
	else if($custom == "no" AND is_file("../../template/".$ADMIN_TEMPLATE."/".$file))
		$template = API_LoadFile("../../template/".$ADMIN_TEMPLATE."/".$file);

	return $template;
}

function API_Window($width, $title, $body, $buttons, $help="", $top = "", $left = "")
{
	return API_WindowGen("custom", $width, $title, $body, $buttons, $help, $top, $left);
}

function API_WindowModule($width, $title, $body, $buttons, $help="",$id)
{
	return API_WindowGen("module", $width, $title, $body, $buttons, $help, "", "", $id);
}

function API_WindowGen($type, $width, $title, $body, $buttons, $help="", $top = "", $left = "", $id = "")
{
	global $ADMIN_TEMPLATE;
	
	// get the window template
	$template = API_GetTemplate("window.html");
	
	// id
	if(empty($id))
	{
		$id = microtime();
	}
	$template = str_replace("##ID##", $id, $template);
	
	// width
	$template = str_replace("##WIDTH##", $width, $template);
	
	// path
	$template = str_replace("##PATH##", "template/".$ADMIN_TEMPLATE, $template);
	
	// fint out whitch buttons to put on
	if(eregi(",", $buttons))
		$buttonsArray = explode(",", $buttons);
	else
		$buttonsArray[0] = $buttons;
	// put the buttons on
	for($x = 0; $x < count($buttonsArray); $x++)
	{
		switch($buttonsArray[$x])
		{
			case "CLOSE":
				if(is_file("template/".$ADMIN_TEMPLATE."/gfx/winClose.png"))
				{
					$imageInfo = getimagesize("template/".$ADMIN_TEMPLATE."/gfx/winClose.png");
					if($imageInfo[2] == 3)
						$image = "<div style=\"cursor: pointer; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='template/".$ADMIN_TEMPLATE."/gfx/winClose.png', sizingMethod='scale'); width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px;\" onClick='javascript:closeWin(\"".$id."\");'><img src=\"template/".$ADMIN_TEMPLATE."/gfx/winClose.png\" style=\"cursor: pointer; width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"\"></div>";
					else
						$image = "<img style='cursor: pointer;' src='template/".$ADMIN_TEMPLATE."/gfx/winClose.png' border='0' onClick='javascript:closeWin(\"".$id."\");'>";
				}
				break;
			case "MAXIMIZE":
				if(is_file("template/".$ADMIN_TEMPLATE."/gfx/winMaximize.png"))
				{
					$imageInfo = getimagesize("template/".$ADMIN_TEMPLATE."/gfx/winMaximize.png");
					if($imageInfo[2] == 3)
						$image = "<div style=\"cursor: pointer; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='template/".$ADMIN_TEMPLATE."/gfx/winMaximize.png', sizingMethod='scale'); width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px;\"><img src=\"template/".$ADMIN_TEMPLATE."/gfx/winMaximize.png\" style=\"cursor: pointer; width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"\"></div>";
					else
						$image = "<img style='cursor: pointer;' src='template/".$ADMIN_TEMPLATE."/gfx/winClose.png' border='0'>";
				}
				break;
			case "MINIMIZE":
				if(is_file("template/".$ADMIN_TEMPLATE."/gfx/winMinimize.png"))
				{
					$imageInfo = getimagesize("template/".$ADMIN_TEMPLATE."/gfx/winMinimize.png");
					if($imageInfo[2] == 3)
						$image = "<div style=\"cursor: pointer; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='template/".$ADMIN_TEMPLATE."/gfx/winMinimize.png', sizingMethod='scale'); width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px;\"><img src=\"template/".$ADMIN_TEMPLATE."/gfx/winMinimize.png\" style=\"cursor: pointer; width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"\"></div>";
					else
						$image = "<img style='cursor: pointer;' src='template/".$ADMIN_TEMPLATE."/gfx/winClose.png' border='0'>";
				}
				break;
			case "HELP":
				if(is_file("template/".$ADMIN_TEMPLATE."/gfx/winHelp.png"))
				{
					$imageInfo = getimagesize("template/".$ADMIN_TEMPLATE."/gfx/winHelp.png");
					if($imageInfo[2] == 3)
						$image = "<div style=\"cursor: pointer; filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='template/".$ADMIN_TEMPLATE."/gfx/winHelp.png', sizingMethod='scale'); width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px;\"><img src=\"template/".$ADMIN_TEMPLATE."/gfx/winHelp.png\" style=\"cursor: pointer; width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"\"></div>";
					else
						$image = "<img style='cursor: pointer;' src='template/".$ADMIN_TEMPLATE."/gfx/winClose.png' border='0'>";
				}
				break;
		}
		$template = str_replace("##".$buttonsArray[$x]."##", $image, $template);
	}
	// making a clean up
	$template = str_replace("##CLOSE##", "", $template);
	$template = str_replace("##MAXIMIZE##", "", $template);
	$template = str_replace("##MINIMIZE##", "", $template);
	$template = str_replace("##HELP##", "", $template);
	
	// the title
	$template = str_replace("##TITTLE##", $title, $template);
	
	// the boddy
	$template = str_replace("##BODY##", $body, $template);

	if($type == "custom")
	{
		if(empty($top))
			$top = 20;
		if(empty($left))
			$left = 200;
		
		$window  = "<div id='".$id."' style='position: absolute; left: ".$left."px; top: ".$top."px; width: ".$width."; z-index: 1000'>".$template."</div>";
	}
	else
		$window = $template;		
	
	return $window;
}

function API_JsWindowGen()
{
	global $ADMIN_TEMPLATE;
	
	// get the window template
	$template = API_GetTemplate("window.html");
	
	// path
	$template = str_replace("##PATH##", "template/".$ADMIN_TEMPLATE, $template);
	
	if(is_file("template/".$ADMIN_TEMPLATE."/gfx/winClose.png"))
	{
		$imageInfo = getimagesize("template/".$ADMIN_TEMPLATE."/gfx/winClose.png");
		if($imageInfo[2] == 3)
			$image = "<div style=\"filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='template/".$ADMIN_TEMPLATE."/gfx/winClose.png', sizingMethod='scale'); width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px;\" onClick='javascript:closeWin(\"##ID##\");'><img style='cursor: pointer;' src=\"template/".$ADMIN_TEMPLATE."/gfx/winClose.png\" style=\"width: ".$imageInfo[0]."px; height: ".$imageInfo[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"\"></div>";
		else
			$image = "<img src='template/".$ADMIN_TEMPLATE."/gfx/winClose.png' border='0' style='cursor: pointer;' onClick=\"javascript:closeWin('##ID##');\">";
	}
	$template = str_replace("##CLOSE##", $image, $template);
	
	// making a clean up
	$template = str_replace("##CLOSE##", "", $template);
	$template = str_replace("##MAXIMIZE##", "", $template);
	$template = str_replace("##MINIMIZE##", "", $template);
	$template = str_replace("##HELP##", "", $template);
	
	
	return str_replace("\"","\\\"", str_replace("\n", "", str_replace("\t","",$template)));
}
///////////////////

function API_Button($type = "", $text, $url)
{
	global $ADMIN_TEMPLATE, $ADMIN_HOSTPATH;

	// get the template for the button
	$template = API_GetTemplate("button.html");
	
	// translate and replace the text
	$template = str_replace("##TEXT##",lang($text),$template);
	// replace the path
	$template = str_replace("##PATH##", $ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE, $template);
	// replaces the url
	$template = str_replace("##URL##",$url,$template);
	
	// try to find the image and put it ind
	if(empty($type))
		$image = "";
	else
	{
		switch($type)
		{
			case "OK":
				if(is_file($ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/ok.icon.png"))
					$image = $ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/ok.icon.png";
				break;
			case "CANCEL":
				if(is_file($ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/cancel.icon.png"))
					$image = $ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/cancel.icon.png";
				break;
			case "DELETE":
				if(is_file($ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/delete.icon.png"))
					$image = $ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/delete.icon.png";
				break;
			case "SEARCH":
				if(is_file($ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/search.icon.png"))
					$image = $ADMIN_HOSTPATH."/template/".$ADMIN_TEMPLATE."/icons/16x16/search.icon.png";
				break;
			default:
				if(is_file($ADMIN_HOSTPATH."/themes/".$ADMIN_TEMPLATE."/icons/16x16/".$type))
					$image = $ADMIN_HOSTPATH."/themes/".$ADMIN_TEMPLATE."/icons/16x16/".$type; 
				break;
		}
	}
	$template = str_replace("##IMAGE##", $image, $template);
		
	return $template;
}

function API_topbar()
{
	global $db, $ADMIN_TEMPLATE, $ADMIN_NAME, $SITE_NAME;
	
	// stylesheat for the bar
	$bar .= "	<link rel='stylesheet' href='template/".$ADMIN_TEMPLATE."/style/topbar.css' type='text/css'>\n";
	
	$bar .= "	<table cellpaddin='2' cellspacing='3' border='0' width='100%' class='barBody'>\n";
	$bar .= "		<tr>\n";
	$bar .= "			<td>\n";
	// the menu system
	$bar .= "<table cellpadding='0' cellspacing='0' class='bar'>\n";
	$bar .= "	<tr>\n";

	$sql  = "SELECT";
	$sql .= " admin_menu_bar.ID,";
	$sql .= " admin_menu_bar.Name ";
	$sql .= "FROM";
	$sql .= "	admin_menu_bar,";
	$sql .= " admin_menu_bar_modules,";
	$sql .= " admin_modules ";
	if($_SESSION[$ADMIN_NAME]["user"]["type"] != "DEVELOPER")
		$sql .= ", admin_user_modules ";
	$sql .= "WHERE";
	$sql .= " admin_menu_bar.ID = admin_menu_bar_modules.MenuBarID ";
	$sql .= " AND admin_menu_bar_modules.ModuleID = admin_modules.ID ";
	if($_SESSION[$ADMIN_NAME]["user"]["type"] != "DEVELOPER")
	{
		$sql .= " AND admin_menu_bar_modules.ModuleID = admin_user_modules.ModuleID";
		$sql .= " AND (admin_user_modules.UserID = '".$_SESSION[$ADMIN_NAME]["user"]["id"]."' ";
		if($_SESSION[$ADMIN_NAME]["user"]["type"] == "ADMIN")
			$sql .= "       OR admin_menu_bar.ID = '4'";
		$sql .= ")	AND admin_modules.InUse = 'yes' ";
		$sql .= " AND admin_modules.Developer = 'no' ";
	}
	$sql .= "GROUP BY admin_menu_bar.ID ";
	$sql .= "ORDER BY admin_menu_bar.IndexNo";
	$rs_menu = mysql_query($sql, $db);
	echo mysql_error();
	$barMenuArray = array();
	while($row_menu = mysql_fetch_row($rs_menu))
	{
		// make new menu
		$barWidth = (strlen(lang($row_menu[1])))*11;
		$bar .= "		<td width='".$barWidth."' align='center' style='cursor: pointer;' onMouseOver=\"javascript:style.backgroundColor='#c4c4c4'\" onMouseOut=\"javascript:style.backgroundColor='transparent'\" onClick='javascript:do_menu_togle(\"menu-".$row_menu[0]."\");'>".lang($row_menu[1])."</td>\n";

		$menut["width"] = $barWidth;
		$menut["id"] = $row_menu[0];
		array_push($barMenuArray, $menut);		
	}
	$barWidth = (strlen(lang("Help")))*11;
	$bar .= "		<td width='".$barWidth."px' align='center' style='cursor: pointer;' onMouseOver=\"javascript:style.backgroundColor='#c4c4c4'\" onMouseOut=\"javascript:style.backgroundColor='transparent'\" onClick='javascript:do_menu_togle(\"menu-help\");'>".lang("Help")."</td>\n";
	$bar .= "	</tr>\n";
	$bar .= "</table>\n";

	// we have to add 3 px to the first menus width because af the table cellpadding
	$barMenuArray[0]["width"] += 3;

	$menuPos = 0;
	for($x = 0; $x < count($barMenuArray); $x++)
	{
		$menuWidth = 0;
		$sql  = "SELECT";
		$sql .= " admin_menu_bar_modules.MenuBarID,";
		$sql .= " admin_menu_bar_modules.Type,";
		$sql .= " admin_menu_bar_modules.Icon,";
		$sql .= " admin_modules.Name,";
		$sql .= " admin_modules.Link,";
		$sql .= " admin_modules.Width,";
		$sql .= " admin_modules.Height,";
		$sql .= " admin_menu_bar_modules.Line ";
		$sql .= "FROM";
		$sql .= " admin_menu_bar_modules,";
		$sql .= " admin_modules ";
		if($_SESSION[$ADMIN_NAME]["user"]["type"] != "DEVELOPER")
			$sql .= ", admin_user_modules ";			
		if($_SESSION[$ADMIN_NAME]["user"]["type"] == "ADMIN")
			$sql .= ", admin_menu_bar ";
		$sql .= "WHERE";
		$sql .= " admin_menu_bar_modules.ModuleID = admin_modules.ID ";
		if($_SESSION[$ADMIN_NAME]["user"]["type"] != "DEVELOPER")
		{
			if($_SESSION[$ADMIN_NAME]["user"]["type"] == "ADMIN")
				$sql .= " AND admin_menu_bar.ID = admin_menu_bar_modules.MenuBarID";
			$sql .= " AND admin_modules.ID = admin_user_modules.ModuleID";
			$sql .= " AND (admin_user_modules.UserID = '".$_SESSION[$ADMIN_NAME]["user"]["id"]."' ";
			if($_SESSION[$ADMIN_NAME]["user"]["type"] == "ADMIN")
#				$sql .= "       OR admin_modules.ID = '2'";
				$sql .= "       OR admin_menu_bar_modules.MenuBarID = '4'";			
			$sql .= ")	AND admin_modules.Developer = 'no' ";
			$sql .= "	AND admin_modules.InUse = 'yes' ";
		}
		$sql .= " AND admin_menu_bar_modules.MenuBarID = '".$barMenuArray[$x]["id"]."' ";
		$sql .= "GROUP BY admin_modules.ID ";
		$sql .= "ORDER BY admin_menu_bar_modules.MenuBarID, admin_menu_bar_modules.IndexNo";
		$rs_menu = mysql_query($sql, $db);
		echo mysql_error();
		while($row_menu = mysql_fetch_row($rs_menu))
		{
			// generate menu layer
			switch($row_menu[1])
			{
				case "SEPERATOR":
					$menu .= "<tr><td class='barMenu' colspan='2'><hr></td></tr>\n";
					break;
					
				default:
					// sep
					if($row_menu[7] == "before")
						$menu .= "<tr><td class='barMenu' colspan='2' style='font-size: 2pt'><hr></td></tr>\n";
						
					$menu .= "<tr style='cursor: pointer;' onmouseover=\"javascript:style.backgroundColor='#fff10b'\" onmouseout=\"javascript:style.backgroundColor='white'\" onClick=\"javascript:createNewWin('".lang($row_menu[3])."', '".$row_menu[4]."', '".$row_menu[5]."', '".$row_menu[6]."', 'menu-".$barMenuArray[$x][id]."');\">";
					$menu .= "	<td class='barMenu' width='18'>";
					if(!empty($row_menu[2]) AND is_file("template/".$ADMIN_TEMPLATE."/icons/".$row_menu[2]))
						$menu .= API_icon("template/".$ADMIN_TEMPLATE."/icons/".$row_menu[2], lang($row_menu[3]));
					else
						$menu .= "&nbsp;";
					$menu .= "	</td>\n";
					$menu .= "	<td class='barMenu' style='cursor: pointer;'>".lang($row_menu[3])."&nbsp;&nbsp;&nbsp;</td>";
					if(strlen(lang($row_menu[3])) > $menuWidth)
						$menuWidth = strlen(lang($row_menu[3]));
					$menu .= "</tr>\n";
					
					// sep
					if($row_menu[7] == "after")
						$menu .= "<tr><td class='barMenu' colspan='2'><hr></td></tr>\n";
					
					break;
			}				
		}	
		
		// make the menu
		$menuWidth = $menuWidth*11+18;
		$bar .= "<div id='menu-".$barMenuArray[$x]["id"]."' style='position: absolute; top: 24px; left: ".$menuPos."px; z-index: 1100; visibility: hidden' class='barMenuLayer'><table cellpadding='4' cellspacing='0'>".$menu."</table></div>\n";
		$menu = "";
		$menuWidth = 0;
		$menuPos += $barMenuArray[$x]["width"];
	}
	
	// generate help menu
	$menu .= "<tr onmouseover=\"javascript:style.backgroundColor='#fff10b'\" onmouseout=\"javascript:style.backgroundColor='white'\" onClick=\"javascript:createNewWin('".lang("Help")." ".strtolower(lang("Topics"))."', 'help/topic.help.php', '600', '550', 'menu-help');\">";
	$menu .= "	<td class='barMenu' width='18'>".API_icon("template/".$ADMIN_TEMPLATE."/icons/16x16/khelpcenter.crystal.apps.icon.png", lang("Help"))."</td>\n";
	$menu .= "	<td class='barMenu'>".lang("Help")."&nbsp;".strtolower(lang("Topics"))."&nbsp;&nbsp;&nbsp;</td>";
	$menu .= "</tr>\n";
/*	
	$menu .= "<tr onmouseover=\"javascript:style.backgroundColor='#fff10b'\" onmouseout=\"javascript:style.backgroundColor='white'\" onClick=\"javascript:createNewWin('".lang("Templates")."', 'help/templates.help.php', '400', '500', 'menu-help');\">";
	$menu .= "	<td class='barMenu' width='18'>".API_icon("template/".$ADMIN_TEMPLATE."/icons/help/templates.icon.png", lang("Templates"))."</td>\n";
	$menu .= "	<td class='barMenu'>".lang("Templates")."&nbsp;&nbsp;&nbsp;</td>";
	$menu .= "</tr>\n";
*/	
	$menu .= "<tr onmouseover=\"javascript:style.backgroundColor='#fff10b'\" onmouseout=\"javascript:style.backgroundColor='white'\" onClick=\"javascript:createNewWin('".lang("Change log")."', '../CHANGES.txt', '600', '500', 'menu-help');\">";
	$menu .= "	<td class='barMenu' width='18'>".API_icon("template/".$ADMIN_TEMPLATE."/icons/help/templates.icon.png", lang("Change log"))."</td>\n";
	$menu .= "	<td class='barMenu'>".lang("Change log")."&nbsp;&nbsp;&nbsp;</td>";
	$menu .= "</tr>\n";
	$menu .= "<tr onmouseover=\"javascript:style.backgroundColor='#fff10b'\" onmouseout=\"javascript:style.backgroundColor='white'\" onClick=\"javascript:createNewWin('".lang("About")."', 'help/about.help.php', '400', '500', 'menu-help');\">";
	$menu .= "	<td class='barMenu' width='18'>".API_icon("template/".$ADMIN_TEMPLATE."/icons/help/about.icon.png", lang("About"))."</td>\n";
	$menu .= "	<td class='barMenu'>".lang("About")."&nbsp;&nbsp;&nbsp;</td>";
	$menu .= "</tr>\n"; 
	$bar .= "<div id='menu-help' style='position: absolute; top: 24px; left: ".$menuPos."px; z-index: 1100; visibility: hidden' class='barMenuLayer'><table cellpadding='4' cellspacing='0'>".$menu."</table></div>\n";

	// make js to handle menus
	$bar .= "<script>\n";
	$bar .= "function do_menu_togle(id)\n";
	$bar .= "{\n";
	$bar .=	"		// first we check to se if the layer already is visible\n";
	$bar .=	"		if(document.getElementById(id).style.visibility == 'visible')\n";
	$bar .=	"			visible = 'true';\n";
	$bar .= "		else\n";
	$bar .= "			visible = 'false';\n";
	$bar .= "		// if it is hide it\n";
	$bar .= "		if(visible == 'true')\n";
	$bar .= "		{\n";
	$bar .= "			document.getElementById(id).style.visibility = 'hidden';\n";
	$bar .= "		}\n";
	$bar .= "		else\n";
	$bar .= "		{\n";
	$bar .= "			// hide alle other menus\n";
	for($x = 0; $x < count($barMenuArray); $x++)
	{
		$bar .= "			document.getElementById('menu-".$barMenuArray[$x]["id"]."').style.visibility = 'hidden';\n";
	}
	$bar .= "			document.getElementById('menu-help').style.visibility = 'hidden';\n";
	$bar .= "			// then show the right menu\n";
	$bar .= "			document.getElementById(id).style.visibility = \"visible\";";
	$bar .= "		}\n";
	$bar .= "}\n"; 
	
	// load the window templare 
	$bar .= "var template = \"".API_JsWindowGen()."\";\n";
	
	$bar .= "</script>\n";
	
	$bar .= "			</td>\n";
	//user info and logout button 
	$bar .= "			<td width='200' align='right'>\n";
	$bar .= "				<b>".lang("User").":</b>&nbsp;".$_SESSION[$ADMIN_NAME]["user"]["name"]."\n";
	$bar .= "			</td>\n";
	$bar .= "			<td width='10' align='right'>&nbsp;&nbsp;&nbsp;</td>\n";
	$bar .= "			<td width='40' align='right' style='cursor: pointer;' onMouseOver=\"javascript:style.backgroundColor='#c4c4c4'\" onMouseOut=\"javascript:style.backgroundColor='transparent'\" onClick='javascript:document.location.href=\"index.php?logout=yes\"'>\n";
	$bar .= "				<table cellpadding='0' cellspacing='0'><tr><td class='bar'>".API_icon("template/".$ADMIN_TEMPLATE."/icons/16x16/logout.icon.png")."</td><td class='bar'>&nbsp;<b>".lang("Logout")."</b>&nbsp;</td></tr></table>";
	$bar .= "			</td>\n";
	
	$bar .= "		</tr>\n";
	$bar .= "	</table>\n";
	
	return $bar;
}


function API_Site()
{
	global $ADMIN_TEMPLATE, $ADMIN_TITTLE, $ADMIN_NAME, $SITE_TITTLE, $SITE_NAME;

	// javascript that makes the windows dragable
	$menuJs .= '<script type="text/javascript" src="js/dragandmove.js"></script>';
	$menuJs .= '<script type="text/javascript" src="js/func.js"></script>';
	
	$menuJs .= "<script type=\"text/javascript\">\n";
	// global start posisition for the next window
	$menuJs .= "var startPosTop = 35;\n";
	$menuJs .= "var startPosLeft = 20;\n";
	$menuJs .= "var PosTop = 35;\n";
	$menuJs .= "var PosLeft = 20;\n";
	$menuJs .= "var zIndex = 5;\n";
	$menuJs .= "var winNum = 0;\n";
	$menuJs .= "var winCur = 0;\n";
	$menuJs .= "var type = browserType();\n";
	$menuJs .= "</script>\n";

	// fetching template
	$template = API_GetTemplate("site.html");
	
	$template = str_replace("##HEAD##", $menuJs, $template);
	
	// inserting the tittle
	$template = str_replace("##TITTLE##", $ADMIN_TITTLE, $template);
	$template = str_replace("##PATH##", "template/".$ADMIN_TEMPLATE, $template);
	
	$back  = "<table cellpadding='0' cellspacing='0' width='100%' height='100%'>\n";
	$back .= "	<tr>\n";
	$back .= "		<td valign='top'>\n";
	if(!empty($_SESSION[$ADMIN_NAME]["user"]["id"]))
		$back .= API_topbar();
	$back .= "		</td>\n";
	$back .= "	<tr>\n";
	
	$back .= "	<tr>\n";
	$back .= "		<td valign='top' align='center'>\n";
	$back .= "<div id='desktop' style='border: 1px solid black; visibility: hidden'></div>";
	// fethcing header if there is one
	if(is_file("template/custom/header.inc.html"))
		$header = API_GetTemplate("header.inc.html", "yes");
	// fiksing path tag
	$header = str_replace("##PATH##", "template/custom", $header);
	// generating the header code
	$back .= "<div style='position: relative; z-index: 0;'>".$header."</div>";

	$back .= "		</td>\n";
	$back .= "	</tr>\n";
	$back .= "	<tr>\n";
	$back .= "		<td valign='bottom' align='center' width='100%'>\n";
	
	// fethcing footer if there is one
	if(is_file("template/custom/footer.inc.html"))
		$footer = API_GetTemplate("footer.inc.html", "yes");
	// fiksing path tag
	$footer = str_replace("##PATH##", "template/custom", $footer);
	// generating the footer
	$back .= "<div style='position: relative; z-index: 0;'>".$footer."</div>";

	$back .= "		</td>\n";
	$back .= "	</tr>\n";
	$back .= "</table>\n";
/*	
	// make a layer we can work on
	$back .= "<div id='desktop' style='position: absolute; top: 25px; z-index: 1' onClick='javascript:do_menu_togle(\"none\");'>&nbsp;asda</div>";
	$back .= "<script>\n";
	$back .= "	document.getElementById('desktop').setAttribute('Width', document.body.scrollWidth);\n";
	$back .= "	document.getElementById('desktop').setAttribute('Height', document.body.scrollHeight-25);\n";
	$back .= "</script>\n";
*/
	$template = str_replace("##BACKGROUND##", $back, $template);
	
	return $template;
}	

function API_Menu($name = "Std")
{
	global $ADMIN_TEMPLATE, $ADMIN_NAME, $SITE_NAME, $db;

	// generate the menu setup
	$rs_menu = mysql_query("SELECT admin_menu.Top, admin_menu.Left, admin_menu.Width FROM admin_menu WHERE Name = '".$name."'", $db);
	echo mysql_error();
	if($row_menu = mysql_fetch_row($rs_menu))
	{
		$visible	= "yes";
		$top			= $row_menu[0];
		$left			= $row_menu[1];
		$width		= $row_menu[2];
	}
	
	
	// findes the modules that fits
	$sql  = "SELECT";
	$sql .= " Type,";
	$sql .= " admin_menu_modules.Name,";
	$sql .= " Icon,";
	$sql .= " admin_modules.Link,";
	$sql .= " admin_modules.Width,";
	$sql .= " admin_modules.Height,";
	$sql .= " admin_menu_modules.Line ";
	$sql .= "FROM admin_menu_modules, admin_modules, admin_user_modules ";
	$sql .= "WHERE";
	$sql .= " admin_menu_modules.ModuleID = admin_modules.ID";
	$sql .= " AND admin_modules.ID = admin_user_modules.ModuleID";
	$sql .= " AND admin_user_modules.UserID = '".$_SESSION[$ADMIN_NAME]["user"]["id"]."'";
	$rs_rights = mysql_query($sql, $db);
	echo mysql_error();
	$menu[$name]["count"] = mysql_num_rows($rs_rights);
	$x = 0;
	while($row_rights = mysql_fetch_row($rs_rights))
	{
		$menu[$name][$x]["type"] 	 = $row_rights[0];
		$menu[$name][$x]["name"] 	 = $row_rights[1];
		$menu[$name][$x]["icon"]	 = $row_rights[2];
		$menu[$name][$x]["link"] 	 = $row_rights[3];
		$menu[$name][$x]["width"]  = $row_rights[4];
		$menu[$name][$x]["height"] = $row_rights[5];
		$menu[$name][$x]["line"]   = $row_rights[6];
		$x++;
	}

	// check to se if the menu dos exist
	if(isset($name) OR isset($visible))
	{
		for($x = 0; $x < $menu[$name]["count"]; $x++)
		{
			$id = $name.$x;

			// generates the layers to load module to
			$contentOfWin = "<div id='".$id."-inside' style='position: ralative; visibility: visible'></div>\n";
			$win = API_WindowModule($menu["Std"][$x]["width"], $menu["Std"][$x]["name"], $contentOfWin, "HELP,CLOSE",$name,$id);
			$menu_win .= "			<div id='".$id."' style='position: absolute; width: ".$menu["Std"][$x]["width"]."; height: ".$menu["Std"][$x]["height"]."; top: 20px; left: 20px; visibility: hidden'  onClick='javascript:clickToFront(\"".$id."\");'>".$win."</div>";
		}
		
		// generate the menu
		$menu_str .= "<table cellpadding='0' cellspacing='0' class='menuTable' width='".($width-10)."'>\n";
		
		for($x = 0; $x < $menu[$name]["count"]; $x++)
		{
			$id = $name.$x;

			if($menu[$name][$x]["line"] == "before")
			{
				$menu_str .= "	<tr class='menuTr'><td><hr></td></tr>\n";
			}
			
			$menu_str .= "	<tr class='menuTr' style='cursor: pointer;' onmouseover=\"javascript:style.backgroundColor='#fff10b'\" onmouseout=\"javascript:style.backgroundColor='white'\" onClick=\"javascript:openWin('".$id."','".$menu[$name][$x]["link"]."','".($menu[$name][$x]["width"]-11)."','".($menu[$name][$x]["height"]-47)."');\">\n";
			$menu_str .= "		<td class='menuTd'>\n";
			
			$menu_str .= "			<table cellspacing='0' cellpadding='0'>\n";
			$menu_str .= "				<tr><td colspan='4' style='font-size: 3px;'>&nbsp;</td></tr>\n";
			$menu_str .= "				<tr>\n";
			$menu_str .= "					<td class='menuTd' width='40' align='right'>\n";
			// retrives the image size
			if(is_file("template/".$ADMIN_TEMPLATE."/icons/".$menu[$name][$x]["icon"]))
			{
				$info = getimagesize("template/".$ADMIN_TEMPLATE."/icons/".$menu[$name][$x]["icon"]);
				$menu_str .= "						<div style=\"filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='template/".$ADMIN_TEMPLATE."/icons/".$menu[$name][$x]["icon"]."', sizingMethod='scale'); width: ".$info[0]."px; height: ".$info[1]."px;\"><img src=\"template/".$ADMIN_TEMPLATE."/icons/".$menu[$name][$x]["icon"]."\" style=\"width: ".$info[0]."px; height: ".$info[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"\"></div>\n";
			}
			else
			{
				$menu_str .= "						&nbsp;\n";
			}
			$menu_str .= "					</td>\n";
			$menu_str .= "					<td class='menuTd' width='5'>&nbsp;&nbsp;</td>\n";
			$menu_str .= "					<td class='menuTd'>".lang($menu[$name][$x]["name"])."</td>\n";
			$menu_str .= "					<td class='menuTd' align='right' width='10%'>\n";
			if($menu[$name][$x]["type"] == "FOLDER")	
			{
				if(is_file("template/".$ADMIN_TEMPLATE."/icons/".$menu[sub_icon]))
				{
					$info = getimagesize("template/".$ADMIN_TEMPLATE."/icons/".$menu["sub_icon"]);
					$menu_str .= "					<div style=\"filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='template/".$ADMIN_TEMPLATE."/icons/".$menu["sub_icon"]."', sizingMethod='scale'); width: ".$info[0]."px; height: ".$info[1]."px;\"><img src=\"template/".$ADMIN_TEMPLATE."/icons/".$menu["sub_icon"]."\" style=\"width: ".$info[0]."px; height: ".$info[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"\"></div>\n";
				}
				else
				{
					$menu_str .= "					&nbsp;\n";
				}
			}
			else	
			{
				$menu_str .= "					&nbsp;\n";
			}
			$menu_str .= "					</td>\n";
			$menu_str .= "				</tr>\n";
			$menu_str .= "				<tr><td colspan='4' style='font-size: 3px;'>&nbsp;</td></tr>\n";
			$menu_str .= "			</table>\n";
			$menu_str .= "		</td>\n";
			$menu_str .= "	</tr>\n";
			
			if($menu[$name][$x]["line"] == "after")
			{
				$menu_str .= "	<tr class='menuTr'><td><hr></td></tr>\n";
			}

		}
		$menu_str .= "</table>\n";
	}
	
	return API_Window($width, "Menu", $menu_str, "HELP", $name, $top, $left).$menu_win;
}

function API_module()
{
	global $ADMIN_TEMPLATE, $ADMIN_NAME;
	
	if(empty($_SESSION[$ADMIN_NAME]["user"]["id"]) OR empty($_SESSION[$ADMIN_NAME]["user"]["type"]) OR $_SESSION[$ADMIN_NAME]["logout"] == "yes")
	{
		echo "<script>if (window != top){top.location.href = '../index.php';} </script>";
		exit();		
	}
	else 
	{
		if(is_file("../template/".$ADMIN_TEMPLATE."/module.html"))
		{
			$module_template = API_LoadFile("../template/".$ADMIN_TEMPLATE."/module.html");
	
			$module_template = str_replace("##PATH##", "../template/".$ADMIN_TEMPLATE, $module_template);
		}
		else if(is_file("../../template/".$ADMIN_TEMPLATE."/module.html"))
		{
			$module_template = API_LoadFile("../../template/".$ADMIN_TEMPLATE."/module.html");
	
			$module_template = str_replace("##PATH##", "../../template/".$ADMIN_TEMPLATE, $module_template);
		}
	
		return $module_template;	
	}
}

function API_icon($icon, $alt = '')
{
	if(is_file($icon))
	{
		$size = getimagesize($icon);
	
		$str = "<div style=\"filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='".$icon."', sizingMethod='scale'); width: ".$size[0]."px; height: ".$size[1]."px;\"><img border='0' src=\"".$icon."\" style=\"width: ".$size[0]."px; height: ".$size[1]."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0)\" alt=\"".$alt."\"></div>";
	}
	else 
	{
		$str = "&nbsp;";	
	}

	return $str;
}

function API_help($help)
{
	global $db, $ADMIN_NAME;

	$rs_help = mysql_query("SELECT Headline, Help FROM admin_help_tips WHERE LanguageCode='".$_SESSION[$ADMIN_NAME]["user"]["language"]."' AND Name = '".$help."'", $db);
	if(!$row_help = mysql_fetch_row($rs_help))
	{
		$rs_help = mysql_query("SELECT Headline, Help FROM admin_help_tips WHERE LanguageCode='en' AND Name = '".$help."'", $db);
		$row_help = mysql_fetch_row($rs_help);
	}
	
	$str  = "<table class='helpback'>\n";
	$str .= "	<tr><td class='helphead'>".$row_help[0]."</td></tr>\n";
	$str .= "	<tr><td class='help'>".$row_help[1]."</td></tr>\n";
	$str .= "</table>\n";
	
	return $str;
}

function API_rte_editor_init()
{
	global $ADMIN_HOSTPATH;
/*	
	$str  = "<script language=\"JavaScript\" type=\"text/javascript\" src=\"../include/rte/richtext.js\"></script>\n";
	
	$str .= "<script language=\"JavaScript\" type=\"text/javascript\">\n";
	$str .= "<!--\n";
	$str .= "function submitForm() {\n";
	$str .= "	//make sure hidden and iframe values are in sync before submitting form\n";
	$str .= "	//to sync only 1 rte, use updateRTE(rte)\n";
	$str .= "	//to sync all rtes, use updateRTEs\n";
	$str .= "	//updateRTE('rte1');\n";
	$str .= "	updateRTEs();\n";
	$str .= "	document.formModule.submit();\n";
#	$str .= "	alert(document.RTEDemo.rte1.value);\n";
	$str .= "	//change the following line to true to submit form\n";
	$str .= "	return false;\n";
	$str .= "}\n";

	$str .= "initRTE(\"../include/rte/images/\", \"\", \"\");\n";
	$str .= "//-->\n";
	$str .= "</script>\n";
*/
	$str  = '<script type="text/javascript" src="../include/FCKeditor/fckconfig.js"></script>';

	return $str;
}

function API_rte_editor($name, $width, $height, $body)
{
	global $db, $SITE_HOSTPATH, $ADMIN_NAME;

/*
	//returns safe code for preloading in the RTE
	$body = trim($body);
	
	//convert all types of single quotes
	$body = str_replace(chr(145), chr(39), $body);
	$body = str_replace(chr(146), chr(39), $body);
	$body = str_replace("'", "&#39;", $body);
	
	//convert all types of double quotes
	$body = str_replace(chr(147), chr(34), $body);
	$body = str_replace(chr(148), chr(34), $body);
	$body = str_replace("\"", "\\\"", $body);
	
	//replace carriage returns & line feeds
	$body = str_replace(chr(10), " ", $body);
	$body = str_replace(chr(13), " ", $body);

	$str .= "<script language=\"JavaScript\" type=\"text/javascript\">\n";
	////////////////////////// MANGLER LOKALE BILLEDER //////////////////////////////
	$images = '<option name="Pic">-- '.lang("Pictures").' --</option>';
	$rs_pic = mysql_query("SELECT ID, Name FROM web_pictures ORDER BY Name", $db);	
	while($row_pic = mysql_fetch_row($rs_pic))
	{
		$images .= '<option value="'.$SITE_HOSTPATH.'files/picture/custom/'.$row_pic[0].'.jpg">'.str_replace("'", "?", $row_pic[1]).'</option>';
	}
	$str .= "//Usage: writeRichText(fieldname, html, width, height, buttons)\n";
	$str .= "writeRichText('".$name."', '".$body."', ".$width.", ".$height.", true, false, '".$images."');\n";
	$str .= "//-->\n";
	$str .= "</script>\n";
*/

	include_once("../include/FCKeditor/fckeditor.php");
	
	$oFCKeditor = new FCKeditor($name) ;
	$oFCKeditor->BasePath = "../include/FCKeditor/" ;

	$oFCKeditor->Config['AutoDetectLanguage']	= false ;
	$oFCKeditor->Config['DefaultLanguage']		= $_SESSION["$ADMIN_NAME"]["user"]["language"];
	
	$oFCKeditor->Width = $width;
	$oFCKeditor->Height = $height;
#	$oFCKeditor->Value = 'This is some <strong>sample text</strong>. You are using <a href="http://www.fckeditor.net/">FCKeditor</a>.' ;
	$oFCKeditor->Value = $body;
	$str = $oFCKeditor->CreateHtml();

	return $str;
}

function API_rte_language_editor($data, $name, $width, $height, $input = "")
{
	global $db;
	
	$languageArr = array();
	$rs_lang = mysql_query("SELECT LanguageCode, Language FROM web_languages WHERE active='yes' ORDER BY web_languages.default", $db);
	while($row_lang = mysql_fetch_row($rs_lang))
	{
		$tmp_arr["Code"] = $row_lang[0];
		$tmp_arr["Language"] = $row_lang[1];
		array_push($languageArr, $tmp_arr);
	}
		
	$str .= "		<script>\n";
	$str .= "			function toggle(target) {\n";
	for($x = 0; $x < count($languageArr); $x++)
	{
		$str .= "				var elem = document.getElementById('layer-".$languageArr[$x]["Code"]."');\n";
		$str .=	"				elem.style.visibility = 'hidden';\n";
		$str .= "				var selected = 'tdlang-".$languageArr[$x]["Code"]."';\n";
		$str .= "				var elemtd = document.getElementById(selected);\n";
		$str .= "				elemtd.className = 'rteLanguageTab';\n";
	}
	$str .= "				selected = 'tdlang-' + target;\n";
	$str .= "				elemtd = document.getElementById(selected);\n";
	$str .= "				elemtd.className = 'rteLanguageTabSelected';\n";
	$str .= "				var elemdiv = document.getElementById('layer-' + target);\n";
	$str .=	"				elemdiv.style.visibility = 'visible';\n";
	$str .= "				selected = '".$name."-' + target + '___Frame.".$name."-' + target;\n";
	$str .= "				var body = document.getElementById(selected);\n";
	$str .= "				body.ForceDesignMode();\n";
	$str .= "			}\n";	
	$str .= "		</script>\n";
	
	$str .= "							<table cellpadding='0' cellspacing='0'>\n";
	$str .= "								<tr>\n";
	$str .= "									<td valign='baseline'>\n";
	$str .= "										<table cellpadding='0' cellspacing='0'>\n";
	$str .= "											<tr>\n";

	$first = true;
	for($x = 0; $x < count($languageArr); $x++)
	{	
		if($first)
		{
			$first = false;
			$str .= "												<td valign='baseline'>\n";
			$str .= "													<table cellpadding='3' cellspacing='0'><tr><td id='tdlang-".$languageArr[$x]["Code"]."' name='tdlang-".$languageArr[$x]["Code"]."' valign='buttom' class='rteLanguageTabSelected' onClick='javascript: toggle(\"".$languageArr[$x]["Code"]."\")'>&nbsp;".lang($languageArr[$x]["Language"])."&nbsp;</td></tr></table>\n";
			$str .= "												</td>\n";
		}
		else 
		{
			$str .= "												<td valign='baseline'>\n";
			$str .= "													<table cellpadding='3' cellspacing='0'><tr><td id='tdlang-".$languageArr[$x]["Code"]."' name='tdlang-".$languageArr[$x]["Code"]."' valign='buttom' class='rteLanguageTab' onClick='javascript: toggle(\"".$languageArr[$x]["Code"]."\")'>&nbsp;".lang($languageArr[$x]["Language"])."&nbsp;</td></tr></table>\n";
			$str .= "												</td>\n";
		}
	}
	
	$str .= "											</tr>\n";
	$str .= "										</table>\n";
	$str .= "									</td>\n";
	$str .= "								</tr>\n";
	$str .= "								<tr>\n";
	$str .= "									<td>\n";

	$first = true;
	for($x = 0; $x < count($languageArr); $x++)
	{	
		if($first)
		{
			$first = false;
			$str .= "										<div id='layer-".$languageArr[$x]["Code"]."' style='border: 1px solid #333333; position: absolute; background-color: #efefde'>\n";
		}
		else
		{
			$str .= "										<div id='layer-".$languageArr[$x]["Code"]."' style='border: 1px solid #333333; position: absolute; background-color: #efefde; visibility: hidden;'>\n";
		}
		$str .= "											<table>\n";
		
		$str .= $input[$languageArr[$x]["Code"]];
		$str .= "												<tr>\n";
		$str .= "													<td class='module' colspan='2'>\n";
		$str .= API_rte_editor($name."-".$languageArr[$x]["Code"], $width, $height, $data[$languageArr[$x]["Code"]]);
		$str .= "													</td>\n";
		$str .= "												</tr>\n";
	
		$str .= "											</table>\n";
		$str .= "										</div>\n";
	}
	$str .= "									</td>\n";
	$str .= "								</tr>\n";
	$str .= "							</table>\n";	
	
	return $str;
}

/*
function API_htmlarea($name, $rows, $cols, $body)
{
	global $db, $ADMIN_HOSTPATH;
	
	$str  = "<!-- load the main HTMLArea files -->\n";
	$str .= "<script type='text/javascript' src='".$ADMIN_HOSTPATH."include/htmlarea/htmlarea.js'></script>\n";
	$str .= "<script type='text/javascript' src='".$ADMIN_HOSTPATH."include/htmlarea/lang/en.js'></script>\n";
	$str .= "<script type='text/javascript' src='".$ADMIN_HOSTPATH."include/htmlarea/dialog.js'></script>\n";
	$str .= "<!-- <script type='text/javascript' src='".$ADMIN_HOSTPATH."include/htmlarea/popupdiv.js'></script> -->\n";
	$str .= "<script type='text/javascript' src='".$ADMIN_HOSTPATH."include/htmlarea/popupwin.js'></script>\n";
	$str .= "<!-- load the TableOperations plugin files -->\n";
	$str .= "<script type='text/javascript' src='".$ADMIN_HOSTPATH."include/htmlarea/plugins/TableOperations/table-operations.js'></script>\n";
	$str .= "<script type='text/javascript' src='".$ADMIN_HOSTPATH."include/htmlarea/plugins/TableOperations/lang/en.js'></script>\n";
	
	$str .= "	<script type=\"text/javascript\">\n";
	$str .= "var editor = null;\n";
	$str .= "function initEditor() {\n";
	$str .= "  // create an editor for the \"".$name."\" textbox\n";
	$str .= "  editor = new HTMLArea(\"".$name."\");\n";
	$str .= "  // register the TableOperations plugin with our editor\n";
	$str .= "  editor.registerPlugin(\"TableOperations\");\n";
	$str .= "  editor.generate();\n";
	$str .= "  return false;\n";
	$str .= "}\n";

	$str .= "function insertHTML() {\n";
	$str .= "  var html = prompt(\"Enter some HTML code here\");\n";
	$str .= "  if (html) {\n";
	$str .= "    editor.insertHTML(html);\n";
	$str .= "  }\n";
	$str .= "}\n";
	
	$str .= "function highlight() {\n";
	$str .= "  editor.surroundHTML('<span style=\"background-color: yellow\">', '</span>');\n";
	$str .= "}\n";
	
	$str .= "initEditor();\n";
	$str .= "</script>\n";
	
	$str .= "	<style type=\"text/css\">\n";
	$str .= "@import url(".$ADMIN_HOSTPATH."include/htmlarea/htmlarea.css);\n";

#	$str .= "html, body {\n";
#	$str .= "  font-family: Verdana,sans-serif;\n";
#	$str .= "  background-color: #fea;\n";
#	$str .= "  color: #000;\n";
#	$str .= "}\n";
#	$str .= "a:link, a:visited { color: #00f; }\n";
#	$str .= "a:hover { color: #048; }\n";
#	$str .= "a:active { color: #f00; }\n";

#	$str .= "textarea { background-color: #fff; border: 1px solid 00f; }\n";
	$str .= "</style>\n";
	
	$str .= "<textarea id=\"".$name."\" name=\"".$name."\" style=\"width:100%\" rows=\"".$rows."\" cols=\"".$cols."\" class='moduleInputArea'>\n";
	$str .= $body;
	$str .= "</textarea>\n";
	
	return $str;
}
*/
?>