<?PHP
/*******************************************************************
 *  cmsWorks                                                       *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.0.2                                                *
 *	Modified: 2005-11-30 02:27                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/
 
include_once("../include/lib.module.php");	// include the std stuff 

function update_module()
{
	global $db;
	
	$version = module_version("Project");

	// install db
	if($version == "no module" OR $version == "")
	{
		$sql[] = "CREATE TABLE `project` (
							`ID` INT( 32 ) NOT NULL AUTO_INCREMENT ,
							`Name` VARCHAR( 255 ) NOT NULL ,
							`Description` TEXT NOT NULL ,
							`CustomerID` INT( 32 ) NOT NULL ,
							`Budget` VARCHAR( 255 ) NOT NULL ,
							`EstTime` VARCHAR( 255 ) NOT NULL ,
							`StartDate` DATE NOT NULL ,
							`EndDate` DATE NOT NULL ,
							`Status` VARCHAR( 20 ) NOT NULL ,
							PRIMARY KEY ( `ID` ),
							INDEX ( `CustomerID` )
							)";
		$sql[] = "CREATE TABLE `project_tasks` (
							`ID` INT( 32 ) NOT NULL AUTO_INCREMENT ,
							`ProjectID` INT( 32 ) NOT NULL ,
							`UserID` INT( 32 ) NOT NULL ,
							`Name` VARCHAR( 255 ) NOT NULL ,
							`Description` TEXT NOT NULL ,
							`EstTime` VARCHAR( 255 ) NOT NULL ,
							`Status` VARCHAR( 20 ) NOT NULL ,
							PRIMARY KEY ( `ID` ) ,
							INDEX ( `ProjectID` , `UserID` )
							)";
		$sql[] = "CREATE TABLE `project_tasks_time` (
							`ID` INT( 32 ) NOT NULL AUTO_INCREMENT ,
							`Project_taskID` INT( 32 ) NOT NULL ,
							`UserID` INT( 32 ) NOT NULL ,
							`StartTime` DATETIME NOT NULL ,
							`EndTime` DATETIME NOT NULL ,
							`UsedTime` VARCHAR( 255 ) NOT NULL ,
							`Description` TEXT NOT NULL ,
							PRIMARY KEY ( `ID` ) ,
							INDEX ( `Project_taskID` , `UserID` )
							) ";
			
		for($x = 0; $x < count($sql); $x++)
			mysql_query($sql[$x], $db);
		echo mysql_error();
		
		module_version_update("Project", "1.0.0");
	}
	
	if($version == "1.0.0")
	{
		$sql[] = "ALTER TABLE `project` ADD `Closed` ENUM( 'no', 'yes' ) NOT NULL ;";
		
		for($x = 0; $x < count($sql); $x++)
			mysql_query($sql[$x], $db);
		echo mysql_error();
		
		module_version_update("Project", "1.0.1");		
	}
	
}
update_module();


function project_list($order, $limitfrom, $search, $variable = "" )
{
	global $db, $ADMIN_NAME, $ADMIN_TEMPLATE, $PHP_SELF;
  
	if(empty($order))
		$order = "project.Name";	// the sql col to order by default
	
	$url = explode("?", $PHP_SELF);

	$module = new MODULE;
	 
	// tools
	$module->MODULE_add_tool($url[0]."?a=e&o=".$order."&s=".$search."&v=".$variable, "New", "new.icon.png");	// new link
#	$module->MODULE_add_tool($url[0]."?a=te&o=".$order."&s=".$search."&v=".$variable, "New&nbsp;task", "new.icon.png");	// new link
	$module->MODULE_add_tool($url[0], "Reload", "reload.icon.png");	// reload the list

	// list header
	$module->MODULE_add_header("Name", "Name", "160");		// here is a cuble of cols for the list
	$module->MODULE_add_header("Customer", "Customer", "160");		// here is a cuble of cols for the list
	$module->MODULE_add_header("StartDate", "Start", "90");		// here is a cuble of cols for the list
	$module->MODULE_add_header("EndDate", "End", "90");		// here is a cuble of cols for the list
	$module->MODULE_add_header("Closed", "Closed", "70");		// here is a cuble of cols for the list
		
	// limit stuff
	if(empty($limitoff))
	{
		$sql  = "SELECT";
		$sql .= " COUNT(project.ID) ";
		$sql .= "FROM project ";	// replace tablename
		if(!empty($search))
			$sql .= " AND (Name LIKE '%".$search."%' OR Description LIKE '%".$search."%') ";	// replace the columns whiths the colums you want to search
		$rs_limitoff = mysql_query($sql, $db);
		$row_limitoff = mysql_fetch_row($rs_limitoff);
		$limitoff = ceil($row_limitoff[0] / $module->listMaxRows);
	}
	
	if(empty($limitfrom) OR $limitfrom > $limitoff)
		$limitfrom = 1;

	// find alle users to generate a list
	$sql  = "SELECT";
	$sql .= " project.ID, project.Name, customer.Name, StartDate, Enddate,Closed "; // replace the colums you want to list
	$sql .= "FROM project ";	// replace tablename
	$sql .= "LEFT JOIN customer ON customer.ID = project.CustomerID ";
#	$sql .= " AND project_obj.Language = '".$_SESSION[$ADMIN_NAME][user][language]."' ";
	if(!empty($search))
		$sql .= " WHERE (Name LIKE '%".$search."%' OR Description LIKE '%".$search."%') ";	// replace the columns whiths the colums you want to search
	$sql .= "ORDER BY ".$order;

	$rs = mysql_query($sql, $db);
	echo mysql_error();
	while($row = mysql_fetch_row($rs))
	{
		// make the list
		$modrow["values"][0] = $row[1];	// value 1 in row
		$modrow["values"][1] = $row[2];	// value 2 in row
		$modrow["values"][2] = $row[3];	// value 3 in row
		$modrow["values"][3] = $row[4];	// value 4 in row
		$modrow["values"][4] = lang($row[5]);	// value 4 in row
		$modrow["id"] = $row[0];				// the id if the row
		$modrow["name"] = $row[1];			// the name shown when you want to delete a row
		
		if($row[5] == "yes")
			$modrow["delete"] = "no";
		else
			$modrow["delete"] = "yes";	
		
		$modrow["links"][0]["link"] = $url[0]."?a=te&i=".$row[0]."&o=".$order."&s=".$search."&v=".$variable;
		$modrow["links"][0]["icon"] = "kthememgr.crystal.apps.icon.png";
		$modrow["links"][0]["name"] = "Tasks";
		
		array_push($module->list, $modrow);
	}

	// remove delete link
#	$module->listDelete = "no";
	// generate page
	$str .= $module->MODULE_generate_list($order, $limitfrom, $limitoff, $search);
	
	return $str;
}

function project_edit($id, $order, $limitfrom, $search)
{
	global $db, $PHP_SELF, $ADMIN_TEMPLATE, $ADMIN_NAME;

	$url = explode("?", $PHP_SELF);

	$sql  = "SELECT";
	$sql .= " ID,";
	$sql .= " Name,";
	$sql .= " Description,";
	$sql .= " CustomerID,";
	$sql .= " StartDate,";
	$sql .= " EndDate,";
	$sql .= " EstTime,";
	$sql .= " Budget,";
	$sql .= " Status,";
	$sql .= " Closed ";
	$sql .= "FROM project ";
	$sql .= "WHERE ID='".$id."'";
	
	$rs = mysql_query($sql, $db);
	$row = mysql_fetch_row($rs);
	echo mysql_error();
	
	// js to check when submit
	$str  = "<script>\n";
	$str .= "	function do_form_check()\n";
	$str .= "	{\n";
	$str .= "		document.formModule.submit();\n";
	$str .= "	}\n";
	
	$str .= "	function do_delete_check()";
	$str .= "	{\n";
	$str .= "		if(confirm('".lang("Are your sure you want to delete")." ".strtolower(lang("This"))."?'))";
	$str .= "		{\n";
	$str .= "			document.location.href = '".$url[0]."?a=d&i=".$id."&o=".$order."&v=".$variable."&lf=".$limitfrom."&s=' + document.formSearch.search.value;\n";
	$str .= "		}\n";
	$str .= "	}\n";
	
	$str .= "</script>\n";
	
		// toolbar
	$module = new MODULE();
	$module->MODULE_add_tool("javascript: do_back();", "Back", "back.icon.png");
	if($row[9] != "yes")
	{
		$module->MODULE_add_tool("javascript: do_delete_check();", "Delete", "delete.icon.png");
		$module->MODULE_add_tool("javascript: do_form_check();", "Save", "save.icon.png");
	}

	// if the search bar is not to be shown
	/*
	if(SOMTHING)
		$module->toolsearch = "no";
	*/
	$str .= $module->MODULE_generate_toolbar($order, $search, $limitfrom, $language);

	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight - 29);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight - 58);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";
	
	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top'>\n";

	$str .= "			<form action='".$url[0]."?a=s&i=".$id."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formModule'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0'>\n";
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='moduleHead' colspan='2'>".lang("Project")."</td>\n";
	$str .= "					</tr>\n";	
	
	// name
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Name")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	$str .= "							<input type='text' name='Name' value='".$row[1]."' size='70' class='moduleInputText'>\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";
	
	// description
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Description")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	$str .= "							<textarea name='Description' rows='10' cols='68' class='moduleInputText'>".$row[2]."</textarea>\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";

	// customer
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Customer")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	$str .= "							<select name='CustomerID' class='moduleInputSelect'>\n";
	$str .= "								<option value='0'>".lang("None")."</option>\n";
	$sql  = "SELECT ID, Name FROM customer ORDER BY Name";
	$rs_customer = mysql_query($sql, $db);
	echo mysql_error();
	while($row_customer = mysql_fetch_row($rs_customer))
	{
		if($row[3] == $row_customer[0])
			$str .= "								<option value='".$row_customer[0]."' selected>".$row_customer[1]."</option>";
		else 
			$str .= "								<option value='".$row_customer[0]."'>".$row_customer[1]."</option>";
	}
	$str .= "							</select>";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";
	
	// start date
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Start date")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	if(empty($row[4]))
		$date = date("Y-m-d", mktime(0, 0, 0, date("m"), date("d"),  date("Y")));
	else 
		$date = $row[4];
	$str .= "							<input type='text' name='StartDate' value='".$date."' size='21' class='moduleInputText'>&nbsp;YYYY-MM-DD\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";

	// end date
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("End date")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	if(empty($row[5]))
		$date = date("Y-m-d", mktime(0, 0, 0, date("m")+1, date("d"),  date("Y")));
	else 
		$date = $row[5];
	$str .= "							<input type='text' name='EndDate' value='".$date."' size='21' class='moduleInputText'>&nbsp;YYYY-MM-DD\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";
	
	// budget
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Budget")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	if(empty($row[7]))
		$budget = "0.00";
	else 
		$budget = $row[7];
	$str .= "							<input type='text' name='Budget' value='".$budget."' size='10' class='moduleInputText'>\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";

	// est time
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Estimated time")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	if(empty($row[6]))
		$est = "01:00";
	else 
		$est = $row[6];
	$str .= "							<input type='text' name='EstTime' value='".$est."' size='10' class='moduleInputText'>\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";
	
	// status
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Status")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>";
	$str .= "							<select name='Status' class='moduleInputSelect'>\n";
	switch ($row[7])
	{
		case "in progress":
			$str .= "								<option value='pending'>".lang("Pending")."</option>";
			$str .= "								<option value='in progress' selected>".lang("In progress")."</option>";
			$str .= "								<option value='waiting'>".lang("Waiting")."</option>";
			$str .= "								<option value='done'>".lang("Done")."</option>";
			break;
			
		case "waiting":
			$str .= "								<option value='pending'>".lang("Pending")."</option>";
			$str .= "								<option value='in progress'>".lang("In progress")."</option>";
			$str .= "								<option value='waiting' selected>".lang("Waiting")."</option>";
			$str .= "								<option value='done'>".lang("Done")."</option>";
			break;
			
		case "done":
			$str .= "								<option value='pending'>".lang("Pending")."</option>";
			$str .= "								<option value='in progress'>".lang("In progress")."</option>";
			$str .= "								<option value='waiting'>".lang("Waiting")."</option>";
			$str .= "								<option value='done' selected>".lang("Done")."</option>";
			break;
			
		default:
			$str .= "								<option value='pending' selected>".lang("Pending")."</option>";
			$str .= "								<option value='in progress'>".lang("In progress")."</option>";
			$str .= "								<option value='waiting'>".lang("Waiting")."</option>";
			$str .= "								<option value='done'>".lang("Done")."</option>";
			break;
	}
	$str .= "							</select>";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";
	
	
	$str .= "					<tr><td class='module'>&nbsp;</td><td class='moduleBottom' colspan='2'>&nbsp;</td></tr>\n";
	
	$str .= "				</table>\n";
	$str .= "			</form>\n";
	
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";	
	
	$str .= "</div>\n";
	
	return $str;
}

function project_delete($id)
{
	global $db;
	
	$rs = mysql_query("SELECT ID FROM project_tasks WHERE ProjectID='".$id."'", $db);
	while($row = mysql_fetch_row($rs))
	{
		mysql_query("DELETE FROM project_tasks_time WHERE Project_taskID='".$row[0]."'", $db);
	}
	mysql_query("DELETE FROM project_tasks WHERE ProjectID='".$id."'", $db);
	mysql_query("DELETE FROM project WHERE ID='".$id."'", $db);
	
	echo mysql_error();	
}

function project_save($id)
{
	global $db, $ADMIN_NAME;

	if(!empty($id))
	{
		$sql  = "UPDATE project SET";
		$sql .= " StartDate='".$_POST["StartDate"]."',";
		$sql .= " EndDate='".$_POST["EndDate"]."',";
		$sql .= " Name='".$_POST["Name"]."',";
		$sql .= " CustomerID='".$_POST["CustomerID"]."',";
		$sql .= " Description='".$_POST["Description"]."',";
		$sql .= " Budget='".$_POST["Budget"]."',";
		$sql .= " EstTime='".$_POST["EstTime"]."',";
		$sql .= " Status='".$_POST["Status"]."' ";
		$sql .= "WHERE ID='".$id."'";

		mysql_query($sql, $db);
	}
	else 
	{
		$sql  = "INSERT INTO project (Name, Description, CustomerID, Budget, EstTime, StartDate, EndDate, Status) VALUES(";
		$sql .= " '".$_POST["Name"]."',";
		$sql .= " '".$_POST["Description"]."',";
		$sql .= " '".$_POST["CustomerID"]."',";
		$sql .= " '".$_POST["Budget"]."',";
		$sql .= " '".$_POST["EstTime"]."',";
		$sql .= " '".$_POST["StartDate"]."',";
		$sql .= " '".$_POST["EndDate"]."',";
		$sql .= " '".$_POST["Status"]."')";
		
		mysql_query($sql, $db);
	}
	echo mysql_error();
}

function project_tasks($id, $order, $limitfrom, $search)
{
	global $db, $PHP_SELF, $ADMIN_TEMPLATE, $ADMIN_NAME;

	$url = explode("?", $PHP_SELF);

	// js to check when submit
	$str  = "<script>\n";
	$str .= "	function do_form_check()";
	$str .= "	{\n";
	$str .= "		document.formModule.submit();\n";
	$str .= "	}\n";
	
	$str .= "</script>\n";
	
		// toolbar
	$module = new MODULE();
	$module->MODULE_add_tool("javascript: document.location.href = '".$url[0]."?o=".$order."&lf=".$limitfrom."&s=".$search."&v=".$variable."'", "Back", "back.icon.png");
	$module->MODULE_add_tool("javascript: document.location.href = '".$url[0]."?a=e&i=".$id."&o=".$order."&lf=".$limitfrom."&s=".$search."&v=".$variable."'", "Edit", "edit.icon.png");

	// if the search bar is not to be shown
	$module->toolsearch = "no";

	$str .= $module->MODULE_generate_toolbar($order, $search, $limitfrom, $variable);
	
	$rs = mysql_query("SELECT Name FROM project WHERE ID='".$id."'", $db);
	$row = mysql_fetch_row($rs);
	$str .= "<table cellpadding='3' cellspacing='0'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td class='module'><b>".lang("Name").":</b></td>\n";
	$str .= "		<td class='module'>&nbsp;&nbsp;".$row[0]."</td>\n";
	$str .= "	</tr>\n";	
	$str .= "</table>\n";

	////////// remember iframe size!
	$str .= "<iframe width='850' height='548' src='".$url[0]."?a=tf&i=".$id."' frameborder='0'></iframe>";
	
	return $str;	
}

function project_tasks_frameset($id)
{
	global $PHP_SELF;
	
	$url = explode("?", $PHP_SELF);

	$str  = "<frameset cols='300,550' frameborder='1' border='1' framespacing='0'>";
	$str .= "	<frame name='leftFrame' scrolling='yes' noresize src='".$url[0]."?a=t&i=".$id."'>";
	$str .= "	<frame name='rightFrame' noresize src='".$url[0]."?a=tfs&oi=".$id."'>";
	$str .= "</frameset>";
	
	echo $str;
	exit();
}

function project_tasks_list($id, $order)
{
	global $db, $ADMIN_NAME;

	if(empty($order))
		$order = "Name";
	
	$module = new MODULE;
	
	$module->subListID = $id;
	
	// list header
	$module->MODULE_add_subheader("Name", "Name", "200");
	
	// find rows
	$sql  = "SELECT";
	$sql .= " ID, Name ";
	$sql .= "FROM project_tasks ";
	$sql .= "WHERE ProjectID = '".$id."' ";

	$rs = mysql_query($sql, $db);
	echo mysql_error();
	
	while($row = mysql_fetch_row($rs))
	{		
		// make the list
		$modrow["values"][0]["name"] = $row[1];	// value 1 in row
		$modrow["values"][1]["link"]  = "";	// value 1 in row
		$modrow["values"][1]["image"] = "";	// value 1 in row
		$modrow["values"][2]["link"]  = "";	// value 1 in row
		$modrow["values"][2]["image"] = "";	// value 1 in row			
		$modrow["id"] 	= $row[0];				// the id if the row
		$modrow["link"] = "javascript: parent.rightFrame.location.href='".$url[0]."?a=tfs&i=".$row[0]."&oi=".$id."&o=".$order."&s=".$search."&v=".$variable."'";
		
		array_push($module->subList, $modrow);
	}

	// gen sublist
	$str = $module->MODULE_generate_sublist($order);
	
	return $str;
}

function project_tasks_show($id, $obj_id)
{
	global $db, $PHP_SELF, $ADMIN_NAME;

	$url = explode("?", $PHP_SELF);

	// js to check when submit
	$str  = "<script>\n";
	$str .= "	function do_form_check()";
	$str .= "	{\n";
	$str .= "		document.formModule.submit();\n";
	$str .= "	}\n";
	$str .= "</script>\n";
	
	$str .= "<script>\n";
	$str .= " parent.leftFrame.location.href = \"".$url[0]."?a=t&i=".$obj_id."\";\n\n";
	$str .= "	function do_subdelete(id, name)\n";
	$str .= "	{\n";
	$str .= "		if(confirm('".lang("Are your sure you want to delete")." \'' + name + '\' ?'))";
	$str .= "		{\n";
	$str .= "			document.location.href = '".$url[0]."?a=td&i=".$id."&oi=".$obj_id."'\n ";
	$str .= "		}\n";
	$str .= "	}\n";
	$str .= "</script>\n";
	
	$str .= "<table cellpadding='0' cellspacing='0' style='border-top: 1px solid #000000' width='100%'>";
	$str .= "	<tr>\n";
	$str .= "		<td>\n";
	
	$sql = "SELECT Closed FROM project WHERE ID='".$object_id."'";
	$rs = mysql_query($sql, $db);
	$row = mysql_fetch_row($rs);
	
	// toolbar
	$module = new MODULE();
	$module->MODULE_add_tool("javascript: document.location.href = '".$url[0]."?a=tfs&oi=".$obj_id."'", "New", "new.icon.png");
	if($row != "yes")
	{
		$module->MODULE_add_tool("javascript: do_subdelete('".$id."','".$row[0]." - ".$row[1]."');", "Delete", "delete.icon.png");
		$module->MODULE_add_tool("javascript: do_form_check();", "Save", "save.icon.png");
	}

	// if the search bar is not to be shown
	$module->toolsearch = "no";

	$str .= $module->MODULE_generate_toolbar($order, $search, $limitfrom, $variable);
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";
	
	$str .= "<form action='".$url[0]."?a=tg&i=".$id."&oi=".$obj_id."' method='post' name='formModule'><br>\n";
	$str .= "<table cellpadding='3' cellspacing='0'>";
	
	$str .= "	<tr>\n";
	$str .= "		<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "		<td class='moduleHead' colspan='3'>".lang("Task")."</td>\n";
	$str .= "	</tr>\n";	
	
	// first the global stuff for this line
	$rs = mysql_query("SELECT UserID , Name, Description, EstTime, Status, Priority FROM project_tasks WHERE ID = '".$id."'", $db);
	$row = mysql_fetch_row($rs);

	// Name
	$str .= "	<tr>\n";
	$str .= "		<td>&nbsp;&nbsp;</td>\n";
	$str .= "		<td class='module'>".lang("Name")."&nbsp;&nbsp;</td>\n";
	$str .= "		<td class='module'><input type='text' size='50' name='Name' value='".$row[1]."' class='moduleInputText'></td>\n";
	$str .= "	</tr>\n";
	
	// Description
	$str .= "	<tr>\n";
	$str .= "		<td>&nbsp;&nbsp;</td>\n";
	$str .= "		<td class='module'>".lang("Description")."&nbsp;&nbsp;</td>\n";
	$str .= "		<td class='module'><textarea rows='10' cols='50' name='Description' class='moduleInputText'>".$row[2]."</textarea></td>\n";
	$str .= "	</tr>\n";

	// est time
	$str .= "	<tr>\n";
	$str .= "		<td>&nbsp;&nbsp;</td>\n";
	$str .= "		<td class='module'>".lang("Estimated time")."&nbsp;&nbsp;</td>\n";
	if(empty($row[3]))
		$est = "01:00";
	else 
		$est = $row[3];
	$str .= "		<td class='module'><input type='text' size='10' name='EstTime' value='".$est."' class='moduleInputText'></td>\n";
	$str .= "	</tr>\n";
	
	// user
	$str .= "		<tr>\n";
	$str .= "			<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "			<td class='module'>".lang("Assign to")."&nbsp;&nbsp;</td>\n";
	$str .= "			<td class='module'>";
	$str .= "				<select name='UserID' class='moduleInputSelect'>\n";
	$str .= "					<option value='0'>".lang("None")."</option>\n";
	$rs_user = mysql_query("SELECT ID, RealName FROM admin_user ORDER BY RealName", $db);
	while($row_user = mysql_fetch_row($rs_user))
	{
		if($row[0] == $row_user[0])
			$str .= "					<option value='".$row_user[0]."' selected>".$row_user[1]."</option>\n";
		else
			$str .= "					<option value='".$row_user[0]."'>".$row_user[1]."</option>\n";
	}
	$str .= "				</select>";
	$str .= "			</td>\n";
	$str .= "		</tr>\n";
	
	// priority
	$str .= "		<tr>\n";
	$str .= "			<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "			<td class='module'>".lang("Priority")."&nbsp;&nbsp;</td>\n";
	$str .= "			<td class='module'>";
	$str .= "				<select name='Priority' class='moduleInputSelect'>\n";
	switch ($row[5])
	{
		case "heigh":
			$str .= "					<option value='low'>".lang("Low")."</option>";
			$str .= "					<option value='heigh' selected>".lang("Heigh")."</option>";
			$str .= "					<option value='normal'>".lang("Normal")."</option>";
			break;
			
		case "low":
			$str .= "					<option value='low' selected>".lang("Low")."</option>";
			$str .= "					<option value='heigh'>".lang("Heigh")."</option>";
			$str .= "					<option value='normal'>".lang("Normal")."</option>";
			break;
			
		default:
			$str .= "					<option value='low'>".lang("Low")."</option>";
			$str .= "					<option value='heigh'>".lang("Heigh")."</option>";
			$str .= "					<option value='normal' selected>".lang("Normal")."</option>";
			break;
	}
	$str .= "				</select>";
	$str .= "			</td>\n";
	$str .= "		</tr>\n";

	// status
	$str .= "		<tr>\n";
	$str .= "			<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "			<td class='module'>".lang("Status")."&nbsp;&nbsp;</td>\n";
	$str .= "			<td class='module'>";
	$str .= "				<select name='Status' class='moduleInputSelect'>\n";
	switch ($row[4])
	{
		case "in progress":
			$str .= "					<option value='pending'>".lang("Pending")."</option>";
			$str .= "					<option value='in progress' selected>".lang("In progress")."</option>";
			$str .= "					<option value='waiting'>".lang("Waiting")."</option>";
			$str .= "					<option value='done'>".lang("Done")."</option>";
			break;
			
		case "waiting":
			$str .= "					<option value='pending'>".lang("Pending")."</option>";
			$str .= "					<option value='in progress'>".lang("In progress")."</option>";
			$str .= "					<option value='waiting' selected>".lang("Waiting")."</option>";
			$str .= "		 			<option value='done'>".lang("Done")."</option>";
			break;
			
		case "done":
			$str .= "					<option value='pending'>".lang("Pending")."</option>";
			$str .= "					<option value='in progress'>".lang("In progress")."</option>";
			$str .= "					<option value='waiting'>".lang("Waiting")."</option>";
			$str .= "					<option value='done' selected>".lang("Done")."</option>";
			break;
			
		default:
			$str .= "					<option value='pending' selected>".lang("Pending")."</option>";
			$str .= "					<option value='in progress'>".lang("In progress")."</option>";
			$str .= "					<option value='waiting'>".lang("Waiting")."</option>";
			$str .= "					<option value='done'>".lang("Done")."</option>";
			break;
	}
	$str .= "				</select>";
	$str .= "			</td>\n";
	$str .= "		</tr>\n";
	
	$str .= "	</table>\n";

	$str .= "</form>\n";
	
	return $str;
}


function project_tasks_save($id, $object_id)
{
	global $db;
	
	if(!empty($id))
	{
		// update
		$sql  = "UPDATE project_tasks SET";
		$sql .= " UserID = '".$_POST["UserID"]."',";
		$sql .= " Name = '".$_POST["Name"]."',";
		$sql .= " Description = '".$_POST["Description"]."',";
		$sql .= " EstTime = '".$_POST["EstTime"]."',";
		$sql .= " Status = '".$_POST["Status"]."',";
		$sql .= " Priority = '".$_POST["Priority"]."' ";
		$sql .= "WHERE ID='".$id."'";
		
		mysql_query($sql, $db);
	}
	else
	{
		$sql .= "INSERT INTO project_tasks";
		$sql .= " (ProjectID, UserID, Name,  Description, EstTime, Status, Priority) ";
		$sql .= "VALUES(";
		$sql .= " '".$object_id."',";
		$sql .= " '".$_POST["UserID"]."',";
		$sql .= " '".$_POST["Name"]."',";
		$sql .= " '".$_POST["Description"]."',";
		$sql .= " '".$_POST["EstTime"]."',";
		$sql .= " '".$_POST["Status"]."',";
		$sql .= " '".$_POST["Priority"]."'";
		$sql .= ")";
		
		$rs = mysql_query($sql, $db);
		echo mysql_error();
		$id = mysql_insert_id();
	}
	
	return $id;
}


switch($_GET["a"])
{
	// edit user
	case "e":
		$str = project_edit($_GET["i"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// save user
	case "s":
		project_save($_GET["i"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		$str = project_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// delete user
	case "d":
		project_delete($_GET["i"]);
		$str = project_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
		
	// task list		
	case "te":
		$str = project_tasks($_GET["i"], $_GET["o"], $_GET["l"], $_GET["s"]);
		break;
	// links save
	case "tg":
		$id = project_tasks_save($_GET["i"], $_GET["oi"]);
		$str = project_tasks_show($id, $_GET["oi"]);
		break;
	// links list
	case "t":
		$str = project_tasks_list($_GET["i"], $_GET["o"]);
		break;
	// links frameset
	case "tf":
		$str = project_tasks_frameset($_GET["i"]);
		break;
	// links show
	case "tfs":
		$str = project_tasks_show($_GET["i"], $_GET["oi"]);
		break;
		
	// default show list
	default:
		$str = project_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
}

echo str_replace("##MODULE##", $str, $module_template);
?>