<?PHP
/*******************************************************************
 *  cmsWorks - upgrades data and database for cmsWorks             *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.0.5                                                *
 *	Modified: 2005-11-04 06:10                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/

include_once("../include/lib.module.php");	// include the std stuff 

$DEBUG = false;

if(!$TEST_SITE)
	$DEFAULT_UPDATE_SERVER = "http://upgrade.cmsworks.netslave.dk";
else 
	$DEFAULT_UPDATE_SERVER = "http://upgrade.test.cmsworks.netslave.dk";

function compare_version_numbers($old, $new)
{
	// split up the numbers
	$old_arr = explode(".", $old);
	$new_arr = explode(".", $new);
	
	// first number
	if($old_arr[0] < $new_arr[0])
		return true;
	else if($old_arr[1] < $new_arr[1] AND $old_arr[0] == $new_arr[0])	// sec number
		return true;
	else if($old_arr[2] < $new_arr[2] AND $old_arr[1] == $new_arr[1])
		return true;
	else if(substr($old_arr[3], 0, 2) == "rc")
	{
		// if the new is not at rc then true
		if(empty($new_arr[3]))
			return true;
		else if(substr($old_arr[3], -1, 1) < substr($new_arr[3], -1, 1)) 
			return true;
		else 
			return false;
	}
	else 
		return false;
}

function do_update($raw_update, $version)
{
	global $db, $SYSTEM_VERSION, $DEBUG;
	
	// Split into files
	// To avoid problems when updateing this module, we use chr() for the first char
	// this way its not recorniced in the split.
	$file_arr = explode(chr(35)."##---###---###---###cmsWorks-header", $raw_update);	

	// check version
	$file_version = substr(str_replace("VERSION:", "", $file_arr[0]), 0, -1);
	if(!compare_version_numbers($SYSTEM_VERSION, $file_version) OR $version != $file_version)
		return false;

	// run thru all files
	for($x = 1; $x < count($file_arr); $x++)
	{
		// Split information and file
		// To avoid problems when updateing this module, we use chr() for the first char
		// this way its not recorniced in the split.
		$file_info = explode(chr(35)."##---###---###---###cmsWorks-upgrade\n", $file_arr[$x]);
		 
		// find file and md5
		$info_arr = explode("\n", $file_info[0]);
		$file_name = str_replace("FILE:", "", $info_arr[1]);
		$file_md5 = str_replace("MD5:", "", $info_arr[2]);
		
		if($DEBUG)
		{
			echo "<br>Filename: ".$file_name."<br>";
			echo "File md5: ".$file_md5."<br>";
		}
		
		// save tmp file, so the md5 can be checked
		if(!is_dir("../../tmp"))
			mkdir("../../tmp");
			
		$tmp_handle = fopen("../../tmp/md5_check_file", "w");
		fwrite($tmp_handle, $file_info[1]);
		fclose($tmp_handle);

		// check md5
		$md5 = md5_file("../../tmp/md5_check_file");
		
		if($DEBUG)
			echo "Check md5: ".$md5."<br>";
			
		// if md5 is OK, then move the file in place
		if($md5 == $file_md5)
		{
			// check to make shure the folder is there for the new file
			$folder_arr = explode("/", $file_name);
			$folder = "";
			for($z = 0; $z < (count($folder_arr)-1); $z++)
			{
				$folder .= "/".$folder_arr[$z];
				
				if(!is_dir("../..".$folder))
				{
					if($DEBUG)
						echo $folder."<br>";
					mkdir("../..".$folder);
				}
			}
			
			copy("../../tmp/md5_check_file", "../..".$file_name);
		}
			
		// update to new version
		$SYSTEM_VERSION = $file_version;
		// if DEBUG is off them we update the version for the system in the db.
		if(!$DEBUG)
			mysql_query("UPDATE setup SET version='".$file_version."'", $db);
	}
}



// chose update method
function update_method()
{
	global $db, $PHP_SELF, $SITE_TEMPLATE, $SITE_NAME;

	$url = explode("?", $PHP_SELF);
	
	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";

	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top' width='300' align='center'>\n";
	$str .= "			<br><br><br><br>";

	$str .= "			<form ENCTYPE='multipart/form-data' action='".$url[0]."?a=two&i=".$id."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formUpdate'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0' width='200'>\n";
	
	// method choice
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='moduleHead' colspan='2'>".lang("Update")." ".strtolower(lang("method"))."</td>\n";
	$str .= "					</tr>\n";	
	
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module' width='50'>&nbsp;&nbsp;&nbsp;&nbsp;<input type='radio' name='update_method' value='online' class='moduleInputRadio' checked></td>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;".lang("Online")."</td>\n";
	$str .= "					</tr>\n";
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;&nbsp;&nbsp;<input type='radio' name='update_method' value='upload' class='moduleInputRadio'></td>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;".lang("Upload")."</td>\n";
	$str .= "					</tr>\n";
	
#	$str .= "					<tr><td>&nbsp;</td><td class='moduleBottom' colspan='2' align='right'><input type='submit' name='".lang("Next")."' value='".lang("Next")."' class='moduleInputSubmit'></td></tr>\n";
	$str .= "					<tr><td>&nbsp;</td><td class='moduleBottom' colspan='2' align='right'>".API_Button('',lang("Next"), "javascript: document.formUpdate.submit()")."</td></tr>\n";
	
	$str .= "				</table>\n";
	$str .= "			</form>\n";
	$str .= "		</td>\n";
	$str .= "		<td>\n";
	$str .= API_help("Update - Method");	
	$str .= "		</td>\n";
	$str .= " </tr>\n";
	$str .= "</table>\n";
	
	return $str;
}

function update_upload()
{
	global $db, $PHP_SELF, $SITE_TEMPLATE, $SITE_NAME;

	$url = explode("?", $PHP_SELF);

	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";

	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top' width='300' align='center'>\n";
	$str .= "			<br><br><br><br>";

	$str .= "			<form ENCTYPE='multipart/form-data' action='".$url[0]."?a=s&i=".$id."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formUpdate'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0'>\n";
	
	/////////////// file ////////////
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='moduleHead' colspan='2'>".lang("Upload")." ".strtolower(lang("update"))."</td>\n";
	$str .= "					</tr>\n";	
	
	// upload
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Update")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='file' name='update_file' size='40' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";
	
	$str .= "					<tr><td>&nbsp;</td><td class='moduleBottom' colspan='2'>&nbsp;</td></tr>\n";
	
	$str .= "				</table>\n";
	$str .= "			</form>\n";
	
	$str .= "		</td>\n";
	$str .= "		<td>\n";
	$str .= API_help("Update - Upload");	
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";	
	
	$str .= "</div>\n";
	
	return $str;
}	
	
function update_online_server()
{
	global $db, $PHP_SELF, $SITE_TEMPLATE, $SITE_NAME, $DEFAULT_UPDATE_SERVER;

	$url = explode("?", $PHP_SELF);
	
	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";

	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top' width='300' align='center'>\n";
	$str .= "			<br><br><br><br>";

	$str .= "			<form ENCTYPE='multipart/form-data' action='".$url[0]."?a=online&i=".$id."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formUpdate'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0'>\n";
	
	/////////////// online ////////////
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='moduleHead' colspan='2'>".lang("Web")." ".strtolower(lang("update"))."</td>\n";
	$str .= "					</tr>\n";	
	
	// update server
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Update")."&nbsp;".strtolower(lang("Server"))."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='text' name='server' value='".$DEFAULT_UPDATE_SERVER."' size='40' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";
	
	$str .= "					<tr><td>&nbsp;</td><td class='moduleBottom' colspan='2' align='right'>".API_Button('',lang("Next"), "javascript: document.formUpdate.submit()")."</td></tr>\n";
	
	$str .= "				</table>\n";
	$str .= "			</form>\n";
	
	$str .= "		</td>\n";
	$str .= "		<td>\n";
	$str .= API_help("Update - Online server");	
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";	
	
	$str .= "</div>\n";
	
	return $str;
}

function update_online($rc = false)
{
	global $db, $DEBUG, $PHP_SELF, $SITE_TEMPLATE, $SITE_NAME, $SYSTEM_VERSION, $TEST_SITE;

	$url = explode("?", $PHP_SELF);
	
	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";

	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top' width='300' align='center'>\n";
	$str .= "			<br>";

	$str .= "			<form ENCTYPE='multipart/form-data' action='".$url[0]."?a=get&i=".$id."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formUpdate'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<input type='hidden' name='server' value='".$_POST["server"]."'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0'>\n";
	
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module' colspan='2'>".lang("Current system version is:")."&nbsp;".$SYSTEM_VERSION."</td>\n";
	$str .= "					</tr>\n";

	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module' colspan='2'>".lang("Fetching information on new versions.")."</td>\n";
	$str .= "					</tr>\n";
/*
	if (!version_compare(phpversion(), "5.0.0", ">=")) 
	{
		// checking connection to update server
		$fp = fsockopen(strtolower($_POST["server"]), 80, $errno, $errstr, 30);
		if (!$fp) 
		{
			$str .= "					<tr>\n";
			$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
			$str .= "						<td class='module' colspan='2'><br><br><b>".$errstr."&nbsp;(".$errno.")</b></td>\n";
			$str .= "					</tr>\n";
			
			$str .= "				</table>\n";
			$str .= "			</form>\n";
			
			$str .= "		</td>\n";
			$str .= "	</tr>\n";
			$str .= "</table>\n";	
			
			$str .= "</div>\n";
			
			return $str;
			exit();
		} 
	}
*/
	// check to se if there is an update
	$update_version = '';

	if(!$rc)
	{
		$server = $_POST["server"];
		$handle = fopen($server."/update.php?type=system_version", "r");
	}
	else 
	{
		$server = $_GET["server"];
		$handle = fopen($server."/update.php?type=system_rc_version", "r");
	}
	
	if ($handle) 
	{
		while (!feof($handle)) 
		{
	  	$update_version .= fread($handle, 8192);
		}
		fclose($handle);
	}

	// if we godt som data from update server
	if($update_version != "false")
	{
		// split versions
		$update_version_arr = explode("\n", $update_version);

		// run tru all updates
		for($y = 0; $y < (count($update_version_arr)-1); $y++)
		{
			if($DEBUG)
				echo "<br>Compare versions: ".$SYSTEM_VERSION." < ".$update_version_arr[$y]."<br>";
			
			// compare the update version with the system version
			if(compare_version_numbers($SYSTEM_VERSION, $update_version_arr[$y]))
			{
				$str .= "					<tr>\n";
				$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
				$str .= "						<td class='module' colspan='2'>".lang("Upgrading to version:")."&nbsp;".$update_version_arr[$y]."</td>\n";
				$str .= "					</tr>\n";
				
				$installed_a_version = true;
				
				// fetch update from server
				if($rc)
					$handle = fopen($server."/update.php?type=system&version=".$update_version_arr[$y]."&rc=true&remote_domain=".$_SERVER['HTTP_HOST'], "r");
				else 
					$handle = fopen($server."/update.php?type=system&version=".$update_version_arr[$y]."&remote_domain=".$_SERVER['HTTP_HOST'], "r");
				if($handle)
				{
					$raw_update = '';
					while (!feof($handle)) {
				  	$raw_update .= fread($handle, 8192);
					}
					fclose($handle);

					// install update
					if(!$TEST_SITE)
						do_update($raw_update, $update_version_arr[$y]);
				}
				else 
				{
					syslog(LOG_ERR, "Unable to get update from server. (Update version: ".$update_version_arr[$y].")");
					echo "Unable to get update from server. (Update version: ".$update_version_arr[$y].")";
					$y = count($update_version_arr);
				}
			}
		}
		if(!$installed_a_version)
		{
			$str .= "					<tr>\n";
			$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
			$str .= "						<td class='module' colspan='2'><br>".lang("You already have the newest version installed.")."</td>\n";
			$str .= "					</tr>\n";
			
			// check to se if there is an rc update
			$handle = fopen($server."/update.php?type=system_rc_version", "r");
			$update_version = '';
			while (!feof($handle)) 
			{
	  		$update_version .= fread($handle, 8192);
			} 
			fclose($handle);			
			
			if($update_version != "false")
			{
				if(compare_version_numbers($SYSTEM_VERSION, $update_version))
				{
					$str .= "					<tr>\n";
					$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
					$str .= "						<td class='module' colspan='2'>".lang("But there is a new releace candidate (RC) update.")."<br><br></td>\n";
					$str .= "					</tr>\n";				 
					$str .= "					<tr>\n";
					$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
					$str .= "						<td class='module' colspan='2'>";
					$str .= "							".lang("Do you wan't to install the RC update?");
					$str .= "							<a href='".$url[0]."?a=online_rc&amp;server=".$_POST["server"]."'>".lang("Yes")."</a></td>\n";
					$str .= "					</tr>\n";				
				}
			}
		}
		else 
		{
			$str .= "					<tr>\n";
			$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
			$str .= "						<td class='module' colspan='2'>".lang("<br>The system is now upgraded. You can continue your work and explore the new features and fixes.<br>If you woukd like to se the change log it can be found")."&nbsp;<a href=\"../../CHANGES.txt\" target=\"_new_\">".lang("here")."</a></td>\n";
			$str .= "					</tr>\n";		
		}
	}
	else
	{
		$str .= "					<tr>\n";
		$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
		$str .= "						<td class='module' colspan='2'>".lang("There is no new updates on the server.")."</td>\n";
		$str .= "					</tr>\n";
		
		// check to se if there is an rc update
		$handle = fopen($server."/update.php?type=system_rc_version", "r");
		$update_version = '';
		while (!feof($handle)) 
		{
  		$update_version .= fread($handle, 8192);
		} 
		fclose($handle);			
		
		if($update_version != "false")
		{
			if(compare_version_numbers($SYSTEM_VERSION, $update_version))
			{
				$str .= "					<tr>\n";
				$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
				$str .= "						<td class='module' colspan='2'>".lang("But there is a new releace candidate (RC) update.")."<br><br></td>\n";
				$str .= "					</tr>\n";				 
				$str .= "					<tr>\n";
				$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
				$str .= "						<td class='module' colspan='2'>";
				$str .= "							".lang("Do you wan't to install the RC update?");
				$str .= "							<a href='".$url[0]."?a=online_rc&amp;server=".$server."'>".lang("Yes")."</a></td>\n";
				$str .= "					</tr>\n";				
			}
		}
	}

	$str .= "				</table>\n";
	$str .= "			</form>\n";
	
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";	
	
	$str .= "</div>\n";
	
	
	
	
	return $str;
}

function update_upload_get_file()
{
	global $db, $DEBUG, $PHP_SELF, $SITE_TEMPLATE, $SITE_NAME, $SYSTEM_VERSION;

	$url = explode("?", $PHP_SELF);
	
	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";

	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top' width='300' align='center'>\n";
	$str .= "			<br>";

	$str .= "			<form ENCTYPE='multipart/form-data' action='".$url[0]."?a=get&i=".$id."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formUpdate'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0'>\n";
	
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module' colspan='2'><b>Sorry!</b><br>This method is not inplemented yet.</td>\n";
	$str .= "					</tr>\n";

	$str .= "				</table>\n";
	$str .= "			</form>\n";
	
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";	
	
	$str .= "</div>\n";
	
	return $str;
}


switch($_GET["a"])
{
	case "two":
		if($_POST["update_method"] == "upload")
			$str = update_upload_get_file();
		else
			$str = update_online_server();
		break;
		
	case "online":
		$str = update_online();
		break;
	case "online_rc":
		$str = update_online("true");
		break;
		
	case "online_status":
		$str = upload_online();
		break;
		
	// default show list
	default:
		$str = update_method();
		break;
}

echo str_replace("##MODULE##", $str, $module_template);
?>