<?PHP
/*******************************************************************
 *  cmsWorks                                                       *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  2.1.2                                                *
 *	Modified: 2006-02-05 22:18                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *    Peter Drengsgaard (peter[at]raichu.dk)                    	 *
 *******************************************************************/
 
include_once("../include/lib.module.php");				// include the std stuff 
include_once("../include/class.gallery.php");			// gallery class 

function _update_module()
{
	global $db;
	
	filesystem_mkdirRecursive("../../files/gallery");	
	
	$version = module_version("Gallery");

	// install db
	if($version == "no module" OR $version == "")
	{
		$sql[0] = "CREATE TABLE `web_gallery` (
								`UseComments` enum('yes','no'),
  							`Columns` varchar(255) NOT NULL default '1',
								`Email` varchar(255) NOT NULL default 'webmaster@yoursite.com' 
							);";		
		$sql[1] = "CREATE TABLE `web_gallery_dirs` (
  							`ID` int(32) NOT NULL auto_increment,
  							`Name` varchar(200) NOT NULL default '',
							  `Headline` varchar(255) NOT NULL default '',
							  `Comment` varchar(255) NOT NULL default '',
							  `Path` varchar(255) NOT NULL default '',
							  `IndexNo` int(11) NOT NULL default '',
							  PRIMARY KEY  (`ID`)
							);";
		$sql[2] = "CREATE TABLE `web_gallery_pics` (
  							`ID` int(32) NOT NULL auto_increment,
								`DirID` int(32) NOT NULL,
  							`Filename` varchar(255) NOT NULL default '',
							  PRIMARY KEY  (`ID`)
							);";
		$sql[3] = "CREATE TABLE `web_gallery_comments` (
  							`ID` int(32) NOT NULL auto_increment,
								`PicID` int(32) NOT NULL,
  							`Comment` varchar(255) NOT NULL default '',
								`Name` varchar(255) NOT NULL default '',
							  PRIMARY KEY  (`ID`)
							);";
		
		for($x = 0; $x < count($sql); $x++)
			mysql_query($sql[$x], $db);
		echo mysql_error();
		
		module_version_update("Gallery", "1.0.0");
	}

	if($version <= "1.0.0")
	{
		// removw all dir entryes, so they can be generated from new
		$sql[] = "DELETE FROM web_gallery_dirs";
		$sql[] = "DELETE FROM web_gallery_pics";
		for($x = 0; $x < count($sql); $x++)
			mysql_query($sql[$x], $db);
		echo mysql_error();
		
		module_version_update("Gallery", "1.0.1");
	}
	
	if($version == "1.0.1")
	{
		$sql[] = "UPDATE `admin_modules` SET `Width` = '750' WHERE `Name` ='Gallery' LIMIT 1";
		for($x = 0; $x < count($sql); $x++)
			mysql_query($sql[$x], $db);
		echo mysql_error();
		
		module_version_update("Gallery", "1.0.2");
	
	}
}
_update_module();

function _web_gallery_check_dirs()
{
	global $db;
	
	// make shure the overview dir is there. This is the basedir so it is always there
	$rs = mysql_query("SELECT ID FROM web_gallery_dirs WHERE Path='.'", $db);
	if(!$row = mysql_fetch_row($rs))
	{
		mysql_query("INSERT INTO web_gallery_dirs (ID, ParrentID, Name, Path) VALUES('1', '0', 'Overview', '.')");
		echo mysql_error();	
	}	
	
	// get actual file dir list
	$g = new GALLERY();
	$g->GALLERY_scan_for_dirs($g->base_dir);

	// hold the dirs that are in the db and on the filesystem
	$dirs_ok = array(".");
	
	// find dirs in db
	$rs = mysql_query("SELECT ID, Path FROM web_gallery_dirs", $db);
	while($row = mysql_fetch_row($rs))
	{
		// check if its there
		if(!in_array($row[1], $g->dir_array))	
		{
			// remove dir, pics and comments for this dir
			mysql_query("DELETE FROM web_gallery_dirs WHERE ID='".$row[0]."'", $db);
			$rs_pic = mysql_query("SELECT ID FROM web_gallery_pics WHERE DirID='".$row[0]."'", $db);
			while($row_pic = mysql_fetch_row($rs_pic))
				mysql_query("DELETE FROM web_gallery_comment WHERE PicID='".$row_pic[0]."'", $db);
			mysql_query("DELETE FROM web_gallery_pics WHERE DirID='".$row[0]."'", $db);
		}
		else
		{
			// remove this dir from $dir
			array_push($dirs_ok, $row[1]);
		}
	}
	
	// check to se if there is som new dirs on the filesystem
	foreach ($g->dir_array as $value)
	{		
		if(!in_array($value, $dirs_ok))
		{
			// get dir without path
			$tmp = explode("/", $value);
			$dir = $tmp[(count($tmp)-1)];
			
			// get parrent name
			$parrent = str_replace("$dir", "", $value);
			// check if this is a root dir
			if($parrent == "")
				$parrent_id = 1;
			else
			{
				// make sure there is no / at the end of the parrent path
				if(substr($parrent, -1) == "/")
					$parrent = substr($parrent, 0, -1);
				
				// find parrent id in db
				$rs = mysql_query("SELECT ID FROM web_gallery_dirs WHERE Path='".$parrent."'", $db);
				if($row = mysql_fetch_row($rs))
					$parrent_id = $row[0];
				else
					echo "<br>ERROR: could not find parrent for '".$value."'!";
					 
			}
			// inset it into the dir table in db
			if($parrent_id >= 0)
			{
				$sql  = "INSERT INTO web_gallery_dirs (ParrentID, Name, Headline, Path)";
				$sql .= " VALUES('".$parrent_id."', '".$dir."', '".$dir."', '".$value."')";
				mysql_query($sql, $db);
			} 
		}
	}
}

function _web_gallery_check_pics($base_dir, $dir_id)
{
	global $db;
	
	// set status true
	$status = true;
				
	// relative gallery dir
	$dir = str_replace("files/galley/", "", $base_dir);
	
	if(is_dir($base_dir))
	{
		// open basedir
		if($handle = opendir($base_dir)) 
		{
			// read content
			while(false !== ($file = readdir($handle))) 
			{
				// the file is not a dir then we are interested
				if ($file != "." && $file != ".." && !(fileperms("$base_dir/$file") & 0x4000) == 0x4000)
				{
					// compare with db
					$rs = mysql_query("SELECT ID FROM web_gallery_pics WHERE DirID='".$dir_id."' AND Filename='".$file."'", $db);
					if(!$row = mysql_fetch_row($rs))	
						$status = false;
				}
			}
		}
	}
	
	return $status;
}

function web_gallery_list($order, $limitfrom, $search, $variable = "" )
{
	global $db, $ADMIN_NAME, $ADMIN_TEMPLATE, $PHP_SELF;
  
	// make check on dirs
	_web_gallery_check_dirs();
	
	if($order != "Path" AND $order != "Name" AND $order != "IndexNo")
		$order = "Path";
	
	if(empty($order))
		$order = "Path";	// the sql col to order by default
	
	$url = explode("?", $PHP_SELF);

	$module = new MODULE;
	 
	// tools
	$module->MODULE_add_tool($url[0], "Reload", "reload.icon.png");	// reload the list
	$module->MODULE_add_tool($url[0]."?a=r&o=".$order."&s=".$search."&v=".$variable, "Requested&nbsp;deleted", "delete.icon.png");
	$module->MODULE_add_tool($url[0]."?a=c&s=".$search."&v=".$variable, "Comments", "new.icon.png");	// comments
	$module->MODULE_add_tool($url[0]."?a=u&o=".$order."&s=".$search."&v=".$variable, "Upload", "save.icon.png");	// upload a pciture

	// list header  
	$module->MODULE_add_header("Name", "Name", "160");
	$module->MODULE_add_header("Path", "Path", "250");	
	$module->MODULE_add_header("IndexNo", "Index", "40");	
	
	// limit stuff
	if(empty($limitoff))
	{
		$sql  = "SELECT";
		$sql .= " COUNT(ID) ";
		$sql .= "FROM web_gallery_dirs ";
		if(!empty($search))
			$sql .= " WHERE Name LIKE '%".$search."%' OR Headline LIKE '%".$search."%' OR Path LIKE '%".$search."%'";	
		$rs_limitoff = mysql_query($sql, $db);
		$row_limitoff = mysql_fetch_row($rs_limitoff);
		$limitoff = ceil($row_limitoff[0] / $module->listMaxRows);
	}
	
	if(empty($limitfrom) OR $limitfrom > $limitoff)
		$limitfrom = 1;

	// find alle users to generate a list
	$sql  = "SELECT";
	$sql .= " ID, Name, Headline, Path, IndexNo "; 
	$sql .= "FROM web_gallery_dirs ";
	if(!empty($search))
		$sql .= " WHERE Name LIKE '%".$search."%' OR Headline LIKE '%".$search."%' OR Path LIKE '%".$search."%' ";	// replace the columns whiths the colums you want to search
	$sql .= "ORDER BY ".$order.",IndexNo";
	$sql .= " LIMIT ".(($limitfrom-1)*$module->listMaxRows).",".$module->listMaxRows;
	$rs = mysql_query($sql, $db);
	echo mysql_error();

	$g = new GALLERY();
	
	while($row = mysql_fetch_row($rs))
	{
		// make the list
		$modrow["values"][0] = $row[1];		// value 1 in row
		$modrow["values"][1] = $row[3];		// value 2 in row
		$modrow["values"][2] = $row[4];		// value 3 in row
		$modrow["id"] = $row[0];	// the id if the row
		$modrow["name"] = $row[1];	// the name shown when you want to delete a row
		
		if(!$g->GALLERY_check_dir("$g->base_dir/$row[3]", "STATUS") OR !_web_gallery_check_pics("$g->base_dir/$row[3]", $row[0]))
		{
			$modrow["links"][0]["link"] = $url[0]."?a=g&i=".$row[0]."&o=".$order."&s=".$search."&v=".$variable."&lf=".$limitfrom;
			$modrow["links"][0]["icon"] = "reload.icon.png";
			$modrow["links"][0]["name"] = "Generate";
		}
		else
		{
			$modrow["links"][0]["link"] = $url[0]."?a=p&i=".$row[0]."&o=".$order."&s=".$search."&v=".$variable."&lf=".$limitfrom;
			$modrow["links"][0]["icon"] = "kmenuedit.crystal.apps.icon.png";
			$modrow["links"][0]["name"] = "Pictures";
		}
		
		array_push($module->list, $modrow);
	}

	$str .= $module->MODULE_generate_list($order, $limitfrom, $limitoff, $search);
	
	return $str;
}

function web_gallery_comment_list($order, $limitfrom, $search, $variable = "" )
{
	global $db, $ADMIN_NAME, $ADMIN_TEMPLATE, $PHP_SELF;

	if($order != "Created" AND $order != "Name" AND $order != "Comment")
		$order = "Created";

	if(empty($order))
		$order = "Created";	// the sql col to order by default
	
	$url = explode("?", $PHP_SELF);

	$module = new MODULE;
	 
	// tools
	$module->MODULE_add_tool($url[0], "Back", "back.icon.png");
	$module->MODULE_add_tool($url[0]."?a=c&s=".$search."&v=".$variable, "Reload", "reload.icon.png");	// reload the list

	// list header  
	$module->MODULE_add_header("Created", "Date", "90");	
	$module->MODULE_add_header("Name", "Name", "70");	
	$module->MODULE_add_header("Comment", "Comment", "420");	
	
	// limit stuff
	if(empty($limitoff))
	{
		$sql  = "SELECT";
		$sql .= " COUNT(ID) ";
		$sql .= "FROM web_gallery_comments ";
		if(!empty($search))
			$sql .= " WHERE Name LIKE '%".$search."%' OR Created LIKE '%".$search."%' OR Comment LIKE '%".$search."%'";	
		$rs_limitoff = mysql_query($sql, $db);
		$row_limitoff = mysql_fetch_row($rs_limitoff);
		$limitoff = ceil($row_limitoff[0] / $module->listMaxRows);
	}
	
	if(empty($limitfrom) OR $limitfrom > $limitoff)
		$limitfrom = 1;

	// find alle users to generate a list
	$sql  = "SELECT";
	$sql .= " ID, Name, DATE_FORMAT(Created, '%Y %c-%d'), Comment, Confirmed "; 
	$sql .= "FROM web_gallery_comments ";
	if(!empty($search))
		$sql .= " WHERE Name LIKE '%".$search."%' OR Created LIKE '%".$search."%' OR Comment LIKE '%".$search."%'";	// replace the columns whiths the colums you want to search
	$sql .= "ORDER BY ".$order;
	$sql .= " LIMIT ".(($limitfrom-1)*$module->listMaxRows).",".$module->listMaxRows;
	$rs = mysql_query($sql, $db);
	echo mysql_error();
	
	while($row = mysql_fetch_row($rs))
	{
		// make the list
		$modrow["values"][0] = $row[2];		// value 1 in row
		$modrow["values"][1] = $row[1];		// value 2 in row
		$modrow["values"][2] = $row[3];		// value 3 in row
		$modrow["id"] = $row[0];	// the id if the row
		$modrow["name"] = $row[2].", ".$row[1];	// the name shown when you want to delete a row
		
		$module->listEdit = "no";
		$module->listDelete = "no";
		
		if($row[4] !="no")
		{
			$modrow["links"][1]["link"] = $url[0]."?a=cc&i=".$row[0]."&o=".$order."&s=".$search."&v=".$variable."&lf=".$limitfrom;
			$modrow["links"][1]["icon"] = "kmenuedit.crystal.apps.icon.png";
			$modrow["links"][1]["name"] = "Confirm";
		}
		
	
		$modrow["links"][0]["link"] = $url[0]."?a=cd&i=".$row[0]."&o=".$order."&s=".$search."&v=".$variable."&lf=".$limitfrom;
		$modrow["links"][0]["icon"] = "delete.icon.png";
		$modrow["links"][0]["name"] = "Delete";
		
		array_push($module->list, $modrow);
	}

	$str .= $module->MODULE_generate_list($order, $limitfrom, $limitoff, $search, "", "c");
	
	return $str;
}

function web_gallery_edit($id, $order, $limitfrom, $search, $error = "")
{
	global $db, $PHP_SELF, $SITE_TEMPLATE, $SITE_NAME;

	$url = explode("?", $PHP_SELF);

	if(!empty($id))
	{
		// get user information
		$sql  = "SELECT";
		$sql .= " Name ";
		$sql .= "FROM web_gallery_dirs ";
		$sql .= "WHERE";
		$sql .= " ID = '".$id."'";
	
		$rs = mysql_query($sql, $db);
		$row = mysql_fetch_row($rs);
		echo mysql_error();
	}

	$module = new MODULE();
	
	$str = $module->MODULE_edit_js();
	
	// toolbar
	$module->MODULE_add_tool("javascript: do_back();", "Back", "back.icon.png");
	$module->MODULE_add_tool("javascript: do_delete(\"".$id."\", \"".$row[2]."\");", "Delete", "delete.icon.png");
	$module->MODULE_add_tool("javascript: do_form_check();", "Save", "save.icon.png");
	$module->toolsearch = "no";

	$str .= $module->MODULE_generate_toolbar($order, $search, $limitfrom, $language);

	
	// add elements
	// headline
	$module->MODULE_edit_add_elements("Folder", "", "head"); 
	// name
	$module->edit_value = $row[0];
	$module->MODULE_edit_add_elements("Name", "Name", "text");
	
	// generate data
	$str .= $module->MODULE_edit_generate($id, $order, $limitfrom, $search);
	
	return $str;
}

// delete folder and subfolders
function web_gallery_delete($id)
{
	global $db;
	
	// find path
	$rs_path = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID='".$id."'", $db);
	$row_path = mysql_fetch_row($rs_path);
	
	// delete files from folder
	$rs_files = mysql_query("SELECT Filename FROM web_gallery_pics WHERE DirID='".$id."'", $db);
	while($row_files = mysql_fetch_row($rs_files))
	{
		unlink("../../files/gallery/".$row_path[0]."/".$row_files[0]);
	}
	
	// delete files from db
	mysql_query("DELETE FROM web_gallery_pics WHERE DirID='".$id."'", $db);
	
	// if there is no sub folders and the folder is not root then delete it
	if($id != 1)
	{
		// check for subdirs
		$rs_sub = mysql_query("SELECT ID FROM web_gallery_dirs WHERE ParrentID='".$id."'", $db);
		$row_sub = mysql_fetch_row($rs_sub);
		if(empty($row_sub[0]))
		{
			// delete the dir
			mysql_query("DELETE FROM web_gallery_dirs WHERE ID='".$id."'", $db);
			echo mysql_error();
						
			// remove the directory
			rmdir("../../files/gallery/$row_path[0]");
		}
	}
	
}

function web_gallery_save($id)
{
	global $db, $ADMIN_NAME, $Picture, $Picture_name;

	mysql_query("UPDATE web_gallery_dirs SET Headline='".$_POST["Name"]."' WHERE ID='".$id."'", $db);
	echo mysql_error();	
	
	return $id;
}

// generate the thumbs in the given dir
function web_gallery_generate_thumbs($id)
{
	global $db, $SITE_TEMPLATE;
	
	// finde the path
	$rs = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID='".$id."'", $db);
	if($row = mysql_fetch_row($rs))
	{
		$g = new GALLERY();

		// get list of files to be added
		$pic_array = $g->GALLERY_check_dir("$g->base_dir/$row[0]", "ALL");
		
		// add pics to db
		foreach ($pic_array as $value) 
		{
			// check if the picture is in the db
			$rs_check = mysql_query("SELECT ID FROM web_gallery_pics WHERE DirID='".$id."' AND Filename='".$value."' ORDER BY ID DESC", $db);
			$check_count = mysql_num_rows($rs_check);
			if($row_check = mysql_fetch_row($rs_check) AND $check_count > 1)
			{
				// make shure the file is not there more then once
				for($x = 1; $x < $check_count; $x++)
					mysql_query("DELETE FROM web_gallery_pics WHERE ID='".$row_check[0]."'", $db);
			}
			else 
			{
				mysql_query("INSERT INTO web_gallery_pics (DirID, Filename) VALUES('".$id."', '".$value."')", $db);
			}
			echo mysql_error();
		}
		
		// include the theme to get info about size and logo
		include_once("../../themes/".$SITE_TEMPLATE."/theme.cfg");
		
		// set size vars	
		$size["dir-width"] 	= $Theme["Gallery"]["DirPicMaxWidth"];
		$size["dir-height"] = $Theme["Gallery"]["DirPicMaxHeight"];
		$size["pic-width"] 	= $Theme["Gallery"]["PicWidth"];
		$size["pic-height"] = $Theme["Gallery"]["PicHeight"];
	
		// logo
		$logo["file"] 		= $Theme["Gallery"]["LogoPic"];
		$logo["location"]	= $Theme["Gallery"]["LogoLocation"];
		
		$g->GALLERY_generate_thumbs($row[0], $size, $logo);
	}
}

function web_gallery_upload()
{
	
	global $db;
		
	
	$module = new MODULE();
	$module->MODULE_add_tool("javascript: do_back();", "Back", "back.icon.png");
	$module->MODULE_add_tool("javascript: do_delete(\"".$id."\", \"".$row[0]."\");", "Delete", "delete.icon.png");
	$module->MODULE_add_tool("javascript: document.formModule.submit();", "Upload", "save.icon.png");
	$module->MODULE_add_tool($url[0]."?a=md&o=".$order."&s=".$search."&v=".$variable, "Make Dir.", "save.icon.png");	// make a dir.

	// if the search bar is not to be shown
	$module->toolsearch = "no";
	
	$str .= $module->MODULE_generate_toolbar($order, $search, $limitfrom, $language);

	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight - 29);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight - 58);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";
	
	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top'>\n";

	$str .= "			<form ENCTYPE='multipart/form-data' action='".$url[0]."?a=us&i=".$id."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formModule'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0'>\n";
	if(!empty($error))
		$str .= "					<tr><td class='module' colspan='3'>".lang("Wrong file format!")."</td></tr>\n";
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='moduleHead' colspan='2'>".lang("Picture")."</td>\n";
	$str .= "					</tr>\n";

	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Folder")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>\n";
	$str .= "							<select name='Folder' class='moduleInputSelect'>\n";
	$rs_groups = mysql_query("SELECT ID, Name, Headline FROM web_gallery_dirs ORDER BY Name", $db);
	while($row_dirs = mysql_fetch_row($rs_groups))
	{
		if ($row_dirs[0] == 1)
			$str .= "								<option value='".$row_dirs[0]."'>".$row_dirs[2]."</option>\n";
		else 
			$str .= "								<option value='".$row_dirs[0]."'>".$row_dirs[2].'&nbsp;('.$row_dirs[1].")</option>\n";
	}

	$str .= "							</select>\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";		
  $str .= "					<tr>\n";
	$str .= "						<td collspan='3'>&nbsp;</td>";
  $str .= "					</tr>\n";		
  $str .= "					<tr><td class='module' colspan='2'>&nbsp;</td><td class='module' colspan='1'>".lang("The folowing formats are accepted").": <b>Jpg, Png</b>.</td></tr>\n";

  $str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Picture")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='file' name='Picture[]' size='45' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";	

	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Picture")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='file' name='Picture[]' size='45' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";	
	
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Picture")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='file' name='Picture[]' size='45' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";	
	
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Picture")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='file' name='Picture[]' size='45' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";	
	
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Picture")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='file' name='Picture[]' size='45' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";	

	$str .= "					<tr><td class='module'>&nbsp;</td><td class='moduleBottom' colspan='2'>&nbsp;</td></tr>\n";		
	$str .= "				</table>\n";
	$str .= "			</form>\n";
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";	
	
	$str .= "</div>\n";
	
	return $str;
}

function web_gallery_upload_save()
{
	global $db;
	
	// Get subfolders when saveing pictures
	$id = $_POST["Folder"];
	
	if ($id != "1")
	{
		$rs_dir = mysql_query("SELECT ParrentID, Name FROM web_gallery_dirs WHERE ID ='$id'", $db);
		$row_dir = mysql_fetch_row($rs_dir);
		$ParrantID = $row_dir[0];
		$folder = $row_dir[1];
		
		while ($ParrantID != 0)
		{		
			$rs_dir = mysql_query("SELECT ID, ParrentID, Name FROM web_gallery_dirs WHERE ID ='$ParrantID'", $db);
			$row_dir = mysql_fetch_row($rs_dir);
	
			if ($row_dir[0] != "1") 
				$folder = $row_dir[2]."/".$folder;	
			$ParrantID = $row_dir[1];
			$id = $row_dir[0];
		}
	}
	
	foreach ($_FILES["Picture"]["error"] as $key => $error) 
	{
   	if ($error == UPLOAD_ERR_OK) 
   	{
       $tmp_name = $_FILES["Picture"]["tmp_name"][$key];
       $name = $_FILES["Picture"]["name"][$key];
       copy($tmp_name, "../../files/gallery/$folder/$name");
   	}
	}
}


function web_gallery_makedir()
{
	global $db;
		
	$module = new MODULE();
	$module->MODULE_add_tool("javascript: do_back();", "Back", "back.icon.png");
	$module->MODULE_add_tool("javascript: do_delete(\"".$id."\", \"".$row[0]."\");", "Delete", "delete.icon.png");
	$module->MODULE_add_tool("javascript: document.formModule.submit();", "Makedir", "save.icon.png");

	// if the search bar is not to be shown
	$module->toolsearch = "no";
	
	$str .= $module->MODULE_generate_toolbar($order, $search, $limitfrom, $language);

	// make div so that scrolling is on it
	$str .= "<div style='overflow: auto;' id='bodyDiv'>\n";
	$str .= "	<script>\n";
	$str .= "		if (document.all)\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.clientHeight - 29);\n";
	$str .= "		}\n";
	$str .= "		else\n";
	$str .= "		{\n";
	$str .= "			document.getElementById('bodyDiv').style.height = '100%';\n";
	$str .= "			document.getElementById('bodyDiv').style.height = (document.body.offsetHeight - 58);\n";
	$str .= "		}\n";
	$str .= "	</script>\n";
	
	$str .= "<table cellpadding='0' cellspacing='3'>\n";
	$str .= "	<tr>\n";
	$str .= "		<td valign='top'>\n";

	$str .= "			<form ENCTYPE='multipart/form-data' action='".$url[0]."?a=mds&i=".$folder_name."&o=".$order."&ls=".$limitfrom."&s=".$search."' method='post' name='formModule'><br>\n";
	$str .= "				<input type='hidden' name='Changed' value='no'>\n";
	$str .= "				<table cellpadding='3' cellspacing='0'>\n";
	if(!empty($error))

	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Folder")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'><input type='text' name='folder_name' size='45' class='moduleInputText'></td>\n";
	$str .= "					</tr>\n";	
	
	$str .= "					<tr>\n";
	$str .= "						<td class='module'>&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>".lang("Select subolder")."&nbsp;&nbsp;</td>\n";
	$str .= "						<td class='module'>\n";
	$str .= "							<select name='subfolder' class='moduleInputSelect'>\n";
	$rs_groups = mysql_query("SELECT ID, Name, Path, Headline FROM web_gallery_dirs ORDER BY Name", $db);
	while($row_dirs = mysql_fetch_row($rs_groups))
	{
		if ($row_dirs[0] == 1)
			$str .= "								<option value='".$row_dirs[2]."'>".$row_dirs[3]."</option>\n";
		else 
			$str .= "								<option value='".$row_dirs[2]."'>".$row_dirs[3].'&nbsp;('.$row_dirs[1].")</option>\n";
	}

	$str .= "							</select>\n";
	$str .= "						</td>\n";
	$str .= "					</tr>\n";		
	
	$str .= "					<tr><td class='module'>&nbsp;</td><td class='moduleBottom' colspan='2'>&nbsp;</td></tr>\n";		
	$str .= "				</table>\n";
	$str .= "			</form>\n";
	$str .= "		</td>\n";
	$str .= "	</tr>\n";
	$str .= "</table>\n";	
	
	$str .= "</div>\n";
	
	return $str;
}

function web_gallery_makedir_save()
{
	global $db;

	if(!is_dir('../../files/gallery/'.$_POST["folder_name"]))
		mkdir('../../files/gallery/'.$_POST["subfolder"].'/'.$_POST["folder_name"]);
}

function web_gallery_pictures($id, $order, $limitfrom, $search, $variable = "" )
{
	
	global $db;

	if($order != "Id" AND $order != "Filename")
		$order = "Id";

	if(empty($order))
		$order = "Id";	// the sql col to order by default
	
	$url = explode("?", $PHP_SELF);

	$module = new MODULE;
	 
	// tools
	$module->MODULE_add_tool($url[0], "Back", "back.icon.png");

	// list header  
	$module->MODULE_add_header("Filename", "Filename", "100");	
	$module->MODULE_add_header("Path", "File Path", "70");	
	
	// find the path of the dir.
	$rs = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID ='".$id."'", $db);
	$row = mysql_fetch_row($rs);
	
	$rs_pic = mysql_query("SELECT ID, Filename FROM web_gallery_pics WHERE DirID = '".$id."'", $db);
	while($row_pic = mysql_fetch_row($rs_pic))
	{
		// get picture size
		list($rWidth, $rHeight, $FileType, $Attr) = getimagesize("../../files/gallery/".$row[0]."/".$row_pic[1]);				
		
		// define max pictue size
		if($rWidth > "300")
		{
			$faktor = ($rWidth / "300");
			$s_rHeight = ($rHeight / $faktor);
			$s_rWidth = "300"	;
			
			settype($s_rWidth, "integer"); 
			settype($s_rHeight, "integer");
		}
		else
		{
			$s_rWidth = $rWidth;
			$s_rHeight = $rHeight;
		}
		// make the list
		$modrow["values"][0] = "<img width='".$s_rWidth."' height='".$s_rHeight."' src='../../picture.php?fID=".$row_pic[0]."' alt='".$row_pic[1]."'>";		// value 1 in row
		$modrow["id"] = $row_pic[0];	// the id if the row
		$modrow["name"] = $row_pic[1];	// the name shown when you want to delete a row
		
		$module->listEdit = "no";
		$module->listDelete = "no";
		
		$modrow["links"][0]["link"] = $url[0]."?a=pd&i=".$row_pic[0]."&o=".$order."&s=".$search."&v=".$variable."&lf=".$limitfrom;
		$modrow["links"][0]["icon"] = "delete.icon.png";
		$modrow["links"][0]["name"] = "Delete";

		$modrow["links"][1]["link"] = $url[0]."?a=rotate&rotate=left&d=".$id."&i=".$row_pic[0]."&o=".$order."&s=".$search."&v=".$variable."&lf=".$limitfrom;
		$modrow["links"][1]["icon"] = "reload.icon.png";
		$modrow["links"][1]["name"] = "Rotate Left";		

		$modrow["links"][2]["link"] = $url[0]."?a=rotate&rotate=right&d=".$id."&i=".$row_pic[0]."&o=".$order."&s=".$search."&v=".$variable."&lf=".$limitfrom;
		$modrow["links"][2]["icon"] = "reload.icon.png";
		$modrow["links"][2]["name"] = "Rotate Right";		
		
		array_push($module->list, $modrow);
	}

	$str .= $module->MODULE_generate_list($order, $limitfrom, $limitoff, $search, "", "c");
	
	return $str;
	
}

function  web_gallery_pictures_delete($id)
{
	global $db;
	
	$rs_pic = mysql_query("SELECT DirID, Filename FROM web_gallery_pics WHERE ID ='".$id."'", $db);	
	$row_pic = mysql_fetch_row($rs_pic);
	
	$rs = mysql_query("SELECT Path, ID FROM web_gallery_dirs WHERE ID = '".$row_pic[0]."'", $db);
	$row =  mysql_fetch_row($rs);

	if(is_file("../../files/gallery/".$row[0]."/".$row_pic[1]))
	{
		unlink("../../files/gallery/".$row[0]."/".$row_pic[1]);
		mysql_query("DELETE FROM web_gallery_pics WHERE ID = '".$id."'", $db);
		echo mysql_error();
	}
	
	return $row[1];
}

function web_gallery_rotate_image($dir, $file, $rotate_value, $rotate = "right") 
{
	global $db, $SITE_TEMPLATE;
	
	include_once("../../themes/".$SITE_TEMPLATE."/theme.cfg");
	
	$ext = substr($file, -3);

	if(strtolower($ext) == "jpg")
		$source = imagecreatefromjpeg($dir."/".$file);
	else if(strtolower($ext) == "png")
		$source = imagecreatefrompng($dir."/".$file);
	
	if($rotate != "left") 
		$rotate_value = $rotate_value*-1;

	$source = imageRotate($source, $rotate_value, 0);

	
	if(strtolower($ext) == "jpg")
		imagejpeg($source, $dir."/".$file, 100);
	else if(strtolower($ext) == "png")
		imagepng($source, $dir."/".$file, 100);

	// dir thumb		
	$thumb = new GALLERY();
	$thumb->GALLERY_resize_img("$dir/$file", "$dir/thumbs/d-$file", $Theme['Gallery']['DirPicMaxHeight'], $Theme['Gallery']['DirPicMaxWidth'], $Theme['Gallery']['LogoPic'] );	
	$thumb->GALLERY_resize_img("$dir/$file", "$dir/thumbs/p-$file", "", $Theme['Gallery']['PicWidth'], $Theme['Gallery']['LogoPic'] );	
}

switch($_GET["a"])
{
	// comment confirm
	case "cc":
		$sql = "UPDATE `web_gallery_comments` SET `Confirmed` = 'no' WHERE `ID` = '".$_GET["i"]."'";
		mysql_query($sql, $db);
		$str = web_gallery_comment_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// comment delete
	case "cd":
		$sql = "DELETE FROM `web_gallery_comments` WHERE ID = '".$_GET["i"]."'";
		mysql_query($sql, $db);
		$str = web_gallery_comment_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// comment 
	case "c":
		$str = web_gallery_comment_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// make dir.
	case "md":
		$str = web_gallery_makedir();
		break;
	// make dir. save
	case "mds":
		$str = web_gallery_makedir_save();
		_web_gallery_check_dirs();
		$str = web_gallery_upload();
		break;
	// upload
	case "u":
		$str = web_gallery_upload();
		break;
	// upload save
	case "us":
		$str = web_gallery_upload_save();
		$str = web_gallery_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;	
	// edit
	case "e":
		$str = web_gallery_edit($_GET["i"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// save
	case "s":
		$ret = web_gallery_save($_GET["i"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		$str = web_gallery_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// delete
	case "d":
		web_gallery_delete($_GET["i"]);
		$str = web_gallery_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	case "g":
		web_gallery_generate_thumbs($_GET["i"]);
		$str = web_gallery_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;	
	// delete pictures from the list
	case "pd":
		$dir_id = web_gallery_pictures_delete($_GET["i"]);
		$str = web_gallery_pictures($dir_id, $_GET["o"], $_GET["lf"], $_GET["s"]);
		break;	
	// list the pictures
	case "p":
		$str = web_gallery_pictures($_GET["i"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	case "rotate":		
		$rs_file = mysql_query("SELECT Filename, DirID FROM web_gallery_pics WHERE ID='".$_GET["i"]."'", $db);
		$row_file = mysql_fetch_row($rs_file);
		if($row_file[1] != 0)
		{
			$rs_dir = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID='".$row_file[1]."'", $db);
			$row_dir = mysql_fetch_row($rs_dir);
		}
		
		web_gallery_rotate_image("../../files/gallery/".$row_dir[0], $row_file[0], 90, $_GET["rotate"]);
		$str = web_gallery_pictures($_GET["d"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		break;

	// default show list
	default:
		$str = web_gallery_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
}

echo str_replace("##MODULE##", $str, $module_template);
?>