<?PHP
/*******************************************************************
 *  cmsWorks - web languages module                                *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.0.7                                                *
 *	Modified: 2006-01-25 05:45                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/

include_once("../include/lib.module.php");	// include the std stuff 

function _update_module()
{
	global $db;
	
	$version = module_version("Languages");
	
	if($version == "")
		module_version_update("Languages", "1.0.0");
}
_update_module();

function web_languages_list($order, $limitfrom, $search, $variable = "" )
{
	global $db, $ADMIN_NAME, $ADMIN_TEMPLATE, $PHP_SELF;
  
	if(empty($order))
		$order = "Language";	// the sql col to order by default
	
	$url = explode("?", $PHP_SELF);

	$module = new MODULE;
	 
	// tools
	$module->MODULE_add_tool($url[0]."?a=e&o=".$order."&s=".$search."&v=".$variable, "New", "new.icon.png");	// new link
	$module->MODULE_add_tool($url[0], "Reload", "reload.icon.png");	// reload the list

	// list header  
	$module->MODULE_add_header("Language", "Language", "100");
	$module->MODULE_add_header("Currency", "Currency", "60");	
	$module->MODULE_add_header("web_languages.Default", "Default", "60");	
	$module->MODULE_add_header("Active", "Active", "60");	
	
	// limit stuff
	if(empty($limitoff))
	{
		$sql  = "SELECT";
		$sql .= " COUNT(ID) ";
		$sql .= "FROM web_languages ";
		if(!empty($search))
			$sql .= " WHERE Language LIKE '%".$search."%' OR LanguageCode LIKE '%".$search."%' OR Country LIKE '%".$search."%' OR Currency LIKE '%".$search."%'";	
		$rs_limitoff = mysql_query($sql, $db);
		$row_limitoff = mysql_fetch_row($rs_limitoff);
		$limitoff = ceil($row_limitoff[0] / $module->listMaxRows);
	}
	
	if(empty($limitfrom) OR $limitfrom > $limitoff)
		$limitfrom = 1;

	// find alle users to generate a list
	$sql  = "SELECT";
	$sql .= " ID, Language, Currency, web_languages.Default, Active "; 
	$sql .= "FROM web_languages ";
	if(!empty($search))
			$sql .= " WHERE Language LIKE '%".$search."%' OR LanguageCode LIKE '%".$search."%' OR Country LIKE '%".$search."%' OR Currency LIKE '%".$search."%'";	
	$sql .= "ORDER BY ".$order;

	$rs = mysql_query($sql, $db);
	echo mysql_error();
	while($row = mysql_fetch_row($rs))
	{
		// make the list
		$modrow["values"][0] = $row[1];		// value 1 in row
		$modrow["values"][1] = $row[2];		// value 2 in row
		$modrow["values"][2] = lang($row[3]);		// value 2 in row
		$modrow["values"][3] = lang($row[4]);		// value 2 in row
		$modrow["id"] = $row[0];	// the id if the row
		$modrow["name"] = $row[1];	// the name shown when you want to delete a row
		
		array_push($module->list, $modrow);
	}

	$str .= $module->MODULE_generate_list($order, $limitfrom, $limitoff, $search);
	
	return $str;
}

function web_languages_edit($id, $order, $limitfrom, $search)
{
	global $db, $PHP_SELF, $ADMIN_TEMPLATE, $ADMIN_NAME;

	$url = explode("?", $PHP_SELF);

	// get information
	$sql  = "SELECT";
	$sql .= " LanguageCode, Language, Country, Currency, VAT, web_languages.Default, Active, Filename, DateFormat ";
	$sql .= "FROM web_languages WHERE ID = '".$id."'";
	$rs = mysql_query($sql, $db);
	echo mysql_error();
	$row = mysql_fetch_row($rs);

	// js to check when submit
	$str  = "<script>\n";
	$str .= "	function do_form_check()";
	$str .= "	{\n";
	$str .= "		document.formModule.submit();\n";
	$str .= "	}\n";
	$str .= "</script>\n";
	
		// toolbar
	$module = new MODULE();
	$module->MODULE_add_tool("javascript: do_back();", "Back", "back.icon.png");
	if($row[5] != "yes")
		$module->MODULE_add_tool("javascript: do_delete(\"".$id."\", \"".$row[0]."\");", "Delete", "delete.icon.png");
	$module->MODULE_add_tool("javascript: do_form_check();", "Save", "save.icon.png");
	// if the search bar is not to be shown
	$module->toolsearch = "no";
	
	$str .= $module->MODULE_generate_toolbar($order, $search, $limitfrom, $language);

	// headline
	$module->MODULE_edit_add_elements("Login", "", "head"); 	
	
	// active
	$select_choise = array(array("name" => lang("Yes"), "value" => "yes"), array("name" => lang("No"), "value" => "no"));
	$module->edit_value = $select_choise;
	$module->edit_selected = $row[6];
	$module->MODULE_edit_add_elements("Active", "Active", "SELECT"); 
	
	// default
	$select_choise = array(array("name" => lang("No"), "value" => "no"), array("name" => lang("Yes"), "value" => "yes"));
	$module->edit_value = $select_choise;
	$module->edit_selected = $row[5];
	$module->MODULE_edit_add_elements("Default", "Default", "SELECT"); 

	// string
	$module->MODULE_edit_add_elements("All text values must bee in english.", "", "STRING");
	
	// Language
	$module->edit_value = $row[1];
	$module->edit_size = 45;	
	$module->MODULE_edit_add_elements("Language", "Language", "TEXT");

	// Language code
	$module->edit_value = $row[0];
	$module->edit_size = 4;	
	$module->MODULE_edit_add_elements("Language code", "LanguageCode", "TEXT");

	// Country
	$module->edit_value = $row[2];
	$module->edit_size = 45;	
	$module->MODULE_edit_add_elements("Country", "Country", "TEXT");

	// currency
	$module->edit_value = $row[3];
	$module->edit_size = 45;	
	$module->MODULE_edit_add_elements("Currency", "Currency", "TEXT");
	
	// VAT
	$module->edit_value = $row[4];
	$module->edit_size = 4;	
	$module->MODULE_edit_add_elements("VAT", "VAT", "TEXT");
		
	// dateformat
	if(!empty($row[8]))
		$module->edit_value = $row[8];
	else 
		$module->edit_value = "YYYY-mm-dd";
	$module->edit_size = 20;	
	#$module->edit_end_text = lang("YYYY = Year, mm = month num, MMM = month name, dd = month day, www = weekday");
	$module->MODULE_edit_add_elements("Date format", "DateFormat", "TEXT");
	$module->MODULE_edit_add_elements("YYYY = Year, mm = month num, MMM = month name, dd = month day, www = weekday", "", "STRING");
	
	// space
	$module->MODULE_edit_add_elements("&nbsp;", "", "STRING");
	
	// picture
	$module->MODULE_edit_add_elements("Picture to use on website", "", "STRING");
	$module->edit_value = $row[7];
	$module->MODULE_edit_add_elements("Picture", "Picture", "UPLOAD");

	$module->MODULE_edit_add_elements("&nbsp;", "", "BOTTOM");
	
	$str .= $module->MODULE_edit_generate($id, $order, $limitfrom, $search);	
	
	return $str;
}


function web_languages_delete($id)
{
	global $db;
	
	// make shure the is a language
	$rs = mysql_query("SELECT COUNT(ID) FROM web_languages", $db);
	$row = mysql_fetch_row($rs);
	echo mysql_error();
	if($row[0] > 1)
	{
		$rs = mysql_query("SELECT Filename FROM web_languages WHERE ID='".$id."'", $db);
		$row = mysql_fetch_row($rs);
		// removing banner file
		if(is_file("../../files/languages/".$row[0]))
			unlink("../../files/languages/".$row[0]);

		// delete
		mysql_query("DELETE FROM web_languages WHERE ID='".$id."'", $db);
		echo mysql_error();			
	}
}


function web_languages_save($id)
{
	global $db, $ADMIN_NAME;

	// upload picture if there is one
	if(!empty($_FILES["Picture"]["name"]))
	{
		// opdater filnavn 
		$filename = $_FILES["Picture"]["name"];
	}		

	// if the id is not empty the make a update
	if(!empty($id))
	{
		$sql  = "UPDATE";
		$sql .= " web_languages ";
		$sql .= "SET";
		$sql .= " Language = '".$_POST["Language"]."',";
		$sql .= " LanguageCode = '".$_POST["LanguageCode"]."',";
		$sql .= " Country = '".$_POST["Country"]."',";
		$sql .= " Currency = '".$_POST["Currency"]."',";
		$sql .= " VAT = '".$_POST["VAT"]."',";
		$sql .= " Active = '".$_POST["Active"]."',";
		$sql .= " DateFormat = '".$_POST["DateFormat"]."' ";
		if(!empty($filename))
			$sql .= ", Filename='".$filename."' ";
		$sql .= "WHERE";
		$sql .= " ID='".$id."'";
		
		mysql_query($sql, $db);
		echo mysql_error();
	}
	else
	{
		// create a new module
		$sql  = "INSERT INTO web_languages";
		$sql .= " (LanguageCode, Language, Country, Currency, VAT, Active, web_languages.Default, Filename, DateFormat) ";
		$sql .= "VALUES('".$_POST["LanguageCode"]."', '".$_POST["Language"]."', '".$_POST["Country"]."',";
		$sql .= " '".$_POST["Currency"]."', '".$_POST["VAT"]."', '".$_POST["Active"]."', 'no', '".$filename."',";
		$sql .= " '".$_POST["DateFormat"]."')";
		mysql_query($sql, $db);
		echo mysql_error();
		$id = mysql_insert_id();
	}

	// check to se if there is a default language
	$rs = mysql_query("SELECT ID FROM web_languages WHERE web_languages.Default = 'yes'", $db);
	$row = mysql_fetch_row($rs);
	// set default
	if($_POST["Default"] == "yes" OR empty($row[0]))
	{
		mysql_query("UPDATE web_languages SET web_languages.Default = 'no'", $db);
		mysql_query("UPDATE web_languages SET web_languages.Default = 'yes' WHERE ID='".$id."'", $db);
	}
	
	// upload picture if there is one
	if(!empty($_FILES["Picture"]["name"]))
	{
		// path
		$path = "../../files/languages/".$filename;
		copy($_FILES['Picture']['tmp_name'], $path);
	}	
}


// make shure the needed folders is there
filesystem_check_dir("../../files");
filesystem_check_dir("../../files/languages");

switch($_GET["a"])
{
	// edit user
	case "e":
		$str = web_languages_edit($_GET["i"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// save user
	case "s":
		web_languages_save($_GET["i"], $_GET["o"], $_GET["lf"], $_GET["s"]);
		$str = web_languages_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// delete user
	case "d":
		web_languages_delete($_GET["i"]);
		$str = web_languages_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
	// default show list
	default:
		$str = web_languages_list($_GET["o"], $_GET["lf"], $_GET["s"]);
		break;
}

echo str_replace("##MODULE##", $str, $module_template);
?>