<?php
/*******************************************************************
 *  cmsWorks - filesystem functions                                *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 *    http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.0.3                                                *
 *  Modified: 2005-11-04 05:10                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/

/**
 * @return void
 * @param unknown $dir
 * @desc Enter description here...
*/
function filesystem_check_dir($dir)
{
	if(!is_dir($dir)) {
		if(!mkdir($dir)) 	{
			echo "FETAL ERROR: Could not make required folder ('".$dir."')";
			exit();
		}	
	}
}

/**
 * @return bool
 * @param path
 * @desc Deletes a dir and its content recursive
*/
function filesystem_rmdirRecursive($path, $followLinks=false) 
{
 	$dir = opendir($path);
	while ( $entry = readdir($dir) ) 
	{
		if ( is_file( "$path/$entry" ) || ((!$followLinks) && is_link("$path/$entry")) ) 
		{
			unlink( "$path/$entry" );
		} 
		else if ( is_dir( "$path/$entry" ) && $entry!='.' && $entry!='..' ) 
		{
			filesystem_rmdirRecursive( "$path/$entry" );
		}
	}
	closedir($dir) ;
	
	return rmdir($path);
}

/**
 * @return void
 * @param path
 * @desc Creates dir(s) recursive
*/
function filesystem_mkdirRecursive($path)
{
	// explode folders
	$folders = explode("/", $path);

	// run tru all dirs
	for($x = 0; $x < count($folders); $x++)
	{
		$dir .= $folders[$x]."/";

		// check if the dir is there
		if($folders[$x] != ".." AND $folders[$x] != "." AND $folders[$x] != "" AND !is_dir($dir))
			mkdir($dir); // create dir
	}
}

function filesystem_count_folders($path)
{
	$count = 0;

	if ($handle = opendir($path)) 
	{
		while (false !== ($file = readdir($handle))) 
		{
			$perms = fileperms($path."/".$file);
			if ($file != "." && $file != ".." && ($perms & 0x4000) == 0x4000) 
				$count++;
		}
		closedir($handle);
	}

	return $count;
}

?>