<?PHP
/*******************************************************************
 *  cmsWorks                                                       *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.0.0                                                *
 *	Modified: 2005-11-10 01:55                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/
// include image toolbox
if(is_file("classes/imageToolbox/Image_Toolbox.class.php"))
	include_once("classes/imageToolbox/Image_Toolbox.class.php");
else
{
	syslog(LOG_ERR, "ERROR: could not include Image Toolbox class (Image_Toolbox.class.php)");
	return;
}	

function image_resize($height, $width, $file_in, $file_out, $method = "fixed_width")
{
	// gen current size
	list($c_width, $c_height, $type, $attr) = getimagesize("$file_in");
	if($c_width > $width OR empty($height) OR $height == 0)
	{
		$f = $width/$c_width;
		$s_height = $c_height*$f;
	}
	if(($c_height > $height AND !empty($height) AND $height != 0) OR empty($width) OR $width == 0)
	{
		$f = $height/$c_height;
		$s_width = $c_width*$f;
		$s_height = $height;
	}
	
	if(empty($s_height) OR empty($s_width))
	{
		if($method == "fixed_width")
		{
			$s_width = $width;
			$f = $width/$c_width;
			$s_height = $c_height*$f;	
		}
		else 
		{
			$s_width = $c_width;
			$s_height = $c_height;		
		}
	}

	// copy picture first
	copy($file_in, $file_out);

	// set best quality resize method, this is slover :-/
	$img = new Image_Toolbox("$file_out");
	$img->setResizeMethod('resample');
	settype($s_width, "integer");
	settype($s_height, "integer");
	$img->newOutputSize($s_width, $s_height, false, false);
	$img->save("$file_out");
}

?>