<?php
/*******************************************************************
 *  cmsWorks - template functions                                  *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.0.10                                               *
 *	Modified: 2006-02-24 03:14                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/
 
function Template_vars()
{
	// main 
	$var[] = "// main\n";
	$var[] = array('required' => 'yes', 'name' => '["MainWidth"]', "val" => '', "comment" => 'width of the main page area');
	$var[] = array('required' => 'yes', 'name' => '["MainWidthLeftCol"]', "val" => '', "comment" => ''); 
	$var[] = array('required' => 'yes', 'name' => '["MainWidthColSpace"]', "val" => '', "comment" => '');
	$var[] = array('required' => 'yes', 'name' => '["MainWidthRightCol"]', "val" => '', "comment" => '');
	$var[] = array('required' => 'yes', 'name' => '["MenuWidthLeft"]', "val" => '', "comment" => 'width of the left side menus');
	$var[] = array('required' => 'yes', 'name' => '["MenuWidthRight"]', "val" => '', "comment" => 'width of the right side menus');
	$var[] = "\n";
	
	// submit
	$var[] = "// submit button\n";
	$var[] = array('required' => 'yes', 'name' => '["Submit"]["Type"]', "val" => 'BUTTON', "comment" => 'types: TEXT, BUTTON');
	$var[] = array('required' => 'yes', 'name' => '["Submit"]["Gfx"]', "val"	=> '', "comment" => 'only used with type TEXT. The image i shown before the text.');
	$var[] = array('required' => 'yes', 'name' => '["Submit"]["Class"]', "val" => 'inputSubmit', "comment" => 'css class to use on TEXT/BUTTON');
	$var[] = "\n";
	
	// menu
	$var[] = "// menu\n";
	$var[] = array('required' => 'no', 'name' => '["Menu"]["Normal"]', "val" => '', "comment"	=> 'normal menu (Image)');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["Selected"]', "val" => '', "comment" => 'selected menu (Image)');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["TemplateLeft"]', "val" => 'menuLeft.html', "comment" => 'template for left menu');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["TemplateRight"]', "val" => 'menuRight.html', "comment" => 'template for right menu');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassLeft"]', "val" => '', "comment" => 'the css class to use on the menu table');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassColLeft"]', "val" => '', "comment" => 'the css class to use on the col');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassRowLeft"]', "val" => '', "comment" => 'the css class to use on the row');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassLinkLeft"]', "val" => '', "comment" => 'the css class to use on the links');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassRight"]', "val" => '', "comment" => 'the css class to use on the menu table');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassColRight"]', "val" => '', "comment" => 'the css class to use on the col');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassRowLeft"]', "val" => '', "comment" => 'the css class to use on the row');
	$var[] = array('required' => 'no', 'name' => '["Menu"]["ClassLinkRight"]', "val" => '', "comment" => 'the css class to use on the links');
	$var[] = "\n";
	
	// top menu
	$var[] = "// old top menu\n";
	$var[] = array('required' => 'no', 'name' => '["TopMenu"]["StartSpace"]', "val" => '', "comment" => 'the space added in the start of the menu');
	$var[] = array('required' => 'no', 'name' => '["TopMenu"]["Space"]', "val" => '', "comment" => 'space betvine menues');
	$var[] = array('required' => 'no', 'name' => '["TopMenu"]["EndSpace"]', "val" => '', "comment" => 'the space added in the end of the menu');
	$var[] = array('required' => 'no', 'name' => '["TopMenu"]["Width"]', "val" => '100%', "comment" => 'the width of the top menu, can be defined in % or px');
	$var[] = array('required' => 'no', 'name' => '["TopMenu"]["Class"]', "val" => 'textMenuTop', "comment" => 'the css class to use on text links');
	$var[] = "\n";
	
	// basket
	$var[] = "// basket\n";
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["Type"]', "val" => 'LIST', "comment" => 'basket menu type IMAGE or LIST');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["Image"]', "val" => '', "comment" => 'if type is IMAGE then define the image here.');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["MenuTemplate"]', "val" => 'menuBasket.html', "comment" => 'the menu template to use for the basket');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["MenuMaxChars"]', "val" => '16', "comment" => 'the max char count for a line in the pasket');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["ToBasketImageVariant"]', "val" => '', "comment" => 'the image used on type COMBI and IMAGE');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["ToBasketTextVariant"]', "val" => 'To basket', "comment" => 'the text uses on type TEXT, COMBI and BUTTON');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["ToBasketImageNonVariant"]', "val" => 'BUTTON', "comment" => 'to basket types TEXT, COMBI, IMAGE, BUTTON');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["ToBasketTextNonVariant"]', "val" => 'To basket', "comment" => 'the text uses on type TEXT, COMBI and BUTTON');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["ToBasketTypeNonVatinat"]', "val" => 'BUTTON', "comment" => 'to basket types TEXT, COMBI, IMAGE, BUTTON');	
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["Sub"]', "val" => 'gfx/minus.jpg', "comment" => 'the add amount gfx for the basket');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["Add"]', "val" => 'gfx/plus.jpg', "comment" => 'the sub amount gfx for the basket');
	$var[] = array('required' => 'yes', 'name' => '["Basket"]["ObjTemplate"]', "val" => 'objectBasket.html', "comment" => 'the template to use on the page');
	$var[] = "\n";
	
	// item setup
	$var[] = "// item group setup\n";
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Template"]', "val" => 'item.html', "comment" => 'themplate for showing item');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["ColorCodeIndicator"]', "val" => '', "comment" => 'icon for active color');
	
	// item group
	$var[] = "// item group setup\n";
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["TopTemplate"]', "val" => 'itemGroupTop.html', "comment" => 'themplate for use in the top of item group list');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["TopClass"]', "val" => '', "comment" => 'the css class to use on the top template');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["TopGroupLinkImage"]', "val" => '', "comment" => 'image to show with sub grup link');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["TopSubGroupTemplate"]', "val" => 'itemGroupTopSubGroup.html', "comment" => 'themplate for subgroup links');	
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["TopSubGroupCols"]', "val" => '3', "comment" => 'themplate for subgroup links cols');	
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["TemplateVariant"]', "val" => 'itemGroupVariant.html', "comment" => 'themplate for use varinat listing items');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["MaxPicWidthVariant"]', "val" => '100', "comment" => 'the max width of pictures varian listing');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["MaxDescLenVariant"]', "val" => '40', "comment" => 'the max length shown of the description');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["TemplateNonVarinat"]', "val" => 'itemGroupNonVariant.html', "comment" => 'themplate for use non variant listing items');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["MaxPicWidthNonVariant"]', "val" => '100', "comment" => 'the max width of pictures non variant listing');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["MaxDescLenNonVariant"]', "val" => '100', "comment" => '');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Group"]["DefaultListingType"]', "val" => 'NonVariant', "comment" => '');
	
	// random item
	$var[] = "// ramdom item\n";
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Random"]["Template"]', "val" => 'itemRandom.html', "comment" => 'template for random items');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Random"]["ColSpace"]', "val" => '5', "comment" => 'col space between items');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Random"]["MaxPicWidth"]', "val" => '100', "comment" => 'the maximum width of the picture on the random item');
	$var[] = array('required' => 'yes', 'name' => '["Item"]["Random"]["MaxDescriptionLength"]', "val" => '55', "comment" => 'the maximum length of the desciption');
	$var[] = "\n";
	
	// order email template
	$var[] = "// order email template\n";
	$var[] = array('required' => 'yes', 'name' => '["Order"]["EmailTemplate"]', "val" => 'email.html', "comment" => 'template for html version of ordre mail');
	$var[] = "\n";
	
	// login
	$var[] = "// login\n";
	$var[] = array('required' => 'yes', 'name' => '["Login"]["PageTemplate"]', "val" => 'pageUser.html', "comment" => '');
	$var[] = array('required' => 'yes', 'name' => '["Login"]["ObjectTemplate"]', "val" => 'objectStd.html', "comment" => '');
	$var[] = array('required' => 'yes', 'name' => '["Login"]["LoginImage"]', "val" => '', "comment" => 'if empty, a submit button is used');
	$var[] = array('required' => 'yes', 'name' => '["Login"]["InputSize"]', "val" => '10', "comment" => 'size of login and password input');
	$var[] = array('required' => 'yes', 'name' => '["Login"]["Type"]', "val" => 'CUSTOMER', "comment" => 'login type CUSSTOMER or PARTY');
	$var[] = array('required' => 'yes', 'name' => '["Login"]["Create"]', "val" => 'yes', "comment" => 'users can create logins');
	$var[] = "\n";
	
	// gallery
	$var[] = "// galley module\n";
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["DirColumns"]', "val" => '3', "comment" => 'columns af pictures of dirs');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["DirPicMaxWidth"]', "val" => '140', "comment" => 'max picture width of dirs');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["DirPicMaxHeight"]', "val" => '105', "comment" => 'max picture height of dirs');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["DirOrder"]', "val" => 'DATE_DESC', "comment" => 'order by \'DATE\', \'DATE_DESC\', \'ALPHABETIC\' or \'ALPHABETIC_DESC\'');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["DirComment"]', "val" => 'no', "comment" => 'use comment on dir');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["DirTemplate"]', "val" => 'galleryDir.html', "comment" => 'template for dirs');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["Comments"]', "val" => 'galleryDir.html', "comment" => 'template for dirs');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["CommentsTemplate"]', "val" => 'galleryComment.html', "comment" => 'comment template');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["CommentsConfirm"]', "val" => 'yes', "comment" => 'confirm user comments?');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["Postcard"]', "val" => 'yes', "comment" => 'allow user to send postcard from site');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["PostcardTemplate"]', "val" => 'galleryPostcard.html', "comment" => 'postcard template');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["RequestDeleteTemplate"]', "val" => 'galleryDelete.html', "comment" => 'postcard template');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["PicWidth"]', "val" => '300', "comment" => 'max picture width');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["PicHeight"]', "val" => '225', "comment" => 'max picture height');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["PicTemplate"]', "val" => 'alleryPic.html', "comment" => 'picture template');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["PicNumber"]', "val" => '8', "comment" => 'number of pics pr page');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["LimitNextGfx"]', "val" => '', "comment" => 'if defined gfx is used as back button on list of pictures');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["LimitBackGfx"]', "val" => '', "comment" => 'if defined gfx is used ad next button on list of pictures');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["ClassLimit"]', "val" => 'gallery', "comment" => 'css class');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["ClassLimitlink"]', "val" => 'gallery_link', "comment" => 'css class');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["ClassMenu"]', "val" => 'gallery_menu', "comment" => 'css for the \'Request delete\', \'Comment\' and \'Send postcard\' menus');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["LogoPic"]', "val" => '', "comment" => 'logo picture');
	$var[] = array('required' => 'yes', 'name' => '["Gallery"]["LogoLocation"]', "val" => 'RIGHT_BOTTOM', "comment" => 'location of the logo, can bee RIGHT_BOTTOM, RIGHT_TOP, LEFT_BOTTOM or LEFT_TOP');
	$var[] = "\n";
	
	// guestbook
	$var[] = "// guestbook module\n";
	$var[] = array('required' => 'yes', 'name' => '["Guestbook"]["Check"]', "val" => 'yes', "comment" => 'confirm messages');
	$var[] = array('required' => 'yes', 'name' => '["Guestbook"]["MessageNumbers"]', "val" => '10', "comment" => 'number of messages on a page');
	$var[] = array('required' => 'yes', 'name' => '["Guestbook"]["Template"]', "val" => 'guestbookList.html', "comment" => 'message template');
#	$var[] = array('required' => 'yes', 'name' => '["Guestbook"]["MessageTemplate"]', "val" => '', "comment" => '');
	$var[] = array('required' => 'yes', 'name' => '["Guestbook"]["InputWidth"]', "val" => '70', "comment" => 'width of input fields');
	$var[] = "\n";
	
	// contact form
	$var[] = "// Contact form module\n";
	$var[] = array('required' => 'no', 'name' => '["Contact"]["NameWidth"]', "val" => '30', "comment" => 'input width');
	$var[] = array('required' => 'no', 'name' => '["Contact"]["EmailWidth"]', "val" => '30', "comment" => 'input width');
	$var[] = array('required' => 'no', 'name' => '["Contact"]["PhoneWidth"]', "val" => '30', "comment" => 'input width');
	$var[] = array('required' => 'no', 'name' => '["Contact"]["MessageRows"]', "val" => '10', "comment" => 'message box rows');
	$var[] = array('required' => 'no', 'name' => '["Contact"]["MessageCols"]', "val" => '30', "comment" => 'message box cols');
	$var[] = array('required' => 'no', 'name' => '["Contact"]["Class"]', "val" => '', "comment" => 'css class to use on fields');
	$var[] = "\n";
	
	// rss
	$var[] = "// RSS\n";
	$var[] = array('required' => 'yes', 'name' => '["RSS"]["Icon"]', "val" => '', "comment" => 'RSS icons to show on the site');
	$var[] = "\n";
	
	// menu location
	$menuLocation[] = array('required' => 'no', 'name' => '["Menu"]["Template"]["Template"]', 'val' => '', 'comment' => 'template to use for this menu');
	$menuLocation[] = array('required' => 'no', 'name' => '["Menu"]["Template"]["GfxNormal"]', 'val' => '', 'comment' => 'normal menu (Image)');
	$menuLocation[] = array('required' => 'no', 'name' => '["Menu"]["Template"]["GfxSelected"]', 'val' => '', 'comment' => 'selected menu (Image)');
	$menuLocation[] = array('required' => 'no', 'name' => '["Menu"]["Template"]["ClassLink"]', 'val' => '', 'comment' => 'the css class to use on the links');
	$menuLocation[] = array('required' => 'no', 'name' => '["Menu"]["Template"]["ClassTable"]', 'val' => '', 'comment' => 'the css class to use on the table');
	$menuLocation[] = array('required' => 'no', 'name' => '["Menu"]["Template"]["ClassCol"]', 'val' => '', 'comment' => 'the css class to use on the col');
	$menuLocation[] = array('required' => 'no', 'name' => '["Menu"]["Template"]["ClassRow"]', 'val' => '', 'comment' => 'the css class to use on the row');

	return $var;
}

function Template_generate_theme_cfg($var)
{
	global $Theme;
	
	for($x = 0; $x < count($var); $x++)
	{
		// if its an array set the var
		if(is_array($var[$x]))
		{			
			$theme_name = "Theme".$var[$x]["name"];
			$tmp = eval("return \$$theme_name;");
			if(empty($tmp))
				$tmp = $var[$x]["val"];
			$file .= str_pad("\$".$theme_name, 55, " ")."= ".str_pad("\"".$tmp."\";", 30, " ")."// ".$var[$x]["comment"]."\n";
		}
		else // it must be the end of a section
		{
			$file .= $var[$x];
		}
	}
	
	// menus templates
	$menuTemplate["Template"] = 'template to use for this menu';
	$menuTemplate["GfxNormal"] = 'normal menu (Image)';
	$menuTemplate["GfxSelected"] = 'selected menu (Image)';
	$menuTemplate["ClassLink"] = 'the css class to use on the links';
	$menuTemplate["ClassTable"] = 'the css class to use on the table';
	$menuTemplate["ClassCol"] = 'the css class to use on the col';
	$menuTemplate["ClassRow"] = 'the css class to use on the row';

	$file .= "// menu templates\n";
	if(is_array($Theme["Menu"]["Template"]))
	{
		while (list($key, $val) = each($Theme["Menu"]["Template"])) 
		{
			if(is_array($Theme["Menu"]["Template"]["$key"]))
			{
				reset($Theme["Menu"]["Template"]["$key"]);
				while (list($key2, $val2) = each($Theme["Menu"]["Template"]["$key"])) 
				{
					$file .= str_pad("\$Theme[\"Menu\"][\"Template\"][\"".$key."\"][\"".$key2."\"]", 55, " ")."= ".str_pad("\"".$val2."\";", 30, " ")."// ".$menuTemplate["$key2"]."\n";
				}
				$file .= "\n";
			}
		}
	}	
	$file .= "\n";

	// menu locations
	$menuLocation["Tag"] = 'template to use for this menu';
	$menuLocation["Orientation"] = 'normal menu (Image)';
	$menuLocation["Width"] = 'selected menu (Image)';
	$menuLocation["StartSpace"] = 'the css class to use on the links';
	$menuLocation["Space"] = 'the css class to use on the table';
	$menuLocation["EndSpace"] = 'the css class to use on the col';

	if(is_array($Theme["Menu"]["Location"]))
	{
		$file .= "// menu locations\n";
		while (list($key, $val) = each($Theme["Menu"]["Location"]))
		{			
			reset($Theme["Menu"]["Location"]["$key"]);
			while (list($key2, $val2) = each($Theme["Menu"]["Location"]["$key"])) 
			{
				$file .= str_pad("\$Theme[\"Menu\"][\"Location\"][\"".$key."\"][\"".$key2."\"]", 55, " ")."= ".str_pad("\"".$val2."\";", 30, " ")."// ".$menuLocation["$key2"]."\n";
			}
			$file .= "\n";
		}
	}
	
	// page templates
	$file .= "// page templates\n";
	$file .= "// the first on the list is the std page, and is used on pages where its not\n";
	$file .= "// possible to select the template.\n";

#	if(isset($Theme["Page"]["Location"]))
	{
		if(isset($Theme["Page"]["Template"]))
		{
			foreach ($Theme["Page"]["Template"] as $key => $value)
			{
				$file .= str_pad("\$Theme[\"Page\"][\"Template\"][\"".$key."\"]", 55, " ")."= ".str_pad("\"".$value."\";", 30, " ")."// page template\n";
			}
		}
		$file .= "\n";
	}
#	else 
	{
#		$file .= "\n";
	}
	
	// object templates
	$file .= "// object templates\n";
	$file .= "// the first on the list is the std object template, and is used when its not\n";
	$file .= "// possible to select the template.\n";
	if(isset($Theme["Object"]["Template"]))
	{
		foreach ($Theme["Object"]["Template"] as $key => $value)
		{
			$file .= str_pad("\$Theme[\"Object\"][\"Template\"][\"".$key."\"]", 55, " ")."= ".str_pad("\"".$value."\";", 30, " ")."// object template\n";
		}
	}

	// make copy of old config
	copy($Theme["Path"]."theme.cfg", $Theme["Path"]."theme.cfg.backup.".date("Y-m-d h:i"));
	
	// save new config
	$file = "<?php\n".$file."\n?>\n";
	$filename = $Theme["Path"].'theme.cfg';

	// Let's make sure the file exists and is writable first.
	if (is_writable($filename)) 
	{
		// In our example we're opening $filename in append mode.
		// The file pointer is at the bottom of the file hence
		// that's where $somecontent will go when we fwrite() it.
		if (!$handle = fopen($filename, 'w')) 
		{
		     echo "Cannot open file ($filename)";
		     exit;
		}

		// Write $somecontent to our opened file.
		if (fwrite($handle, $file) === FALSE) 
		{
		   echo "Cannot write to file ($filename)";
		   exit;
		}

		fclose($handle);
	} 
	else 
	{
		echo "The file ".$Theme["Path"].$filename." is not writable";
		exit();
	}
}

function Template_cfg()
{
	global $db, $Theme, $SITE_TEMPLATE;

	if(empty($SITE_TEMPLATE))
	{
		echo "Sorry! The site is not configuret right.<br>Please go to the admin page and select a theme for this site.";
		exit();
	}
	else if(!is_file("themes/".$SITE_TEMPLATE."/theme.cfg"))
	{
		echo "Sorry! This theme is not created right, plase make shure there is a theme.cfg file for this theme.";
		exit();
	}
	
	// include the current selected theme
	include_once "themes/".$SITE_TEMPLATE."/theme.cfg";

	// the theme path
	$Theme["Path"] = "themes/".$SITE_TEMPLATE."/";

	$var = Template_vars();
	
	// is there a theme var that is not set then set this true
	$theme_ok = true;
	
	for($x = 0; $x < count($var); $x++)
	{
		if(is_array($var[$x]))
		{			
			$theme_name = "Theme".$var[$x]["name"];
			$tmp = eval("return \$$theme_name;");
			
			// check to se if the theme var is set, if not set the control var
			$this_ok = true;
			if(!isset($tmp) AND $var[$x]["required"] == "yes")
			{
				$theme_ok = false;				
				$this_ok = false;
			}
			// set the session vars
			if(!$this_ok)
			{
				$$theme_name = $var[$x]["val"];				
			}
			else 
			{
				$tmp = eval("return \$$theme_name;");
				${$theme_name} = $tmp;
				#echo $session_name." => ".$tmp."<br>";		
			}

		}
	}
/*
	// menu temlate check for backward compatibility
	if(empty($Theme["Menu"]["Template"]["Left"]["Template"]))
	{
		if(empty($Theme["Menu"]["TemplateLeft"]))
			$Theme["Menu"]["Template"]["Left"]["Template"] 	= "menu.html";
		else 
			$Theme["Menu"]["Template"]["Left"]["Template"] 	= $Theme["Menu"]["TemplateLeft"];
		
		$Theme["Menu"]["Template"]["Left"]["GfxNormal"] 	= $Theme["Menu"]["Normal"];
		$Theme["Menu"]["Template"]["Left"]["GfxSelected"] = $Theme["Menu"]["Selected"];
		$Theme["Menu"]["Template"]["Left"]["ClassLink"] 	= $Theme["Menu"]["ClassLinkLeft"];
		$Theme["Menu"]["Template"]["Left"]["ClassTable"]	= $Theme["Menu"]["ClassLeft"];
		$Theme["Menu"]["Template"]["Left"]["ClassCol"]		= $Theme["Menu"]["ClassColLeft"];
		$Theme["Menu"]["Template"]["Left"]["ClassRow"]		= $Theme["Menu"]["ClassRowLeft"];
	}
	if(empty($Theme["Menu"]["Template"]["Right"]["Template"]))
	{
		if(empty($Theme["Menu"]["TemplateRight"]))
			$Theme["Menu"]["Template"]["Right"]["Template"] 	= "menu.html";
		else 
			$Theme["Menu"]["Template"]["Right"]["Template"] 	= $Theme["Menu"]["TemplateRight"];
		
		$Theme["Menu"]["Template"]["Right"]["GfxNormal"] 		= $Theme["Menu"]["Normal"];
		$Theme["Menu"]["Template"]["Right"]["GfxSelected"] 	= $Theme["Menu"]["Selected"];
		$Theme["Menu"]["Template"]["Right"]["ClassLink"]		= $Theme["Menu"]["ClassLinkLeft"];
		$Theme["Menu"]["Template"]["Right"]["ClassTable"]		= $Theme["Menu"]["ClassLeft"];
		$Theme["Menu"]["Template"]["Right"]["ClassCol"]			= $Theme["Menu"]["ClassColLeft"];
		$Theme["Menu"]["Template"]["Right"]["ClassRow"]			= $Theme["Menu"]["ClassRowLeft"];
	}

	// std page template 
	if(isset($Theme["Page"]["Template"]))
	{
		foreach ($Theme["Page"]["Template"] as $key => $value)
		{
			if(!isset($first_page))
				$first_page = $value;
		}
		$Theme["Page"]["Template"] = $first_page;
	}

	// std object template 
	if(isset($Theme["Object"]["Template"]))
	{
		foreach ($Theme["Object"]["Template"] as $key => $value)
		{
			if(!isset($first_obj))
				$first_obj = $value;
		}		
		$Theme["Object"]["Template"] = $first_obj;
	}
*/	
	// check for login templates set it to default if its not defined in the config.
	if(empty($Theme["Login"]["PageTemplate"]))
		$Theme["Login"]["PageTemplate"] = $Theme["Page"]["Template"];
	if(empty($Theme["Login"]["ObjectTemplate"]))
		$Theme["Login"]["ObjectTemplate"] = $Theme["Object"]["Template"];


	// if theme is not ok, then make a backup of the old and generate a new.
	if(!$theme_ok)	
		Template_generate_theme_cfg($var);
}

// loader defineret template
function Template_load($file)
{
	global $Theme;

	// copy std template if the template is missing and a std template 
	if(!is_file($Theme["Path"].$file) AND is_file("setup/default_templates/".$file))
		copy("setup/default_templates/".$file, $Theme["Path"].$file);
	
	if(is_file($Theme["Path"].$file))
	{
		// getting template 
		$fp = fopen($Theme["Path"].$file,"r");
		while(!feof($fp)) 
		{
			$Template .= fgets($fp, 4096);
		}
		fclose($fp);
	}

	return $Template;
}

function Template_menu($Posision = "Right")
{
	global $db, $Theme, $SITE_TEMPLATE;

	// henter std templaten for sitet ind
	if(is_file("themes/".$SITE_TEMPLATE."/".$Theme["Menu"]["Template"][$Posision]))
	{
		// genter templaten ind
		$fp = fopen("themes/".$SITE_TEMPLATE."/".$Theme["Menu"]["Template"][$Posision],"r");
		while(!feof($fp)) 
		{
			$Template .= fgets($fp, 4096);
		}
		fclose($fp);
	}

	return $Template;
}

function Template_main()
{
	global $db, $Theme, $SITE_TEMPLATE;

	// finder theme
#	$ROW = mysql_fetch_row(mysql_query("SELECT Theme FROM web_setup",$db));

	// henter std templaten for sitet ind
	if(is_file("themes/".$SITE_TEMPLATE."/".$Theme["Page"]["Template"]))
	{
		// genter templaten ind
		$fp = fopen("themes/".$SITE_TEMPLATE."/".$Theme["Page"]["Template"],"r");
		while(!feof($fp)) 
		{
			$Template .= fgets($fp, 4096);
		}
		fclose($fp);
	}

	return $Template;
}

function Template_site()
{
	global $db, $Theme, $SITE_NAME, $SITE_TEMPLATE, $SITE_TITTLE, $get;
	
	// make shure the theme folder is there
	if(!is_dir("themes"))
		mkdir("themes");
	
	// finder theme
	$ROW = mysql_fetch_row(mysql_query("SELECT MetaKeywords, MetaDescription FROM setup",$db));
	
	// henter std templaten for sitet ind
	if(is_file("themes/".$SITE_TEMPLATE."/site.html"))
	{
		// genter templaten ind
		$fp = fopen("themes/".$SITE_TEMPLATE."/site.html","r");
		while(!feof($fp)) 
		{
			$Template .= fgets($fp, 4096);
		}
		fclose($fp);
	}

	// replace sitename
	// first find the name of the page
	switch($get["Type"])
	{
		case "Itemgroup":
			$rs_group = mysql_query("SELECT Name FROM item_groups_obj WHERE GroupID='".$get["ID"]."' AND Language='".$_SESSION["Language"]["Code"]."'", $db);
			$row_group = mysql_fetch_row($rs_group);
			
			$name = $row_group[0];
			break;
		
		case "Item":
			$rs_item = mysql_query("SELECT Name FROM item_obj WHERE ItemID='".$get["ID"]."' AND Language='".$_SESSION["Language"]["Code"]."'", $db);
			$row_item = mysql_fetch_row($rs_item);
			
			$name = $row_item[0];
			break;
			
		case "basket":
			$name = Translate($_SESSION["Language"]["Code"], "Basket");	
			break;
			
		default:
			if(empty($get["ID"]) OR $get["ID"] == "0")
			{
				$rs = mysql_query("SELECT web_page_obj.Name FROM web_menu_links, web_page_obj WHERE web_page_obj.PageID = web_menu_links.PageID AND web_menu_links.Std='yes' AND web_page_obj.Language = '".$_SESSION["Language"]["Code"]."'", $db);
				echo mysql_error();		
				if($row = mysql_fetch_row($rs))
				{
					$name = $row[0];
				}
				else 
				{
					$rs = mysql_query("SELECT web_page_obj.Name FROM web_page, web_page_obj WHERE web_page.ID = web_page_obj.PageID AND web_page.Default='yes' AND web_page_obj.Language = '".$_SESSION["Language"]["Code"]."'",$db);
					$row = mysql_fetch_row($rs);
					$name = $row[0];
				}
			}
			else if(!is_numeric($get["ID"]))
			{				
				$rs_page = mysql_query("SELECT PageID, Name FROM web_page_obj" , $db);
				while($row_page = mysql_fetch_row($rs_page))
				{
					if(strtolower(ereg_replace("[^[:alnum:]+]", "", $get["ID"])) == strtolower(ereg_replace("[^[:alnum:]+]","", $row_page[1])))
						$name = $row_page[1];					
				}
			}
			else
			{
				$rs = mysql_query("SELECT web_page_obj.Name FROM web_page, web_page_obj WHERE web_page.ID = web_page_obj.PageID AND web_page.ID='".$get["ID"]."' AND web_page_obj.Language = '".$_SESSION["Language"]["Code"]."'",$db);
				$row = mysql_fetch_row($rs);
				$name = $row[0];
			}
			
			break;
	}
	echo mysql_error();
	$Template = str_replace("##SiteName##", $name." - ".$SITE_TITTLE, $Template);	
	
	// replaces meta stings
	$Template = str_replace("##MetaKeywords##", $ROW[0], $Template);	
	$Template = str_replace("##MetaDescription##", $ROW[1], $Template);	
	
	// add curren year
	$Template = str_replace("##Year##", date("Y"), $Template);
	
	return $Template;
}

function Template_item()
{
	global $db, $SITE_TEMPLATE, $Theme, $Theme_is_changed;

	// chech if a template is defined, else we have to generate the default template
	if(empty($Theme["Item"]["Template"]))
	{
		$Theme["Item"]["Template"] = "item.html";
		$Theme_is_changed = true;
	}
	
	// henter std templaten for sitet ind
	if(is_file("themes/".$SITE_TEMPLATE."/".$Theme["Item"]["Template"]))
	{
		// genter templaten ind
		$fp = fopen("themes/".$SITE_TEMPLATE."/".$Theme["Item"]["Template"],"r");
		while(!feof($fp)) 
		{
			$Template .= fgets($fp, 4096);
		}
		fclose($fp);
	}

	return $Template;
}
?>
