<?php
/*******************************************************************
 *  cmsWorks                                                       *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  6.3.6                                                *
 *	Modified: 2006-02-10 04:46                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *******************************************************************/

// current brance version, is overwritten later.
$VERSION = "2.2.0"; 

// Effectively turn off dangerous register_globals without having to edit php.ini
if (ini_get(register_globals))  // If register_globals is enabled
{ 
	// Unset $_GET keys
  foreach ($_GET as $get_key => $get_value) 
  {
		if (ereg('^([a-zA-Z]|_){1}([a-zA-Z0-9]|_)*$', $get_key)) 
		{
		 eval("unset(\${$get_key});");
		}
  } 
  reset($_GET);
  // Unset $_POST keys
  foreach ($_POST as $post_key => $post_value) 
  {
		if (ereg('^([a-zA-Z]|_){1}([a-zA-Z0-9]|_)*$', $post_key)) 
		{
		 eval("unset(\${$post_key});");
		}
  } 
  reset($_POST);
  // Unset $_REQUEST keys
  foreach ($_REQUEST as $request_key => $request_value) 
  {
		if (ereg('^([a-zA-Z]|_){1}([a-zA-Z0-9]|_)*$', $request_key)) 
		{
		 eval("unset(\${$request_key});");
		}
  }
  reset($_REQUEST);
}

// include config stuff and makes db connection
include_once "libs/lib.config.php";

// fix url
include_once "libs/lib.url.php";

// updates files and data after a system upgrade
include_once "libs/lib.update.php";

// includes
include_once("libs/lib.banner.php");
include_once("libs/lib.basket.php");
include_once("libs/lib.customers.php");
include_once("libs/lib.login.php");
include_once("libs/lib.mail.php");
include_once("libs/lib.menu.php");
include_once("libs/lib.pages.php");
include_once("libs/lib.template.php");
include_once("libs/lib.translation.php");
include_once("libs/lib.rss.php");

// std modules in the system (these should be convertet to plugins)
include_once "libs/lib.contact.php";
include_once "libs/lib.faq.php";
include_once "libs/lib.groups.php";
include_once "libs/lib.items.php";
include_once "libs/lib.news.php";
include_once "libs/lib.text.php";

// function includes
include_once "include/api.inc.php";
include_once "include/datetime.lib.php";
include_once "admin/include/class.img_resize.php";	// image class

// user tracting
include_once "libs/lib.session.php";
UserSessions($SITE_NAME);

// find browser language
include_once "libs/lib.language.php";
Browser_Language();

// include translation
include_once "libs/lib.translation.php";

// fetching theme cfg
Template_cfg();

// sets default width for this theme
$MainWidth = $Theme["MainWidth"];
$MenuWidth = $Theme["MenuWidth"];

// fecthing templates
$Template_site 				= Template_site();
$Template_main 				= Template_main();
$Template_menu_right 	= Template_menu("Right");
$Template_menu_left 	= Template_menu("Left");
$Template_item 				= Template_item();
$Template_object			= Template_load($Theme["Object"]["Template"]);

// login stuff
Customer_login($_POST["Login"], $_POST["Password"]);

// removing back from item
if($get["Type"] != "Item")
	unset($_SESSION["Itemgroup"]["ID"]);
	
// set search value for custom designed search box
$Template_site = str_replace("##SearchValue##", $_GET["Itemsearch"], $Template_site);

// show flags if tag is found
$Template_site = str_replace("##Languages##", Browser_language_flags(), $Template_site);

// resets pageid session var
$_SESSION["PageID"] = "";

// template controle var
$Theme_is_changed = false;

// check to se if the site is closed and if this is and we are not login in on the admin page
// the show the site closed system text
if($SITE_CLOSED == "yes" AND empty($_SESSION["$ADMIN_NAME"]["user"]["id"]))
{
	$closed_text = Text_system("Site Closed");
	$Template_site = str_replace("##Main##", $closed_text, $Template_site);
}
else 
{
	// find the page type
	switch($get["Type"])
	{
		case "Itemgroup":
			$Template_site = str_replace("##Main##", Gruppe_valg($MainWidth, $Template_main), $Template_site);
			break;
		
		case "Item":
			$Template_site = str_replace("##Main##", Show_item($Template_item, $get["ItemlineID"], $Theme["Path"].$Theme["Submit"]["Gfx"], $Theme["Basket"]["ToBaketTypeVariant"], "center", 300, 200, $MainWidth, $_SESSION["Language"]["Code"]), $Template_site);
			break;
			
		case "basket":
			$Template_site = str_replace("##Main##", Basket_next($MainWidth, $Template_main), $Template_site);
			break;
		
		case "customer":
			$Template_site = str_replace("##Main##", Customer($MainWidth, $Template_object), $Template_site);
			break;	
	
		default:
			// check for page name, and convert it to the ID.
			if(!is_numeric($get["ID"]) AND !empty($get["ID"]))
			{
				$rs_page = mysql_query("SELECT PageID FROM web_page_obj WHERE Name='".rawurldecode($get["ID"])."'" , $db);
				if($row_page = mysql_fetch_row($rs_page))
					$get["ID"] = $row_page[0];
				else
				{
					$found = false;
					
					$rs_page = mysql_query("SELECT PageID, Name FROM web_page_obj" , $db);
					while($row_page = mysql_fetch_row($rs_page))
					{
						if(ereg_replace("[^[:alnum:]+]", "", $get["page"]) == ereg_replace("[^[:alnum:]+]","", $row_page[1]))
						{
							$get["ID"] = $row_page[0];					
							$found = true;
						}
					}
						
					if(!$found)
						$get["ID"] = "";
				}
			}
			
			// make shure that ther always is a MainPage
			if(empty($get["ID"]) OR $get["ID"] == "0")
			{
				$rs = mysql_query("SELECT PageID FROM web_menu_links WHERE Std='yes'", $db);
				if($row = mysql_fetch_row($rs))
				{
					$ID = $row[0];
				}
				else 
				{
					$rs = mysql_query("SELECT ID FROM web_page WHERE web_page.Default='yes'",$db);
					$row = mysql_fetch_row($rs);
					$ID = $row[0];
				}
			}
			else
			{
				$ID = $get["ID"];
			}
			
			$_SESSION["PageID"] = $ID;
	
			// insert the page that i selected
			$Template_site = str_replace("##Main##", Page($ID, $MainWidth, $get["mID"]), $Template_site);
			break;
	}
	
	// fix menus
	$rs_menus = mysql_query("SELECT Location, Template, ID FROM web_menu GROUP BY Location", $db);
	while($row_menus = mysql_fetch_row($rs_menus))
	{
		$menu_used = false;

		// the new system have presedense
		if(!isset($Theme["Menu"]["Location"][$row_menus[0]]["Tag"]))
		{
			switch ($row_menus[0])
			{
				case "Top":
					// inserting top menu
					$Template_site = str_replace("##Menu_top##", Menu_top($_SESSION["Language"]["Code"], $Theme["TopMenu"]["Width"], $Theme["TopMenu"]["StartSpace"], $Theme["TopMenu"]["Space"], $Theme["TopMenu"]["EndSpace"], "Top", $row_menus[2]), $Template_site);
					// menu used
					$menu_used = true;
					break;
					
				case "Left":
					// inserting left menu
					if(!empty($Theme["Menu"]["Location"][$row_menus[0]]["Width"]))
						$MenuWidthLeft = $Theme["Menu"]["Location"][$row_menus[0]]["Width"];
					else 
						$MenuWidthLeft = $MenuWidth;
					$Template_site = str_replace("##Menu_left##",Menu($Template_menu_left, $_SESSION["Language"]["Code"], $MenuWidthLeft, "Left"), $Template_site);
					// menu used
					$menu_used = true;
					break;
					
				case "Right":
					// inserting right menu
					if(!empty($Theme["Menu"]["Location"][$row_menus[0]]["Width"]))
						$MenuWidthRight = $Theme["Menu"]["Location"][$row_menus[0]]["Width"];
					else 
						$MenuWidthRight = $MenuWidth;
					$Template_site = str_replace("##Menu_right##",Menu($Template_menu_right, $_SESSION["Language"]["Code"], $MenuWidthRight, "Right"), $Template_site);
					// menu used
					$menu_used = true;
					break;
			}
		}
					
		if(!$menu_used)
		{
			// orientation
			switch ($Theme["Menu"]["Location"][$row_menus[0]]["Orientation"])
			{
				case "HORIZONTAL":				
					$menu_tag = $Theme["Menu"]["Location"][$row_menus[0]]["Tag"];
					$menu_width = $Theme["Menu"]["Location"][$row_menus[0]]["Width"];
					$menu_start_space = $Theme["Menu"]["Location"][$row_menus[0]]["StartSpace"];
					$menu_space = $Theme["Menu"]["Location"][$row_menus[0]]["Space"];
					$menu_end_space = $Theme["Menu"]["Location"][$row_menus[0]]["EndSpace"];

					$menu_str = Menu_top($_SESSION["Language"]["Code"], $menu_width, $menu_start_space, $menu_space, $menu_end_space, $row_menus[1], $row_menus[2]);					
					$Template_site = str_replace($menu_tag , $menu_str, $Template_site);
					break;
					
				default:
					$menu_tag = $Theme["Menu"]["Location"][$row_menus[0]]["Tag"];
					$menu_width = $Theme["Menu"]["Location"][$row_menus[0]]["Width"];
					$menu_template = "";
					
					$Template_site = str_replace($menu_tag, Menu($menu_template, $_SESSION["Language"]["Code"], $menu_width, $row_menus[0], $row_menus[1]), $Template_site);
					break;
			}	
		}
	}
}

// check for unused menue tags
if(isset($Theme["Menu"]["Location"]))
{
	foreach ($Theme["Menu"]["Location"] as $key => $value)
	{
		$Template_site = str_replace($Theme["Menu"]["Location"][$key]["Tag"], "", $Template_site);
	}
}
// remove old unused tags
$Template_site = str_replace("##Menu_top##", "", $Template_site);
$Template_site = str_replace("##Menu_left##", "", $Template_site);
$Template_site = str_replace("##Menu_right##", "", $Template_site);

// custom login
$Template_site = str_replace("##Login##", Customer_custom_login(), $Template_site);

// rss feed
$Template_site = str_replace("##RSS##", rss_link(), $Template_site);
$Template_site = str_replace("##RSS_link##", rss_live_bookmark_link(), $Template_site);

// output the site :o)
echo $Template_site;

// generate a new theme.cfg is it has been changed.
if($Theme_is_changed)
{
	$var = Template_vars();
	Template_generate_theme_cfg($var);
}
?>
