<?php
/*******************************************************************
 *  cmsWorks - gallery plugin                                      *
 *  Copyright (C) 2003-2005 Ryan Skov                              *
 *                                                                 *
 *  Licensed under the terms of the GNU General Public License:    *
 * 		http://www.opensource.org/licenses/gpl-license.php           *
 *                                                                 *
 *  For further information visit:                                 *
 * 		http://www.netslave.dk/cmsworks                              *
 *                                                                 *
 *  Version:  1.1.6                                                *
 *	Modified: 2006-02-05 22:36                                     *
 *                                                                 *
 *  File Authors:                                                  *
 *    Ryan Skov (ryan[at]netslave.dk)                              *
 *    Peter Drengsgaard (peter[at]raichu.dk)                       *
 *******************************************************************/
 
function gallery_rotate_image($dir, $file, $rotate_value, $rotate = "right") 
{
	global $Theme;
	
	include_once("admin/include/class.gallery.php");
	
	$ext = substr($file, -3);

	if(strtolower($ext) == "jpg")
		$source = imagecreatefromjpeg($dir."/".$file);
	else if(strtolower($ext) == "png")
		$source = imagecreatefrompng($dir."/".$file);
	
	if($rotate != "left") 
		$rotate_value = $rotate_value*-1;

	$source = imageRotate($source, $rotate_value, 0);
		
	if(strtolower($ext) == "jpg")
		imagejpeg($source, $dir."/".$file, 100);
	else if(strtolower($ext) == "png")
		imagepng($source, $dir."/".$file, 100);
	
	// dir thumb		
	$thumb = new GALLERY();
	$thumb->GALLERY_resize_img("$dir/$file", "$dir/thumbs/d-$file", $Theme['Gallery']['DirPicMaxHeight'], $Theme['Gallery']['DirPicMaxWidth'], $Theme['Gallery']['LogoPic'] );	
	$thumb->GALLERY_resize_img("$dir/$file", "$dir/thumbs/p-$file", "", $Theme['Gallery']['PicWidth'], $Theme['Gallery']['LogoPic'] );	
}

function _gallery_resize_image($file_in, $file_out, $width, $logo = "yes")
{
	$real_in_file = $file_in;
	
	// add logo if one is defined in the config
	if(!empty($_SESSION["Theme"]["Gallery"]["LogoPic"]) AND is_file($_SESSION["Theme"]["Gallery"]["LogoPic"]) AND $logo == "yes")
	{
		include_once("classes/Image_Toolbox.class.php");
		
		$img = new Image_Toolbox("$file_in");
		$img->addImage($_SESSION["Theme"]["Gallery"]["LogoPic"]);

		switch($_SESSION["Theme"]["Gallery"]["LogoLocation"])
		{
			case "RIGHT_TOP":
				$img->blend('right','top');
				break;
			case "LEFT_BOTTOM":
				$img->blend('left','bottom');
				break;
			case "LEFT_TOP":
				$img->blend('left','top');
				break;
			default:
				$img->blend('right','bottom');
				break;
		}
		
		$ext_arr = explode(".", $file_out);
		$extension = $ext_arr[(count($ext_arr)-1)];
		if(strtolower($extension) == "jpg")
			$img->save("$file_out", 'jpg');
		else
			$img->save("$file_out", 'png');
			
		$real_in_file = $file_out;
	}
	
	$thumb=new thumbnail("$file_out");		// generate image_file, set filename to resize
	$thumb->size_width($width);				// set width for thumbnail, or
	$thumb->jpeg_quality(100);				// [OPTIONAL] set quality for jpeg only (0 - 100) (worst - best), default = 75
	$thumb->save("$file_out");
}

function gallery_navigation($parrent_id, $type="")
{
	global $db, $Theme, $get;

	// find name of root
	$rs = mysql_query("SELECT Name FROM web_gallery_dirs WHERE ID='1'", $db);
	$row = mysql_fetch_row($rs);
	if($row[0] == "Overview")
		$over = Translate("Overview");
	else 
		$over = $row[0];
	
	// navigation
	$g["ID"] = $get["ID"];
	$g["mID"] = $get["mID"];
	$g["tID"] = $get["tID"];
	$g["ParrentID"] = "";
	$navi_link  = "<a href='".url_generate($g, true)."'>".$over."</a>";
	$tmp_parrent_id = $parrent_id;
	while($tmp_parrent_id != 1)
	{
		// find name of dir
		$rs_dir = mysql_query("SELECT ParrentID, Name FROM web_gallery_dirs WHERE ID= '".$tmp_parrent_id."'", $db);
		$row_dir = mysql_fetch_row($rs_dir);
		
		// url stuff 
		$g["ParrentID"] = $tmp_parrent_id;
		
#		if($type == "requestdelete")
			$navi_link_tmp = " -> <a href='".url_generate($g, true)."'>".$row_dir[1]."</a>".$navi_link_tmp;
#		else 
#			$navi_link_tmp = " -> ".$row_dir[1].$navi_link_tmp;
		
		$tmp_parrent_id = $row_dir[0];
	}
	$navi_link .= $navi_link_tmp;
	
	return $navi_link;
}


function gallery_show_image($file_id, $type)
{
	global $db;
	
	$rs_pic = mysql_query("SELECT DirID, Filename FROM web_gallery_pics WHERE ID='".$file_id."'", $db);
	$row_pic = mysql_fetch_row($rs_pic);
	
	$file = "files/gallery/";
	
	if($row_pic[0] != 0)
	{
		$rs_dir = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID='".$row_pic[0]."'", $db);
		$row_dir = mysql_fetch_row($rs_dir);
		$file .= $row_dir[0]."/";
	}
	
	// type
	switch ($type) 
	{
		case "d":
			$file .= "thumbs/d-";
			break;
			
		case "p":
			$file .= "thumbs/p-";
			break;
	}
	$file .= $row_pic[1];
	
	//First, see if the file exists
#	if (!is_file($file)) { die("<b>404 File not found!</b>"); }

	//Gather relevent info about file
	$len = filesize($file);
	$filename = basename($file);
	$file_extension = strtolower(substr(strrchr($filename,"."),1));

	//This will set the Content-Type to the appropriate setting for the file
	switch( $file_extension ) 
	{
		case "pdf": $ctype="application/pdf"; break;
		case "exe": $ctype="application/octet-stream"; break;
		case "zip": $ctype="application/zip"; break;
		case "doc": $ctype="application/msword"; break;
		case "xls": $ctype="application/vnd.ms-excel"; break;
		case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
		case "gif": $ctype="image/gif"; break;
		case "png": $ctype="image/png"; break;
		case "jpeg":
		case "jpg": $ctype="image/jpg"; break;
		case "mp3": $ctype="audio/mpeg"; break;
		case "wav": $ctype="audio/x-wav"; break;
		case "mpeg":
		case "mpg":
		case "mpe": $ctype="video/mpeg"; break;
		case "mov": $ctype="video/quicktime"; break;
		case "avi": $ctype="video/x-msvideo"; break;
		
		//The following are for extensions that shouldn't be downloaded (sensitive stuff, like php files)
		case "php":
		case "htm":
		case "html":
		case "txt": die("<b>Cannot be used for ". $file_extension ." files!</b>"); break;
		
		default: $ctype="application/force-download";
	}

	//Begin writing headers
#	header("Pragma: public");
#	header("Expires: 0");
#	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
#	header("Cache-Control: public");
#	header("Content-Description: File Transfer");
	
	//Use the switch-generated Content-Type
	
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Cache-Control: must-revalidate");
	
	header("Content-Type: $ctype");
	
	//Force the download
#	$header="Content-Disposition: attachment; filename=".$filename.";";
#	header($header );
#	header("Content-Transfer-Encoding: binary");
#	header("Content-Length: ".$len);
/*
  $chunksize = 1*(1024*1024); // how many bytes per chunk
  $buffer = '';
  $handle = fopen($file, 'rb');
  if ($handle === false) {
   return false;
  }
  while (!feof($handle)) {
   $buffer = fread($handle, $chunksize);
   print $buffer;
  }
  fclose($handle); 
*/
	@readfile($file);
	exit;	
}

function _gallery_find_sub_dirs($parrent_id)
{
	global $db, $Theme;
	
	$dirs = "";
	
	$rs = mysql_query("SELECT ID, Path FROM web_gallery_dirs WHERE ParrentID='".$parrent_id."'", $db);
	while($row = mysql_fetch_row($rs))
	{
		if(is_dir("files/gallery/$row[1]"))
		{
			$dir .= "DirID='".$row[0]."' OR ";
		
#			$dir .= _gallery_find_sub_dirs($row[0]);
		}
	}
	
	return $dir;
}

// check to se of there is pictures in som subdirs
function _gallery_check_for_pictures_in_dirs($dir_id)
{
	global $db;
	
	// find out if there is pictures in this dir
	$rs_pic = mysql_query("SELECT ID FROM web_gallery_pics WHERE DirID='".$dir_id."'", $db);
	if($row_pic = mysql_fetch_row($rs_pic))
		return true;
	else 
	{
		$rs_sub = mysql_query("SELECT ID FROM web_gallery_dirs WHERE ParrentID='".$dir_id."'", $db);
		while ($row_sub = mysql_fetch_row($rs_sub)) 
		{
			if(_gallery_check_for_pictures_in_dirs($row_sub[0]))
				return true;
		}
	}
	
	return false;
}

function gallery_list($obj_template, $options, $width, $plugin_id, $version)
{
	global $db, $Theme, $ADMIN_NAME, $get, $SOE_URLS, $SITE_PATH;
	
	$dir_col_max = $Theme["Gallery"]["DirColumns"];
	$dir_col_space = 10;
	$dir_css_headline = "tableHeadRow";
	$dir_css_comment = "textBody";
	if($Theme["Gallery"]["DirOrder"] == "DATE")
		$dir_order = "ID";
	else if($Theme["Gallery"]["DirOrder"] == "DATE_DESC")
		$dir_order = "ID DESC";
	else if($Theme["Gallery"]["DirOrder"] == "ALPHABETIC")
		$dir_order = "Name";
	else 
		$dir_order = "Name DESC";
	
	// check dir
	if(!is_dir("files/gallery"))
		mkdir("files/gallery");

	// find path 
	$path = "files/gallery/";

	if(empty($get["ParrentID"]))
		$parrent_id = 1;
	else 
		$parrent_id = $get["ParrentID"];

	// navigation
	$body = gallery_navigation($parrent_id)."<br>";

	
	///////////////////////////////////////////////////
	// generate dirs
	$html_dirs = "<table cellpadding='0' cellspacing='0' width='100%'>\n";
	$col_count = 1;

	$rs_dir = mysql_query("SELECT ID, Headline, Comment, Path FROM web_gallery_dirs WHERE ParrentID = '".$parrent_id."' ORDER BY ".$dir_order, $db);
	echo mysql_error();
	while($row_dir = mysql_fetch_row($rs_dir))
	{		
		// url stuff
		$get2 = $get;
		$get2["ParrentID"] = $row_dir[0];
		$dir_link = url_generate($get2, true);

		// if the folder is there and there is som pictures in it or som sub dir
		if((is_dir("files/gallery/".$row_dir[3]) AND _gallery_check_for_pictures_in_dirs($row_dir[0])) OR $row_dir[3] == ".")
		{ 			
			$dir_ok = true;
			
			$sub_dirs = substr(_gallery_find_sub_dirs($row_dir[0]), 0, -4);
			if(!empty($sub_dirs))
				$sub_dirs = " OR ".$sub_dirs;

			// make new row if col_count is 1
			if($col_count == 1)
				$html_dirs .= "	<tr>\n";
		
			// find random pic from path
			$rs_pic = mysql_query("SELECT Filename, Path, web_gallery_pics.ID FROM web_gallery_pics, web_gallery_dirs WHERE web_gallery_dirs.ID=web_gallery_pics.DirID AND (DirID='".$row_dir[0]."' ".$sub_dirs.") ORDER BY RAND() LIMIT 1", $db);
			echo mysql_error();
			if($row_pic = mysql_fetch_row($rs_pic))	
			{
				// show dir
				$html_dirs .= "		<td align='center' width='".(floor(100/$dir_col_max)-2)."%'>\n";
				
				$html_dirs .= "			<table cellpadding='0' cellspacing='0'>\n";
				$html_dirs .= "				<tr>\n";
				$html_dirs .= "					<td  class='".$dir_css_headline."' colspan='2'><a href='".$dir_link."'>".$row_dir[1]."</a></td>\n";
				$html_dirs .= "				</tr>\n";
				$html_dirs .= "				<tr>\n";
				// url stuff
				if($SOE_URLS)
					$pic_url = $SITE_PATH."picture/fID/".$row_pic[2]."/type/d";
				else 
					$pic_url = $SITE_PATH."picture.php?fID=".$row_pic[2]."&type=d";
				$html_dirs .= "					<td><a href='".$dir_link."'><img alt='".$row_pic[0]."' src='".$pic_url."' border='0'></a></td>\n";
				$html_dirs .= "				</tr>\n";		
				$html_dirs .= "			</table>\n";
				
				$html_dirs .= "		</td>\n";
			}
			else 
			{
				// show dir
				$html_dirs .= "		<td align='center' width='".(floor(100/$dir_col_max)-2)."%'>\n";
				
				$html_dirs .= "			<table cellpadding='0' cellspacing='0'>\n";
				$html_dirs .= "				<tr>\n";
				$html_dirs .= "					<td  class='".$dir_css_headline."' colspan='2'><a href='".$dir_link."'>".$row_dir[1]."</a></td>\n";
				$html_dirs .= "				</tr>\n";
				$html_dirs .= "			</table>\n";
				
				$html_dirs .= "		</td>\n";				
			}

			// make end of row
			if($col_count == $dir_col_max)
			{
				$html_dirs .= "	</tr>\n";				
				$col_count = 1;
			}
			else 
			{
				// make space
				$html_dirs .= "		<td width='".$dir_col_space."' style='font-size: 2px'>&nbsp;</td>\n";
				
				// increase col_count
				$col_count++;		
			}
		}
/*		
		else if(!is_dir("files/gallery/$row_dir[3]"))
		{
	
			$sub_dirs = substr(_gallery_find_sub_dirs($row_dir[0]), 0, -4);
			if(!empty($sub_dirs))
				$sub_dirs = " OR ".$sub_dirs;

			$sql = "DELETE FROM web_gallery_dirs WHERE ID='".$row_dir[0]."'".$sub_dirs;
			mysql_query($sql, $db);			
		}
*/
	}	
	
	// fill up
	if($col_count != $dir_col_max)
	{
		for($x = $col_count; $x <= $dir_col_max; $x++)
		{
			$html_dirs .= "			<td width='".(floor(100/$dir_col_max)-2)."%'>&nbsp;</td>\n";
			$html_dirs .= "			<td width='".$dir_col_space."' style='font-size: 2px'>&nbsp;</td>\n";
		}
		$html_dirs .= "	</tr>\n";
	}
	// finish table
	$html_dirs .= "</table>\n";
	if($dir_ok)
	{
		$dir_template = Template_load($Theme['Gallery']['DirTemplate']);
		if(!empty($dir_template))
			$body .= str_replace("##Body##", $html_dirs, str_replace("##Width##", $width, $dir_template));
		else 
			$body .= $html_dirs;
	}

		
	// show pics
	
	// use std template or load the one from theme.cfg.
	if(!empty($Theme['Gallery']['PicTemplate']))
		$pic_template = Template_load($Theme['Gallery']['PicTemplate']);
	// if empty generate std tempalate
	if(empty($pic_template) OR !is_file($Theme["Path"].$Theme["Gallery"]["PicTemplate"]))	
	{
		$pic_template  = "<table cellpadding='0' cellspacing='0' width='##Width##'>\n";
		$pic_template .= "	<tr>\n";
		$pic_template .= "		<td style='border-bottom: 1px solid #000000' align='center'>\n";
		$pic_template .= "			<table cellpadding='0' cellspacing='0'>\n";
		$pic_template .= "				<tr>\n";
		$pic_template .= "					<td width='20%' align='center'>##MakeComment##</td>\n";
		$pic_template .= "					<td width='20%' align='center'>##PostCard##</td>\n";
		$pic_template .= "					<td width='20%' align='center'>##RequestDelete##</td>\n";
		$pic_template .= "				</tr>\n";
		$pic_template .= "			</table>\n";
		$pic_template .= "		</td>\n";
		$pic_template .= "	</tr>\n";
		$pic_template .= "	<tr>\n";
		$pic_template .= "		<td style='border-left: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000;'>\n";
		$pic_template .= "			<table width='100%'>\n";
		$pic_template .= "				<tr>\n";
		$pic_template .= "					<td>##Picture##</td>\n";
		$pic_template .= "					<td>##Comment##</td>\n";
		$pic_template .= "				</tr>\n";
		$pic_template .= "			</table>\n";
		$pic_template .= "		</td>\n";
		$pic_template .= "	</tr>\n";
		$pic_template .= "</table>\n";
		$pic_template .= "<br>\n";
		
		// write to std to theme
		$filename = $Theme["Path"]."galleryPic.html";
		if (is_writable($Theme["Path"])) 
		{
			$fp = fopen($filename, "w");
			fwrite($fp, $pic_template);
			fclose($fp);
				
			$Theme['Gallery']['PicTemplate'] = "galleryPic.html";
			$var = Template_vars();
			Template_generate_theme_cfg($var);
		}
	}
	
	// name of current dir
	$rs_dir = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID = '".$parrent_id."'", $db);
	$row_dir = mysql_fetch_row($rs_dir);
	
	// make limit on how many to show
	if(empty($get["limit"]))
		$limit = 0;
	else 
		$limit = $get["limit"];
		
	// navi bar
	$navi  = "<table width='100%'>\n";
	$navi .= "	<tr>\n";
	$navi .= "		<td align='center' class='".$Theme["Gallery"]["ClassLimit"]."'>\n";

	$limit_back = $limit - $Theme["Gallery"]["PicNumber"];
	
	if($limit != 0)
	{
		// url stuff
		$get["limit"] = $limit_back;
		$get["ParrentID"] = $parrent_id;
		$navi .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimitLink"]."'>";
	}
		
	if(!empty($Theme["Gallery"]["LimitBackGfx"]) AND is_file($Theme["Path"]."/".$Theme["Gallery"]["LimitBackGfx"]))
		$navi .= "<img src='".$Theme["Path"]."/".$Theme["Gallery"]["LimitBackGfx"]."' border='0'>";
	else 
		$navi .= "<< ".Translate("Back");
		
	if($limit != 0)		
		$navi .= "</a>\n";
		
	// display numbers as pages and highlite the selected page
	$rs_num_pic = mysql_query("SELECT ID FROM web_gallery_pics WHERE DirID='".$parrent_id."'",$db);
	$num_pic = mysql_num_rows($rs_num_pic);

	$page_number = $limit/$Theme["Gallery"]["PicNumber"];
	$page_number++;	
	$page_max = ceil($num_pic/$Theme["Gallery"]["PicNumber"]);

	$navi .= "&nbsp;&nbsp;".$page_number."&nbsp;".Translate("Of")."&nbsp;".$page_max."&nbsp;&nbsp;";

	$limit_next = $limit + $Theme["Gallery"]["PicNumber"];
	if($page_max > $page_number)
	{
		$get["limit"] = $limit_next;
		$get["ParrentID"] = $parrent_id;
		$navi .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimit"]."'>";
	}
	if(!empty($Theme["Gallery"]["LimitNextGfx"]) AND is_file($Theme["Path"]."/".$Theme["Gallery"]["LimitNextGfx"]))
		$navi .= "<img src='".$Theme["Path"]."/".$Theme["Gallery"]["LimitNextGfx"]."' border='0'>";
	else 
		$navi .= Translate("Next")." >>";
		
	if($page_max > $page_number)
		$navi .= "</a>\n";
	
	$navi .= "		</td>\n";
	$navi .= "	</tr>\n";
	$navi .= "</table>\n";

#	unset($get);
#	url_set();	
#print_r($get);	
#echo $get["ParrentID"];
	// find pics in this dir
	$sql = "SELECT ID, Filename FROM web_gallery_pics WHERE DirID='".$parrent_id."' LIMIT ".$limit.",".$Theme["Gallery"]["PicNumber"];
	$rs_pic = mysql_query($sql, $db);
	while($row_pic = mysql_fetch_row($rs_pic))
	{
		if(is_file("files/gallery/$row_dir[0]/$row_pic[1]"))
		{		
			// control var
			$is_pictures = true;
			
			// copy template
			$tmp_pic_template = $pic_template;
			
			// pic link
	#		$link_pic = "files/gallery/".urlencode($row_dir[0])."/".urlencode($row_pic[1]);
	#		$link_pic_thumb = "files/gallery/".urlencode($row_dir[0])."/thumbs/p-".urlencode($row_pic[1]);
			$link_pic = "files/gallery/".$row_dir[0]."/".urlencode($row_pic[1]);
			$link_pic_thumb = "files/gallery/".$row_dir[0]."/thumbs/p-".urlencode($row_pic[1]);
			
			// make rotate and delete links if an admin is loged in
			if(!empty($_SESSION[$ADMIN_NAME]["user"]["id"]))
			{
				$controls  = "<table width='100%'>\n";
				$controls .= "	<tr>\n";
				$controls .= "		<td>\n";
				$get["limit"] = $limit;
				$get["pID"] = $row_pic[0];
				$get["action"] = "rotate";
				$get["rotate"] = "left";
				$controls .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimitlink"]."'><< ".Translate("Rotate left")."</a>";
				$controls .= "		</td>\n";
				$controls .= "		<td align='center'>\n";
				$get["action"] = "requestdeleteaccept";
				$controls .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimitlink"]."'>".Translate("Delete")."</a>";
				$controls .= "		</td>\n";
				$controls .= "		<td align='center'>\n";
				$get["action"] = "comment";
				$controls .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimitlink"]."'>".Translate("Comment")."</a>";
				$controls .= "		</td>\n";
				$controls .= "		<td align='right'>\n";
				$get["action"] = "rotate";
				$get["rotate"] = "right";
				$controls .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimitlink"]."'>".Translate("Rotate right")." >></a>";
				$controls .= "		</td>\n";
				$controls .= "	</tr>\n";
				$controls .= "</table>\n";
			}
	
			// url stuff
			url_set();
			if($SOE_URLS)
			{
				$pic_url_large = $SITE_PATH."picture/fID/".$row_pic[0];
				$pic_url = $pic_url_large."/type/p";	
			}
			else 
			{
				$pic_url_large = $SITE_PATH."picture.php?fID=".$row_pic[0];
				$pic_url = $pic_url_large."&type=p";				
			}
			$pic = "<a href='".$pic_url_large."' target='_new_'><img alt='".$row_pic[0]."' src='".$pic_url."' border='0'></a>";
			$tmp_pic_template = str_replace("##Picture##", $controls.$pic, $tmp_pic_template);
			
			// postcard link
			$get["action"] = "postcard";
			$get["limit"] = $limit;
			$get["pID"] = $row_pic[0];
			$link_postcard = url_generate($get, true);
			
			$postcard = "<a href='".$link_postcard."' class='".$Theme["Gallery"]["ClassMenu"]."'>".Translate("Send postcard")."</a>";
			
			$tmp_pic_template = str_replace("##PostCard##", $postcard, $tmp_pic_template);
			
			
			// comment
			$get["action"] = "comment";
			$link_comment = url_generate($get, true);
	
			$comment = "<a href='".$link_comment."' class='".$Theme["Gallery"]["ClassMenu"]."'>".Translate("Comment")."</a>";
			
			$tmp_pic_template = str_replace("##MakeComment##", $comment, $tmp_pic_template);
			
			// find last comment and show
			$rs_comment = mysql_query("SELECT Comment FROM web_gallery_comments WHERE PicID='".$row_pic[0]."' ORDER BY Created DESC LIMIT 1", $db);
			$row_comment = mysql_fetch_row($rs_comment);
			
			if(empty($row_comment[0]))
				$comment = "&nbsp;";
			else 
				$comment = str_replace("\n", "<br>", $row_comment[0]);
			$tmp_pic_template = str_replace("##Comment##", $comment, $tmp_pic_template);
	
			
			// request delete
			$get["action"] = "requestdelete";
			$link_request_delete = url_generate($get, true);
	
			$request_delete = "<a href='".$link_request_delete."' class='".$Theme["Gallery"]["ClassMenu"]."'>".Translate("Request delete")."</a>";
			
			$tmp_pic_template = str_replace("##RequestDelete##", $request_delete, $tmp_pic_template);
			
			
			// add the image to the body
			$pic_body .= $tmp_pic_template;
		}
		else 
		{
			// remove from db, because the file is not there
			mysql_query("DELETE FROM web_gallery_pics WHERE ID='".$row_pic[0]."'", $db);
			mysql_query("DELETE FROM web_gallery_comments WHERE PicID='".$row_pic[0]."'", $db);
		}
	}

	if($is_pictures)
		$body .= $navi;
	
	$body .= $pic_body;

	if($is_pictures)
		$body .= $navi;
	
	// load template
	$template = Template_load($obj_template);

	$template = str_replace("##Body##", $body, $template);
	$template = str_replace("##Width##", $width, $template);
	$template = str_replace("##Headline1##", Translate("Gallery"), $template);
	$template = str_replace("##Headline2##", "&nbsp;", $template);
		
	$str = $template;
	
	return $str;
}

function gallery_postcard($id, $width, $obj_template)
{
	global $db, $Theme, $SITE_NAME, $SITE_WEBMASTER, $get, $SOE_URLS, $SITE_PATH;

	// pic url
	if($SOE_URLS)
		$path = $SITE_PATH."picture/fID/".$get["pID"];
	else 
		$path = $SITE_PATH."picture.php?fID=".$get["pID"];
	
	// load postcasd template
	$pic_template = Template_load($Theme['Gallery']['PostcardTemplate']);

	// if empty generate std tempalate
	if(empty($pic_template) OR !is_file($Theme["Path"].$Theme["Gallery"]["PicTemplate"]))	
	{
		$pic_template  = "<table cellpadding='0' cellspacing='0' width='100%'>\n";
		$pic_template .= "	<tr>\n";
		$pic_template .= "		<td colspan='4'>\n";
		$pic_template .= "			<table cellpadding='2' cellspacing='0' width='100%'>\n";
		$pic_template .= "				<tr><td colspan='2' width='100%'>##Picture##</td></tr>\n";
		$pic_template .= "				<tr><td colspan='2' width='100%' style='font-size: 10px'><i>##YourName##</i></td></tr>\n";
		$pic_template .= "				<tr><td colspan='2' width='100%' style='font-size: 10px'><i>##YourEmail##</i></td></tr>\n";
		$pic_template .= "				<tr><td colspan='2' width='100%' style='font-size: 10px'><i>##Message##</i></td></tr>\n";
		$pic_template .= "				<tr><td colspan='2' width='100%' style='font-size: 10px'><i>##Email##</i></td></tr>\n";
		$pic_template .= "				<tr>\n";
		$pic_template .= "					<td>##Back##</td>\n";
		$pic_template .= "					<td align='right'>##Submit##</td>\n";
		$pic_template .= "				</tr>\n";
		$pic_template .= "			</table>\n";
		$pic_template .= "		</td>\n";
		$pic_template .= "	</tr>\n";
		$pic_template .= "</table>\n";
		
		// write to std to theme
		$filename = $Theme["Path"]."galleryPostcard.html";
		if (is_writable($Theme["Path"])) 
		{
			$fp = fopen($filename, "w");
			fwrite($fp, $pic_template);
			fclose($fp);
				
			$Theme['Gallery']['PostcardTemplate'] = "galleryPostcard.html";
			$var = Template_vars();
			Template_generate_theme_cfg($var);
		}
	}
	
	// picture
	$pic_template = str_replace("##Picture##", "<img src='".$path."' border='0' width='".($width-4)."'>", $pic_template);
	
	$str  = Translate("Your")."&nbsp;".strtolower(Translate("Name")).":<br><input type='text' size='50' name='YourName' value='".$_SESSION["tmp"]["name"]."' class='feltInput'>";
	$pic_template = str_replace("##YourName##", $str, $pic_template);
	
	$str  = Translate("Your")."&nbsp;".strtolower(Translate("Email")).":<br><input type='text' size='50' name='YourEmail' value='".$_SESSION["tmp"]["email"]."' class='feltInput'>";
	$pic_template = str_replace("##YourEmail##", $str, $pic_template);

	$str  = Translate("Resiver")."&nbsp;".strtolower(Translate("Email")).":<br><input type='text' size='50' name='Email' value='".$_SESSION["tmp"]["email"]."' class='feltInput'>";
	$pic_template = str_replace("##Email##", $str, $pic_template);
	
	$str  = Translate("Message").":<br><textarea rows='5' cols='50' name='Message' class='feltInput'></textarea>";
	$pic_template = str_replace("##Message##", $str, $pic_template);

	$str = "<input type='button' onClick='javascript:do_action(\"postcardsend\")' class='".$Theme["Submit"]["Class"]."' name='".Translate("Send")."' value='Send'>";
	$pic_template = str_replace("##Submit##", $str, $pic_template);

	$str = "<input type='button' onClick='javascript:do_action(\"postcardback\")' class='".$Theme["Submit"]["Class"]."' name='".Translate("Back")."' value='Back'>";
	$pic_template = str_replace("##Back##", $str, $pic_template);
	
	// url stuff
	$body  = "<form action='".url_generate($get, true)."' method='post' name='frmPostcard'>\n";
	$body .= "<input type='hidden' name='action'>\n";
	$body .= "<script>\n";
	$body .= " function do_action(action)\n";
	$body .= " {\n";
	$body .= "		document.frmPostcard.action.value = action;\n";
	$body .= "		document.frmPostcard.submit();\n";
	$body .= "	}\n";
	$body .=  "</script>\n";	
	$body .= $pic_template;
	$body .= "</form>\n";
	
	// load template
	$template = Template_load($obj_template);

	$template = str_replace("##Body##", $body, $template);
	$template = str_replace("##Width##", $width, $template);
	$template = str_replace("##Headline1##", Translate("Postcard"), $template);
	$template = str_replace("##Headline2##", "&nbsp;", $template);
		
	$str = $template;
	
	return $str;
}

function gallery_postcard_send($id)
{
	global $db, $Theme, $SITE_TITTLE, $SITE_WEBMASTER;

	// find pic name
	$sql  = "SELECT Path, Filename ";
	$sql .= "FROM web_gallery_pics, web_gallery_dirs ";
	$sql .= "WHERE web_gallery_pics.ID='".$id."'";
	$sql .= " AND web_gallery_pics.DirID = web_gallery_dirs.ID ";
	$rs_pic = mysql_query($sql, $db);
	$row_pic = mysql_fetch_row($rs_pic);
	
	$pic_name = $row_pic[1];
	$pic = "files/gallery/".$row_pic[0]."/".$row_pic[1];
	$path = "files/gallery/".$row_pic[0]."/";

	$template = Template_load($Theme["Gallery"]["PostcardEmailTemplate"]);
	
	if(empty($template))
	{
		// build the html part, only used is there is no template
		$mail_html  = "<html>\n";
		$mail_html .= "<table>\n";
		$mail_html .= "	<tr>\n";
		$mail_html .= "		<td><img src=\"".$pic_name."\" border='0'></td>\n";
		$mail_html .= "	</tr>\n";
		$mail_html .= "	<tr>\n";
		$mail_html .= "		<td style='font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #000000;'>\n";
		$mail_html .= str_replace("\n", "<br>", $_POST["Message"])."<br><br>";
		$mail_html .= "		</td>\n";
		$mail_html .= "	<tr>\n";
		$mail_html .= "</table>\n";
		$mail_html .= "</html>\n";	
	}
	else
	{
		// use the tmplate and replace tags
		// picture
		$mail_html = str_replace("##Picture##", "<img src='".$pic_name."' border='0'>", $template);
		// message
		$mail_html = str_replace("##Message##", str_replace("\n", "<br>", $_POST["Message"]), $mail_html);
	}
	
	$mail_text = Text_system("Mail only in html");

/*	
	include_once("libs/class/class.html.mime.mail.inc");
		
	$mail = new html_mime_mail('X-Mailer: Html Mime Mail Class');
	$mail->add_html($mail_html, $mail_text);
	$mail->set_charset('iso-8859-1', TRUE);
	$mail->find_html_images($path);
	// bygger mailen
	$mail->build_message();
	// sender
	return  $mail->send("", $_POST["Email"], $_POST["YourName"], $_POST["YourEmail"], $SITE_NAME." ".Translate("Postcard"));
*/

	include_once("classes/htmlMimeMail/htmlMimeMail.php");	

	$mail = new htmlMimeMail();
	$background = $mail->getFile($pic);
	
	$mail->setHtml($mail_html, $mail_text);
	
	// determend the file type
	$ext_arr = explode(".", $pic_name);
	$extension = $ext_arr[(count($ext_arr)-1)];
	switch (strtolower($extension))
	{
		case "jpg":
			$type = "image/jpeg";
			break;
			
		case "png":
			$type = "image/png";
			break;
	}
	
	$mail->addHtmlImage($background, $pic_name, $type);
	
	if(!empty($_POST["YourEmail"]))
		$mail->setReturnPath($_POST["YourEmail"]);
	else 
		$mail->setReturnPath($SITE_WEBMASTER);
			
	$mail->setFrom('"'.$_POST["YourName"].'" <'.$_POST["YourEmail"].'>');
	$mail->setSubject($SITE_TITTLE." ".Translate("Postcard"));
	$mail->setHeader('X-Mailer', 'HTML Mime mail class (http://www.phpguru.org)');
			
	$result = $mail->send(array($_POST["Email"]), 'mail');
}


function gallery_request_delete($id, $parrent_id, $obj_template, $width)
{
	global $db, $Theme, $get;

	$template = Template_load($Theme["Gallery"]["RequestDeleteTemplate"]);

	// if empty generate std tempalate
	if(empty($template) OR !is_file($Theme["Path"].$Theme["Gallery"]["PicTemplate"]))	
	{
		$template  = "<table cellpadding='0' cellspacing='0' width='100%'>\n";
		$template .= "	<tr>\n";
		$template .= "		<td>\n";
		$template .= "			<table cellpadding='2' cellspacing='0' width='100%'>\n";
		$template .= "				<tr><td colspan='2'>##Name##</td></tr>\n";
		$template .= "				<tr><td colspan='2'>##Email##</td></tr>\n";
		$template .= "				<tr><td colspan='2'>##Explanation##</td></tr>\n";
		$template .= "				<tr>\n";
		$template .= "					<td>##Back##</td>\n";
		$template .= "					<td align='right'>##Submit##</td>\n";
		$template .= "				</tr>\n";
		$template .= "			</table>\n";
		$template .= "		</td>\n";
		$template .= "	</tr>\n";
		$template .= "</table>\n";
		
		// write to std to theme
		$filename = $Theme["Path"]."galleryDelete.html";
		if (is_writable($Theme["Path"])) 
		{
			$fp = fopen($filename, "w");
			fwrite($fp, $template);
			fclose($fp);
				
			$Theme['Gallery']['RequestDeleteTemplate'] = "galleryDelete.html";
			$var = Template_vars();
			Template_generate_theme_cfg($var);
		}
	}
	
	
	$body = gallery_navigation($parrent_id, "requestdelete");
	
	$headline = Translate("Request delete");
	if(!empty($template))
		$body = str_replace("##Headline##", $headline, $body);
	else 
		$body .= $headline."<br>";	
		
	$str  = Translate("Name")."&nbsp;".strtolower(Translate("Name")).":<br><input type='text' size='50' name='Name' class='feltInput'>";
	$template = str_replace("##Name##", $str, $template);
	
	$str  = Translate("Email")."&nbsp;".strtolower(Translate("Name")).":<br><input type='text' size='50' name='Email' class='feltInput'>";
	$template = str_replace("##Email##", $str, $template);
	
	$str  = Translate("Explanation").":<br><textarea rows='5' cols='50' name='Explanation' class='feltInput'></textarea>";
	$template = str_replace("##Explanation##", $str, $template);

	$str = "<input type='button' onClick='javascript:do_action(\"requestdeletesend\")' class='".$Theme["Submit"]["Class"]."' name='".Translate("Send")."' value='Send'>";
	$template = str_replace("##Submit##", $str, $template);

	$str = "<input type='button' onClick='javascript:do_action(\"requestdeleteback\")' class='".$Theme["Submit"]["Class"]."' name='".Translate("Back")."' value='Back'>";
	$template = str_replace("##Back##", $str, $template);
	
	$body  = Text_system("Gallery - Request delete");
	$body .= "<form action='".url_generate($get, true)."' method='post' name='frmDelete'>\n";	
	$body .= "<input type='hidden' name='action'>\n";
	$body .= "<script>\n";
	$body .= " function do_action(action)\n";
	$body .= " {\n";
	$body .= "		document.frmDelete.action.value = action;\n";
	$body .= "		document.frmDelete.submit();\n";
	$body .= "	}\n";
	$body .= "</script>\n";
	$body .= $template;
	$body .= "</form>\n";	
	
	// load template
	$template = Template_load($obj_template);

	$template = str_replace("##Body##", $body, $template);
	$template = str_replace("##Width##", $width, $template);
	$template = str_replace("##Headline1##", Translate("Request delete"), $template);
	$template = str_replace("##Headline2##", "&nbsp;", $template);
		
	$str = $template;
	
	return $str;
}

function gallery_request_delete_send()
{
	global $db, $Theme, $SITE_TITTLE, $SITE_WEBMASTER, $get, $SITE_HOSTPATH, $SOE_URLS;
	
	// url stuff
	if($SOE_URLS)
		$path = $SITE_HOSTPATH."picture/fID/".$get["pID"];
	else 
		$path = $SITE_HOSTPATH."picture.php?fID=".$get["pID"];
	
	// generate mail to webmaster of the site.
	$mail  = "A user on your site ".$SITE_TITTLE." has requested that the following images is deleted.\n\n";	
	$mail .= $path."\n\n";
	$mail .= "Explanation:\n";
	$mail .= $_POST["Explanation"]."\n\n";
	$mail .= "Name: ".$_POST["Name"]."\n";
	$mail .= "Email: ".$_POST["Email"]."\n\n";
	$mail .= "If the images is to be removed click om the link and confirm the delete!\n\n";
	// url stuff
	$get["action"] = "requestdeleteaccept";
	unset($get["limit"]);
	unset($get["ParrentID"]);
	unset($get["tID"]);
	unset($get["rotate"]);
	$mail .= url_generate($get, true)."\n\n";
	
	mail($SITE_WEBMASTER, $SITE_TITTLE." - User request for deletion of image from galley", $mail, 
				"From: webmaster@{$_SERVER['SERVER_NAME']}\r\n" .
     		"Reply-To: webmaster@{$_SERVER['SERVER_NAME']}\r\n" .
     		"X-Mailer: PHP/" . phpversion());
}

function gallery_request_delete_accept()
{
	global $db, $Theme, $get, $SITE_HOSTPATH, $SOE_URLS;
	
	// url stuff
	if($SOE_URLS)
		$path = $SITE_HOSTPATH."picture/fID/".$get["pID"];
	else 
		$path = $SITE_HOSTPATH."picture.php?fID=".$get["pID"];
		
	$str  = "<b>Delete image!</b><br><br>\n";
	$str .= "<img src='".$path."' border='0'><br><br>\n";
	$get["action"] = "delete";
	$str .= "Are your shure this image is to bee deleted?&nbsp;<a href='".url_generate($get, true)."'>YES</a>\n";
	
	return $str;
}

function gallery_delete_picture($id)
{
	global $db, $Theme;
	
	// find pic name
	$rs_pic = mysql_query("SELECT DirID, Filename FROM web_gallery_pics WHERE ID='".$id."'", $db);
	$row_pic = mysql_fetch_row($rs_pic);
	if($row_pic[0] != 0)
	{
		$rs_path = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID='".$row_pic[0]."'", $db);
		$row_path = mysql_fetch_row($rs_path);
		$path_p = "files/gallery/".$row_path[0]."/thumbs/p-".$row_pic[1];
		$path_d = "files/gallery/".$row_path[0]."/thumbs/d-".$row_pic[1];
		$path = "files/gallery/".$row_path[0]."/".$row_pic[1];
	}
	else 
	{
		$path = "files/gallery/".$row_pic[1];
		$path_p = "files/gallery/thumbs/p-".$row_pic[1];
		$path_d = "files/gallery/thumbs/d-".$row_pic[1];
	}

	unlink($path);
	unlink($path_p);
	unlink($path_d);
	
	mysql_query("DELETE FROM web_gallery_pics WHERE ID='".$id."'", $db);
}

function gallery_comment($id, $width, $obj_template)
{
	global $db, $Theme, $SITE_NAME, $SITE_WEBMASTER, $ADMIN_NAME, $get, $SOE_URLS;

	// find pic name
	$rs_pic = mysql_query("SELECT DirID, Filename FROM web_gallery_pics WHERE ID='".$get["pID"]."'", $db);
	$row_pic = mysql_fetch_row($rs_pic);
	if($row_pic[0] != 0)
	{
		$rs_path = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID='".$row_pic[0]."'", $db);
		$row_path = mysql_fetch_row($rs_path);
		$path = "files/gallery/".$row_path[0]."/".$row_pic[1];
	}
	else 
	{
		$path = "files/gallery/".$row_pic[1];
	}
	
	// load postcasd template
	$pic_template = Template_load($Theme['Gallery']['CommentsTemplate']);
	
	if(empty($pic_template))
	{
		$pic_template   = '<table cellpadding="0" cellspacing="0" width="90%">';
		$pic_template  .= '	<tr>';
		$pic_template  .= '		<td colspan="4">';
		$pic_template  .= '			<table cellpadding="2" cellspacing="0" width="100%">';
		$pic_template  .= '				<tr><td colspan="2" width="100%">##Picture##</td></tr>';
		$pic_template  .= '				<tr><td colspan="2" width="100%">##CommentList##</td></tr>';
		$pic_template  .= '				<tr><td colspan="2" width="100%">&nbsp;</td></tr>';
		$pic_template  .= '				<tr><td colspan="2" width="100%" class="textBody"><b>##Headline##</b></td></tr>';
		$pic_template  .= '				<tr><td colspan="2" width="100%" style="font-size: 10px"><i>##Comment##</i></td></tr>';
		$pic_template  .= '				<tr><td colspan="2" width="100%" style="font-size: 10px"><i>##Name##</i></td></tr>';
		$pic_template  .= '				<tr><td align="left">##Back##</td><td align="right">##Submit##</td></tr>';
		$pic_template  .= '			</table>';
		$pic_template  .= '		</td>';
		$pic_template  .= '	</tr>';
		$pic_template  .= '</table>';
	}

	// picture
	// url stuff
/*	
	$get["action"] = "show";
	$get["fID"] = $get["pID"];
	$get["type"] = "";	
*/
	if($SOE_URLS)
		$pic_url = "/picture/fID/".$get["pID"];	
	else 
		$pic_url = "picture.php?fID=".$get["fID"];
	$pic_template = str_replace("##Picture##", "<img alt='' src='".$pic_url."' border='0' width='".($width-4)."'>", $pic_template);
	
	// add old comments
	$str = "<table width='100%'>\n";
	
	$sql = "SELECT ID, Comment, Name, DATE_FORMAT(Created, '%d-%m - %Y') FROM web_gallery_comments WHERE PicID='".$id."'";
	if($Theme["Gallery"]["CommentsConfirm"] == "yes" AND empty($_SESSION[$ADMIN_NAME]["user"]["id"]))
		$sql .= " AND Confirmed = 'yes'";
	$sql .= " ORDER BY ID DESC";
	$rs = mysql_query($sql, $db);
	echo mysql_error();
	while($row = mysql_fetch_row($rs))
	{
		$str .= "<tr>\n";
		$str .= "	<td class='textBody' style='text-size: 10px; border-bottom: 1px solid #000000'><b>".$row[3]."</b></td>\n";
		$str .= "	<td class='textBody' style='text-size: 10px; border-bottom: 1px solid #000000' align='right'><b>".Translate("By").":</b>&nbsp;".$row[2]."</td>\n";
		$str .= "</tr>\n";

		if(!empty($_SESSION[$ADMIN_NAME]["user"]["id"]))
		{
			$str .= "<tr>\n";
			$str .= "	<td colspan='2' class='textBody' style='text-size: 10px' align='right'>\n";
			$get["action"] = "commentdelete";
			$get["pID"] = $id;
			$get["cID"] = $row[0];
			$get["limit"] = $limit;
			$str .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimitlink"]."'><font color='#FF0000'>".Translate("Delete")."</font></a>&nbsp;&nbsp;";
			if($Theme["Gallery"]["CommentsConfirm"] == "yes")
			{
				$get["action"] = "commentconfirm";
				$str .= "<a href='".url_generate($get, true)."' class='".$Theme["Gallery"]["ClassLimitlink"]."'><font color='#FF0000'>".Translate("Confirm")."</font></a>";
			}
			$str .= "</tr>\n";
		}

		$str .= "<tr><td class='textBody' colspan='2'>".str_replace("\n", "<br>", $row[1])."</td></tr>";	
		$str .= "<tr><td colspan='2' class='textBody'></td></tr>";
	}
	$str .= "</table>\n";
	$pic_template = str_replace("##CommentList##", $str, $pic_template);
	
	$pic_template = str_replace("##Headline##", Translate("New Comment"), $pic_template);
	
	$str  = Translate("Comment").":<br><textarea rows='5' cols='50' name='Comment' class='feltInput'></textarea>";
	$pic_template = str_replace("##Comment##", $str, $pic_template);
	
	$str  = Translate("Your")."&nbsp;".strtolower(Translate("Name")).":<br><input type='text' size='50' name='Name' class='feltInput'>";
	$pic_template = str_replace("##Name##", $str, $pic_template);

	$str = "<input type='button' onClick='javascript:do_action(\"commentsave\")' class='".$Theme["Submit"]["Class"]."' name='".Translate("Save")."' value='Save'>";
	$pic_template = str_replace("##Submit##", $str, $pic_template);

	$str = "<input type='button' onClick='javascript:do_action(\"commentback\")' class='".$Theme["Submit"]["Class"]."' name='".Translate("Back")."' value='Back'>";
	$pic_template = str_replace("##Back##", $str, $pic_template);

	url_set();
	$body  = "<form action='".url_generate($get, true)."' method='post' name='frmComment'>\n";
	$body .= "<input type='hidden' name='action'>\n";
	$body .= "<script>\n";
	$body .= " function do_action(action)\n";
	$body .= " {\n";
	$body .= "		document.frmComment.action.value = action;\n";
	$body .= "		document.frmComment.submit();\n";
	$body .= "	}\n";
	$body .=  "</script>\n";
	$body .= $pic_template;
	$body .= "</form>\n";
	
	// load template
	$template = Template_load($obj_template);

	$template = str_replace("##Body##", $body, $template);
	$template = str_replace("##Width##", $width, $template);
	$template = str_replace("##Headline1##", Translate("Comment"), $template);
	$template = str_replace("##Headline2##", "&nbsp;", $template);
		
	$str = $template;
	
	return $str;
}

function gallery_comment_save($id)
{
	global $db, $Theme, $SITE_WEBMASTER, $SITE_TITTLE, $get, $SITE_PATH, $SITE_HOSTPATH;
	
	// if the comment is not empty
	if(!empty($_POST["Comment"]))
	{
		// insert into mysql
		mysql_query("INSERT INTO web_gallery_comments (PicID, Comment, Name, Created, Confirmed) VALUES('".$id."', '".$_POST["Comment"]."', '".$_POST["Name"]."', now(), '".strtolower($Theme["Gallery"]["CommentsConfirm"])."')", $db);
		echo mysql_error();
		$cid = mysql_insert_id();
		
		if(strtolower($Theme["Gallery"]["CommentsConfirm"]) == "yes")
		{
/*			
			$urlpath_arr = explode("/", $_SERVER['PHP_SELF']);
			for($x = 0; $x < (count($urlpath_arr) - 1); $x++)
				$url .= $urlpath_arr[$x]."/";
			if(count($urlpath_arr) == 0)
				$url = "/";
*/				
			// generate mail to webmaster of the site.
			$mail  = "A user on your site ".$SITE_TITTLE." has added a comment.\n\n";	
			$mail .= "Comment:\n";
			$mail .= $_POST["Comment"]."\n\n";
			$mail .= "Name:\n";
			$mail .= $_POST["Name"]."\n\n";
			// url stuff 
			$g["action"] = "comment";
			$g["pID"] = $id;
			$mail .= url_generate($g, true)."\n\n";
			$mail .= "If the comment is OK click om the link to CONFIRM!\n\n";
			$g["action"] = "commentconfirm";
			$g["cID"] = $cid;
			$mail .= url_generate($g, true)."\n\n";
			$mail .= "If the comment is to be removed click om the link to DELETE!\n\n";
			$g["action"] = "commentdelete";
			$mail .= url_generate($g, true)."\n\n";
			
			mail($SITE_WEBMASTER, $SITE_TITTLE." - User comment in galley", $mail, 
						"From: webmaster@{$_SERVER['SERVER_NAME']}\r\n" .
		     		"Reply-To: webmaster@{$_SERVER['SERVER_NAME']}\r\n" .
		     		"X-Mailer: PHP/" . phpversion());
		}
	}
}

function gallery_comment_confirm($id)
{
	global $db, $Theme;
	
	mysql_query("UPDATE web_gallery_comments SET Confirmed = 'yes' WHERE ID = '".$id."'", $db);
	echo mysql_error();
}

function gallery_comment_delete($id)
{
	global $db, $Theme;
	
	mysql_query("DELETE FROM web_gallery_comments WHERE ID = '".$id."'", $db);
	echo mysql_error();
}


function gallery_actions($obj_template, $options, $width, $plugin_id, $version)
{
	global $db, $Theme, $ADMIN_NAME, $get, $SOE_URLS;

	if(!is_dir("files"))
		mkdir("files");
	
	switch ($get["action"])
	{
		case "show":
#			gallery_show_image($get["fID"], $get["type"]);
			if($SOE_URLS)
				header("Location: picture/fID/".$get["fID"]."/type/".$get["type"]);
			else 
				header("Location: picture.php?fID=".$get["fID"]."&type=".$get["type"]);
			break;
		
		case "comment":
			$str = gallery_comment($get["pID"], $width, $obj_template);
			break;

		case "commentconfirm":
			gallery_comment_confirm($get["pID"]);
			$get["action"] = "comment";
			$str = "<script>document.location.href='".url_generate($get, true)."';</script>\n";
			break;

			
		case "commentdelete":
			gallery_comment_delete($get["cID"]);
			$get["action"] = "comment";
			$str = "<script>document.location.href='".url_generate($get, true)."';</script>\n";
			break;
		
		case "postcard":
			$str = gallery_postcard($get["pID"], $width, $obj_template);
			break;
			
		case "requestdelete":
			$str = gallery_request_delete($get["pID"], $get["ParrentID"], $obj_template, $width);
			break;
			
		case "requestdeleteaccept":
			$str = gallery_request_delete_accept();
			break;
			
		case "delete":
			if(!empty($_SESSION[$ADMIN_NAME]["user"]["id"]))
				gallery_delete_picture($get["pID"]);
			$str = gallery_list($obj_template, $options, $width, $plugin_id, $version);
			break;

		case "rotate":		
			if(!empty($_SESSION[$ADMIN_NAME]["user"]["id"]))
			{
				$rs_file = mysql_query("SELECT Filename, DirID FROM web_gallery_pics WHERE ID='".$get["pID"]."'", $db);
				$row_file = mysql_fetch_row($rs_file);
				if($row_file[1] != 0)
				{
					$rs_dir = mysql_query("SELECT Path FROM web_gallery_dirs WHERE ID='".$row_file[1]."'", $db);
					$row_dir = mysql_fetch_row($rs_dir);
				}
				gallery_rotate_image("files/gallery/".$row_dir[0], $row_file[0], 90, $get["rotate"]);
			}
			$get["action"] = "";
	  	$str = "<script>document.location.href='".url_generate($get, true)."';</script>\n";
			break;

		default:						
			$str = gallery_list($obj_template, $options, $width, $plugin_id, $version);
			break;
	}
		
	switch ($_POST["action"])
	{
		case "commentsave":
			gallery_comment_save($get["pID"]);
			$get["action"] = "comment";
			$str = "<script>document.location.href='".url_generate($get, true)."';</script>\n";
			break;
			
		case "postcardback":
		case "requestdeleteback":
		case "commentback":
			$str = gallery_list($obj_template, $options, $width, $plugin_id, $version);
			break;		

		case "postcardsend":
			gallery_postcard_send($get["pID"]);
			$get["action"] = "";
			$str = "<script>document.location.href='".url_generate($get, true)."';</script>\n";
			break;

		case "requestdeletesend":
			gallery_request_delete_send();
			$get["action"] = "";
			$str = "<script>document.location.href='".url_generate($get, true)."';</script>\n";
			break;	
	}
	
	return $str;
}



?>